PROGRAM FV_CD_2D
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!Program to solve N-S equation using cell-center finite volume method.
!
!
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  IMPLICIT NONE
  INTEGER,PARAMETER :: DP = SELECTED_REAL_KIND(p=15)
  REAL(KIND=DP),PARAMETER                  :: PI = 3.141592653589793_DP

  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: X , Y ,  X1 , Y1 , Z , S , RHS
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: U , U_old , U_temp , U_old2
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: V , V_old , V_temp , V_old2
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: W , W_old , W_temp , W_old2
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: P , P_old , P_temp 
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: Us , Vs , Ws , PP_C , P_C
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: Uc , Vc , Wc , Uc_old , Vc_old  , Wc_old, Uc_old2 , Vc_old2 , Wc_old2
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: DIV , PP , P_X , P_Y , P_Z , PP_X , PP_Y , PP_Z
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: U_X , U_Y , V_X , V_Y 
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: Fu , Fv , Fw  !, Kappa , PHI_X , PHI_Y  , PHI_Z 
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: K_X , K_Y  , K_Z , C_X , C_Y , C_Z
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: PHI , PHI_old , PHI_temp 
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: RHO , MU , HE , HP , RHO_cx , RHO_cy , RHO_cZ , HP2
 ! REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: TEST1 , HEAVY_MAT
  
  
  REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:,:) :: C_1  , C_2  , C_1_TEMP  , C_2_TEMP  ,   W_MIX_1  ,  W_MIX_2  , C_T
  

  REAL(KIND=DP) :: Xstart , Xend , Ystart , Yend , Zstart , Zend , Total_FV , CFL
  REAL(KIND=DP) :: Dx , Dy  , DZ , Dt , Re , DIV_cell , DIV_node , Tol 
  REAL(KIND=DP) :: L2NORM_U , L2NORM_V , L2NORM_W , L2NORM_P , DDt  
  REAL(KIND=DP) :: L2_U , L2_V , L2_W , L2_P  , MASS , AREA  , MASS_OLD , AREA_OLD 
  REAL(KIND=DP) :: DE_VSOLD
  
  
  
  REAL(KIND=DP)                            :: Ts , Te 
  
  
  REAL(KIND=DP)                            ::   W_1S ,W_2S
  
  
  REAL(KIND=DP) :: XL , YL , ZL , AREA_TOTAL  , RHO_GL , MU_GL , We ,Fr  , SS ,MO_p
  
  
  INTEGER :: I , J ,  K , Nx , Ny , NZ , Node_X , Node_Y , Node_Z   , IMASS ,    start1     !¼ start1
  INTEGER :: Ierr , Iter , T_Iter , I_Iter , Run_counter , TIMESTOP , NON_T, timestep
 
  INTEGER ::  heavy_node
  
  
  
  REAL(KIND=DP) :: D_0 , MU_L , MU_G , RHO_G , ANG_C , ANGC , PARA1 , PARA2 , T , RRR
  REAL(KIND=DP) :: Delx , Delz, ST, v_i, ANGA_C, ANGR_C, ANGRC, ANGAC
        
 
 
   REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:) :: AU_X1 , BU_X1 , AAU_X1 , BBU_X1
   REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:) :: AD_X1 , BD_X1 , AAD_X1 , BBD_X1
   REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:) :: AU_Y1 , BU_Y1 , AAU_Y1 , BBU_Y1
   REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:) :: AD_Y1 , BD_Y1 , AAD_Y1 , BBD_Y1
   REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:) :: AU_Z1 , BU_Z1 , AAU_Z1 , BBU_Z1
   REAL(KIND=DP),ALLOCATABLE,DIMENSION(:,:) :: AD_Z1 , BD_Z1 , AAD_Z1 , BBD_Z1
 
 
     
     
     REAL(KIND=DP),ALLOCATABLE,DIMENSION(:)   ::  C_F  !, CP                     ! ӱ  
     REAL(KIND=DP) :: dx1,dy1 ,dz1,x_c1,y_c1,h_c1   ,t_h1, t_h2, t_h3, xr_x1       !,uus,vvs,wws   ,t_hʾͻ,xr_x1ʽͻ뾶
     REAL(KIND=DP) :: m_s1,m_s2,m_st ,dv,dA_ZY,DA_XY,A_X            ! ӱ
     REAL(KIND=DP) :: M_D1,M_D2,M_DT ,M_D11,M_D22,M_DT1 ,M_D111,M_D222,M_DT11 
     REAL(KIND=DP) :: SUM_CW1, SUM_CW2,SUM_CW11, SUM_CW22,SUM_CW111, SUM_CW222,m0_s1,m0_s2,m0_st                                   ! ӱ
     REAL(KIND=DP) :: EK_CON,EP_CON,ES_CON,EST_CON,ESTT_CON,ESUM_CWT,ESUM_CW1,ESUM_CW2,ED_U,ED_V,ED_W,T_H11,E0,e0_1,ED_UVW , ed_uvw1
     REAL(KIND=DP) :: EDT_UVW, EDTT_UVW,ESUMT_CWT,ESUMTT_CWT ,MT_S1,MTT_S1 ,MT_S2,MTT_S2,MT_ST,MTT_ST ,ET_0!! ӱ
   
   
 
   WRITE(*,*) "INPUT NODE_X ,   NODE_Y  ,  NODE_Z :"
   READ (*,*) Node_X ,  Node_Y , Node_Z	

   
   ! Node_X = 130	
   ! Node_y = 130
   ! Node_z = 65
   
   
    Nx = Node_X + 2
    Ny = Node_Y + 2
    Nz = Node_z + 2
  
  !  Total_FV = REAL(Node_X * Node_Y ,DP)
    Tol = 1.0E-4_DP
  	 
    Xstart =  0.0_DP
    Xend   =  10.0_DP
   
    Ystart =  0.0_DP
    Yend   =  2.0_DP  
    
    Zstart = 0.0_DP
    Zend   = 2.0_DP   



  !   Xstart = -1.25_DP / 2.0_DP  
  !   Xend   =  1.25_DP   / 2.0_DP
  !                 
  !   Ystart =  0.0_DP   / 2.0_DP
  !   Yend   =  3.75_DP   / 2.0_DP 
  
     
      Re    = 3000
      Fr = 1.0_Dp        
      WE    = 16.0_DP  
    
    
      w_1S = 0.02_DP
      w_2S = 0.0_DP 
    
      RHO_GL = 1.0_DP 
      MU_GL  = 1.0_DP
      
    !  RHO_GL = 1.0_DP / 1000.0_dp    
    !  MU_GL  = 1.0_DP / 100.0_dp

	
	!!!CASE 1
	
	  !   DE_VSOLD = 0.0_DP
	  !
	  !
	  !   timestep = 150
	  !
	  !   ST = 0.07423_DP   
	  !   RHO_G = 1.138_DP
	  !   MU_L = 0.001308_DP
	  !   MU_G = 1.91034127e-5_DP
	  !   
	  !   D_0 = 20.0e-6_DP
	  !   V_I = 50.0_DP
	      ANG_C = 170.0_DP
	  !   ANGA_C = 180.0_dp
	  !   ANGR_C = 160.0_dp
	  !   
	  !   
	  !   WE = 1000.0_DP*V_I**2*D_0 / ST
	  !   RE = 1000.0_DP*V_I*D_0 / MU_L
	  !   FR = V_I / SQRT(9.8_DP*D_0)
	  !   !FR = ( WE * 0.072_DP / ( RE * MU_L) )  / SQRT(9.8_DP * D_0 )
	  !   
	  !   MO_p = 0.0_dp !9.81_DP/ V_I**2
	  !   
	  !
	  !  !  MU_L = SQRT(1000.0_DP * D_0 * WE * 0.072_DP / RE**2 )           ! EQ (21)       
    !  !  T = 140.0_DP + 247.8_DP / LOG10( MU_L / 0.00002414_DP )                 
    !  !  MU_G = 0.000001512041288_DP * T**(3.0_DP/2.0_DP) / ( T + 120.0_DP ) 
    !  !  RHO_G = 1.1455_DP * (273.15_DP + 35.0_DP ) / T   
    !
    !
    !  
       ANGC = ANG_C * PI / 180.0_DP
    !  ANGRC = ANGR_C * PI /180.0_DP
    !  ANGAC = ANGA_C * PI /180.0_DP
    !  RRR = ( 4.0_dp * 0.25_DP**3 / ( 2.0_DP*( 1.0_DP - COS(ANGC)) + COS(ANGC-0.5_DP*PI )**2*SIN(ANGC-0.5_DP*PI) ))**(1.0_DP/3.0_DP)
    !
    !  
    !   
	  !	RHO_GL = RHO_G / 1000.0_DP 
    !  MU_GL  = MU_G / MU_L 
    
    
     
    
    
    Dx = (Xend - Xstart) / REAL(Node_X , KIND=DP)
    Dy = (Yend - Ystart) / REAL(Node_Y , KIND=DP)
    DZ = (Zend - Zstart) / REAL(Node_Z , KIND=DP)


    DT = 0.01_DP*DX 
    
  
   ! TIMESTOP   =   ANINT( 4.0_DP / DT  )
    TIMESTOP   =   ANINT( 12.0_DP / DT  )
    WRITE(*,*) "TOTAL TIME STEP" , TIMESTOP
  

    !WRITE(*,*) "Select for steady-state or real-transient case"
    !WRITE(*,*) "(1)steady-state"
    !WRITE(*,*) "(2)real-transient"
    !READ (*,*) Run_counter
    
    RUN_COUNTER = 1
    I_Iter = 1
!     IF(Run_counter == 1) THEN
 !     	I_Iter = 1
!      ELSE IF(Run_counter == 2) THEN
!         I_Iter = 1
!      ELSE
 !       WRITE(*,*) "ERROR! the case must be 1 or 2"
!        STOP
!      END IF

    ALLOCATE( X(Nx,Ny,NZ) , Y(Nx,Ny,NZ) , X1(Nx,Ny,NZ) , Y1(Nx,Ny,NZ)  , Z(Nx,Ny,NZ)   , STAT=Ierr)
    IF(Ierr /= 0) STOP 'ALLOCATE X Y ERROR!'

    X(1 ,:,:) = Xstart
    X(Nx,:,:) = Xend
   
    Y(: ,1 ,:) = Ystart
    Y(: ,Ny,:) = Yend
    
    Z(: ,: ,1) = Zstart
    Z(: ,:, NZ) = Zend
   
    DO I = 2 , Nx - 1
      X(I,:,:) = Xstart + ( REAL(I-1,DP) - 0.5_DP) * Dx
    END DO
   
    DO J = 2 , Ny - 1
      Y(:,J,:) = Ystart + ( REAL(J-1,DP) - 0.5_DP) * Dy
    END DO
    
    DO K = 2 , NZ - 1
      Z(:,:,K) = Zstart + ( REAL(K-1,DP) - 0.5_DP) * DZ
    END DO

     ALLOCATE( U(Nx,Ny,NZ) , U_old(Nx,Ny,NZ) , Fu(Nx,Ny,NZ) , Fv(Nx,Ny,NZ)  , Fw(Nx,Ny,NZ), STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE U Ext S ERROR!'
    
     ALLOCATE( V(Nx,Ny,NZ) , V_old(Nx,Ny,NZ) , PP_X(Nx,Ny,NZ) , PP_Y(Nx,Ny,NZ)  , PP_Z(Nx,Ny,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE U Ext S ERROR!'
     
     ALLOCATE( W(Nx,Ny,NZ) , W_old(Nx,Ny,NZ)  , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE U Ext S ERROR!'
    
     ALLOCATE( U_temp(Nx,Ny,NZ) , V_temp(Nx,Ny,NZ)  , W_temp(Nx,Ny,NZ) , P_temp(Nx,Ny,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE U Ext S ERROR!'
    
     ALLOCATE( P(Nx,Ny,NZ) , P_old(Nx,Ny,NZ) , PP_C(Nx,Ny,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE U Ext S ERROR!'
    
    ! ALLOCATE( PHI_X(Nx,Ny,NZ) , PHI_Y(Nx,Ny,NZ)  , PHI_Z(Nx,Ny,NZ), Kappa(Nx,Ny,NZ)  , STAT=Ierr)
    ! IF(Ierr /= 0) STOP 'ALLOCATE U Ext S ERROR!'
     ALLOCATE( C_F(nx))
    
     ALLOCATE( PP(Nx,Ny,NZ) , P_X(Nx,Ny,NZ) , P_Y(Nx,Ny,NZ)  , P_Z(Nx,Ny,NZ) , DIV(Nx,Ny,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE U Ext S ERROR!'
    
     ALLOCATE( S(Nx,Ny,NZ) , C_X(Nx,Ny,NZ) , C_Y(Nx,Ny,NZ) , C_Z(Nx,Ny,NZ) , RHS(Nx,Ny,NZ), STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE U Ext S ERROR!'
    
     ALLOCATE( K_X(Nx,Ny,NZ) , K_Y(Nx,Ny,NZ)  , K_Z(Nx,Ny,NZ), P_C(Nx,Ny,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE U Ext S ERROR!'
    
     ALLOCATE( Us(Nx,Ny,NZ) , Vs(Nx,Ny,NZ)  , Ws(Nx,Ny,NZ)  , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE cell face value ERROR!'
    
     ALLOCATE( Uc(Nx,Ny,NZ) , Vc(Nx,Ny,NZ)  , Wc(Nx,Ny,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE cell face value ERROR!'
    
     ALLOCATE( Uc_old(Nx,Ny,NZ) , Vc_old(Nx,Ny,NZ)  , Wc_old(Nx,Ny,NZ), STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE cell face value ERROR!'
    
     ALLOCATE( Uc_old2(Nx,Ny,NZ) , Vc_old2(Nx,Ny,NZ) , Wc_old2(Nx,Ny,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE cell face value ERROR!'
    
     ALLOCATE( U_old2(Nx,Ny,NZ) , V_old2(Nx,Ny,NZ) , W_old2(Nx,Ny,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE cell face value ERROR!'
    
     ALLOCATE( PHI(Nx,Ny,NZ) ,RHO(Nx,Ny,NZ) , MU(Nx,Ny,NZ) ,HE(Nx,Ny,NZ) , HP(Nx,Ny,NZ) , HP2(Nx,Ny,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE cell face value ERROR!'
    
     ALLOCATE( RHO_cx(Nx,Ny,NZ) , RHO_cy(Nx,Ny,NZ) , RHO_cZ(Nx,Ny,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE cell face value ERROR!'
    
     ALLOCATE( PHI_old(Nx,Ny,NZ) , PHI_temp(Nx,Ny,NZ)  ,  STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE PHI value ERROR!'
     
     ALLOCATE( U_X(Nx,Ny,NZ) , U_Y(Nx,Ny,NZ) , V_X(Nx,Ny,NZ) , V_Y(Nx,Ny,NZ) ,  STAT=Ierr)
     IF(Ierr /= 0) STOP 'ALLOCATE PHI value ERROR!'
     
    ! ALLOCATE( TEST1(Nx,Ny,NZ) , HEAVY_MAT(Nx,Ny,NZ) ,   STAT=Ierr)
    ! IF(Ierr /= 0) STOP 'ALLOCATE PHI value ERROR!'
     
     
     ALLOCATE( C_1(Nx,Ny,NZ)  ,  C_2(Nx,Ny,NZ)  , C_1_TEMP(Nx,Ny,NZ)  ,  C_2_TEMP(Nx,Ny,NZ)  ,  W_MIX_1(Nx,Ny,NZ)  ,  W_MIX_2(Nx,Ny,NZ) ,  C_T(Nx,Ny,NZ)   , STAT=Ierr)
    IF(Ierr /= 0) STOP 'ALLOCATE PHI value ERROR!'
     
     
     
     
     !For CCD BLOCK SOLVER ,  LEVEL SET
     ALLOCATE(AU_X1(3,Nx) , BU_X1(3,Nx) , AAU_X1(3,Nx) , BBU_X1(3,Nx) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ERROR!!! AU_X'
    
     ALLOCATE(AD_X1(3,Nx) , BD_X1(3,Nx) , AAD_X1(3,Nx) , BBD_X1(3,Nx) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ERROR!!! AD_X'
    
     ALLOCATE(AU_Y1(3,Ny) , BU_Y1(3,Ny) , AAU_Y1(3,Ny) , BBU_Y1(3,Ny) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ERROR!!! AU_Y'
    
     ALLOCATE(AD_Y1(3,Ny) , BD_Y1(3,Ny) , AAD_Y1(3,Ny) , BBD_Y1(3,Ny) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ERROR!!! AD_Y'
     
     ALLOCATE(AU_Z1(3,NZ) , BU_Z1(3,NZ) , AAU_Z1(3,NZ) , BBU_Z1(3,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ERROR!!! AU_Z'
    
     ALLOCATE(AD_Z1(3,NZ) , BD_Z1(3,NZ) , AAD_Z1(3,NZ) , BBD_Z1(3,NZ) , STAT=Ierr)
     IF(Ierr /= 0) STOP 'ERROR!!! AD_ZY'
     
     
    !  CALL ASSIGN_CCD_UD_TWIN_2(Nx , Dx , AU_X1 , BU_X1 , AAU_X1 , BBU_X1 &
    !                       &        , AD_X1 , BD_X1 , AAD_X1 , BBD_X1 )
    !  CALL ASSIGN_CCD_UD_TWIN_2(Ny , Dy , AU_Y1 , BU_Y1 , AAU_Y1 , BBU_Y1 &
    !                       &        , AD_Y1 , BD_Y1 , AAD_Y1 , BBD_Y1 )
    !  CALL ASSIGN_CCD_UD_TWIN_2(NZ , DZ , AU_Z1 , BU_Z1 , AAU_Z1 , BBU_Z1 &
    !                       &        , AD_Z1 , BD_Z1 , AAD_Z1 , BBD_Z1 )  
                           
     
    !  CALL TWIN_DEC_1( AU_X1, BU_X1, AAU_X1, BBU_X1 )
    !  CALL TWIN_DEC_1( AU_Y1, BU_Y1, AAU_Y1, BBU_Y1 )
    !  CALL TWIN_DEC_1( AU_Z1, BU_Z1, AAU_Z1, BBU_Z1 )
    ! 
    !  CALL TWIN_DEC_1( AD_X1, BD_X1, AAD_X1, BBD_X1 )
    !  CALL TWIN_DEC_1( AD_Y1, BD_Y1, AAD_Y1, BBD_Y1 )
    !  CALL TWIN_DEC_1( AD_Z1, BD_Z1, AAD_Z1, BBD_Z1 ) 
     
                           
      CALL ASSIGN_CCD_UD_TWIN(Nx , Dx , AU_X1 , BU_X1 , AAU_X1 , BBU_X1 &
                           &        , AD_X1 , BD_X1 , AAD_X1 , BBD_X1 )
      CALL ASSIGN_CCD_UD_TWIN(Ny , Dy , AU_Y1 , BU_Y1 , AAU_Y1 , BBU_Y1 &
                           &        , AD_Y1 , BD_Y1 , AAD_Y1 , BBD_Y1 )
      CALL ASSIGN_CCD_UD_TWIN(NZ , DZ , AU_Z1 , BU_Z1 , AAU_Z1 , BBU_Z1 &
                           &        , AD_Z1 , BD_Z1 , AAD_Z1 , BBD_Z1 )                                           
                           
     
      CALL TWIN_DEC( AU_X1, BU_X1, AAU_X1, BBU_X1 )
      CALL TWIN_DEC( AU_Y1, BU_Y1, AAU_Y1, BBU_Y1 )
      CALL TWIN_DEC( AU_Z1, BU_Z1, AAU_Z1, BBU_Z1 )
     
      CALL TWIN_DEC( AD_X1, BD_X1, AAD_X1, BBD_X1 )
      CALL TWIN_DEC( AD_Y1, BD_Y1, AAD_Y1, BBD_Y1 )
      CALL TWIN_DEC( AD_Z1, BD_Z1, AAD_Z1, BBD_Z1 ) 

      
   !!!!12012090 raduius = 0.3   
    !     DO K = 1 , NZ
	  !     DO J = 1 , NY
    !     DO I = 1 , NX
    !     	!!!!
    !       IF(  ((X(I,J,K)+ RRR)**2 + (Y(I,J,K))**2  + (Z(I,J,K)- RRR*SIN(ANGC-0.5_DP*PI) )**2) <= RRR**2 ) THEN 
    !       	
    !            PHI(I,J,K) = 1.0_DP    
    !              
    !       ELSEIF (  (  (X(I,J,K) - RRR )**2 + (Y(I,J,K))**2  + (Z(I,J,K)- RRR*SIN(ANGC-0.5_DP*PI) )**2 ) <= RRR**2  ) THEN
    !            PHI(I,J,K) = 1.0_DP      
    !       ELSE
    !          	 PHI(I,J,K) = -1.0_DP
    !       END IF
    !       
    !       
    !       
    !   !    
    !   !    IF ( ( X(I,J,K)  +   0.25_dp  )**2 + ( Y(I,J,K)   )**2 + ( Z(I,J,K)-0.25_DP)**2 <= 0.25_DP**2 ) THEN
 	  !   !  	 
 	  !   !  	  PHI(I,J,K) = 1.0_DP
 	  !   !  	  
 	  !   !  
 	  !   !    ELSEIF(  ( X(I,J,K) - 0.25_DP)**2 +  ( Y(I,J,K)  )**2 + ( Z(I,J,K)-0.25_DP)**2 <= 0.25_DP**2 ) THEN
 	  !   !	  
 	  !   !  	  PHI(I,J,K) = 1.0_DP
    !   !  
  	!   !	   
  	!   !    ELSE 
  	!   !    		    	   
  	!   !	     PHI(I,J,K) = -1.0_DP
    !   !         	         	
    !   !    END IF
    !   !    
    !     END DO
    !     END DO
    !     END DO
        
            
  !    DO k = 1 , NZ      
  !    DO J = 1 , NY
  !    DO I = 1 , NX
  !    	
  !          IF ( ( X(I,J,K)  -   2.0_dp  )**2 + ( Y(I,J,K) -   2.0_dp   )**2 + ( Z(I,J,K)-2.15_DP)**2 <= 0.5_DP**2 ) THEN
 	!        	 
 	!        	  PHI(I,J,K) = -1.0_DP
 	!        	  
 	!        
 	!          ELSEIF(  ( X(I,J,K)  -   2.5_dp  )**2 + ( Y(I,J,K) -   2.0_dp   )**2 + ( Z(I,J,K)-1.0_DP)**2 <= 0.5_DP**2 ) THEN
 	!      	  
 	!        	  PHI(I,J,K) = -1.0_DP
  !        
  !	    	   
  !	        ELSE 
  !	        		    	   
  !	    	     PHI(I,J,K) = 1.0_DP
  !               	         	
  !          END IF
  !      
  !    END DO
  !    END DO
  !    END DO   	
      
      
      DO k = 1 , NZ      
      DO J = 1 , NY
      DO I = 1 , NX
      	
         !   IF ( ( X(I,J,K)  -   2.0_dp  )**2 + ( Y(I,J,K) -   2.0_dp   )**2 + ( Z(I,J,K)-2.5_DP)**2 <= 0.5_DP**2 ) THEN
 	       ! 	 
 	       ! 	  PHI(I,J,K) = -1.0_DP
 	       ! 	  
 	       ! 
 	       !   ELSEIF(  ( X(I,J,K)  -   2.85_dp  )**2 + ( Y(I,J,K) -   2.0_dp   )**2 + ( Z(I,J,K)-1.0_DP)**2 <= 0.5_DP**2 ) THEN
 	       !   
 	       ! 	  PHI(I,J,K) = -1.0_DP
         ! 
  	     !    
  	     !   ELSE 
  	     !   		    	   
  	     !      PHI(I,J,K) = 1.0_DP
         !        	         	
         !   END IF
            
 !ʼ           
          IF (  X(I,J,K) <= 1.0_DP.AND. Y(I,J,K) <= 2.0_DP .AND.Z(I,J,K) <= 2.0_DP ) THEN
             PHI(I,J,K) = 1.0_DP
          ELSE
          	 PHI(I,J,K) = -1.0_DP
          ENDIF	
            
            
             
            
        
      END DO
      END DO
      END DO   	
            
      
      DV=DX*DY*DZ
      
        
	      WRITE(*,*) "===================================================="
        WRITE(*,*) "3 D - CALL TEC_LS_Vec_2D(0 , Nx , Ny , X , Y , U , V , PHI , PHI , PHI) "
        WRITE(*,*) "===================================================="
       ! CALL TEC_ITER_NESQ_Vec_3D(0  , Nx , NY , NZ , X , Y , Z , PHI , PHI , PHI , PHI)
        CALL TEC_ITER_NESQ_Vec_3D(0  , Nx , NY , NZ , X , Y , Z , RHO , MU , PHI , PHI)
  
	     
	     
        XL = Xend - Xstart
        YL = Yend - Ystart
        ZL = Zend - Zstart
     
        CALL LEVEL_SET_INITIALIZE_3D(NX , NY , NZ , PHI , XL , YL , ZL , DX , DY , DZ)
      
        
        WRITE(*,*) "OK1"
  
       
       
       
      !   MASS_OLD = 0.0_DP
      !   DO K=2,NZ-1
      !   DO J=2,NY-1
      !   DO I=2,NX-1
      !     MASS_OLD = MASS_OLD + heavy(PHI(i,j,K),dx,hp(I,J,K))
      !   ENDDO
      !   ENDDO
      !   ENDDO
         
      
      
        
    !  OPEN(UNIT=13,FILE='mass.plt')
    !  OPEN(UNIT=14,FILE='AREA.plt')
      
    
    !  WRITE(13,*) 0 , MASS_OLD / MASS_OLD  ,  ( MASS_old - MASS_OLD ) / MASS_OLD
    !  WRITE(14,*) 0 , AREA_OLD / AREA_OLD  ,   ( AREA_OLD - AREA_OLD ) / AREA_OLD
  
      CALL RHO_Mu_compute(NX , NY , NZ , Dx , PHI , RHO , MU , RHO_GL , MU_GL , He , Hp)
      
         K_X = 1.0_DP / Re
         K_Y = 1.0_DP / Re  
         K_z = 1.0_DP / Re  
      
      
      DO K = 1 , NZ
      DO J = 1 , NY
      DO I = 1 , NX
       
   
          C_T(I,J,K) =  HE(I,J,K)
          C_1(I,J,K) =  C_T(I,J,K) !/ 2.0_DP  
        !  C_2(I,J,K) =  C_T(I,J,K) / 2.0_DP  
            
            
 
     END DO  
     END DO
     END DO
      
   
     !  PHI_old = PHI
     
       U = 0.0_DP
       V = 0.0_DP
       W = 0.0_DP
       P = 0.0_DP
       
     !  DO K = 1 , NZ 
     !  DO J = 1 , NY
     !  DO I = 1 , NX
     !  	
     !   IF(  (  (X(I,J,K)+ RRR )**2 + (Y(I,J,K))**2  + (Z(I,J,K)- RRR*SIN(ANGC-0.5_DP*PI) )**2 )<= RRR**2 ) THEN      
     !        U(I,J,K) = 1.0E-10_DP                                                                                        
     !                                                                                                                   
     !   ELSEIF (  (  (X(I,J,K) - RRR )**2 + (Y(I,J,K))**2  + (Z(I,J,K)- RRR*SIN(ANGC-0.5_DP*PI) )**2 ) <= RRR**2  ) THEN
     !        U(I,J,K) = -1.0E-10_DP  
     !                                                                                              
     !   END IF
     !   	                                                                                                         
     !  END DO
     !  END DO
     !  END DO
     
     
   !   DO k = 1 , NZ      
   !   DO J = 1 , NY
   !   DO I = 1 , NX
   !     IF(  (  ( X(I,J,K)-0.0_dp )**2 + (Y(I,J,K)-0.0_DP )**2 + (Z(I,J,K)-0.55_DP )**2 ) <= 0.5_DP**2 ) THEN 
   !         W(I,J,K) =  -0.5_DP    
   !      ELSEIF(  (  ( X(I,J,K)-0.0_dp )**2 + (Y(I,J,K)-0.0_DP )**2 + (Z(I,J,K) + 0.55_DP)**2 ) <= 0.5_DP**2 ) THEN     
   !      	  W(I,J,K) =  0.5_DP 
   !      ELSE
   !        	W(I,J,K) = 0.0_DP
   !     END IF
   !     
   !   END DO
   !   END DO
   !   END DO   	
     
     
      
      WRITE(*,*) "===================================================="
      WRITE(*,*) "INITIAL FINISH" 
      WRITE(*,*) "CALL TEC_LS_Vec_2D(0 , Nx , Ny , X , Y , U , V , P , c_t , c_t) "
      WRITE(*,*) "===================================================="
    
      CALL TEC_ITER_NESQ_Vec_3D(0  , Nx , NY , NZ , X , Y , Z , u , v , w , c_t)

         
     
      U_old = U
      V_old = V
      W_old = W
      P_old = P
    
      U_old2 = U_old
      V_old2 = V_old
      W_old2 = W_old
    
      P_X  = 0.0_DP
      P_Y  = 0.0_DP
      P_Z  = 0.0_DP
      
      P    = 0.0_DP
      P_C  = 0.0_DP
      PP   = 0.0_DP
      PP_C = 0.0_DP
   
 
       C_X = U_old
       C_Y = V_old
       C_Z = W_old
         
       Fu = 0.0_DP
       Fv = 0.0_DP
       FW = 0.0_DP
      
       CALL Cell_face_velocity_FV_3D(Nx , Ny , NZ , C_X , C_Y  , C_Z , Uc , Vc , Wc)
      
       Uc_old = Uc
       Vc_old = Vc
       Wc_old = Wc
       
      
       Uc_old2 = Uc_old
       Vc_old2 = Vc_old
       Wc_old2 = Wc_old
      
       !Solving N-S
       CALL CPU_TIME(Ts)
       
      
       
       
       
       
 T_Iter = 0
       
   
       DA_ZY=DY*DZ
       DA_xY=DY*Dx
       a_x=yend *zend  
       e0_1=0.0_dp
       EST_CON=0.0_DP
       EDT_UVW=0.0_DP
       ESUMT_CWT=0.0_DP
       mt_s1=0.0_dp
       mt_s2=0.0_dp
       mt_st=0.0_dp
       
       !ʼʱ̵
  !   e0=dx*dy*dz *sum(z*c_t)  
       
!
  
    do k=2,nz-1
    do j=2,ny-1
    do i=2,nx-1
    	 e0_1=e0_1+z(i,j,k)*c_1(i,j,k)
    	end do
    	end do
    	end do           	
    e0=e0_1*dv  !  2*3*1*ƽ߶ȣ0.5*Ũֵ1.0


       
       
       
 
! OPEN( 900, FILE='CON-force_3D.plt', STATUS= 'UNKNOWN' ) 
! OPEN( 901, FILE='c1-2-t_3D.plt', STATUS= 'UNKNOWN' )
 OPEN( 902, FILE='suspension_12t_3D.plt', STATUS= 'UNKNOWN' )
 OPEN( 903, FILE='front_time_3D.plt', STATUS= 'UNKNOWN' )
! OPEN( 904, FILE='sediment1_12t_3D.plt', STATUS= 'UNKNOWN' ) 
! OPEN( 9041, FILE='sediment2_12t_3D.plt', STATUS= 'UNKNOWN' )
! OPEN( 9042, FILE='sediment12_12t_3D.plt', STATUS= 'UNKNOWN' )
! OPEN( 905, FILE='height-8s_3D.plt', STATUS= 'UNKNOWN' )
 OPEN( 906, FILE='eq-energy_3D.plt', STATUS= 'UNKNOWN' )
 OPEN( 907, FILE='eq-energy_3D-ini.plt', STATUS= 'UNKNOWN' ) 
! OPEN( 908, FILE='height-16s_3D.plt', STATUS= 'UNKNOWN' )
! OPEN( 909, FILE='height-30s_3D.plt', STATUS= 'UNKNOWN' )   
       
       
       
      
       
       
       
       
  
   DO
        
  !    IF(MOD(T_ITER,500)==0) THEN          
  !      !!!!! ** ŪiO] ** !!!!!
  !    OPEN( UNIT = 222, FILE = "RT.dat", STATUS = "old" )
  !      DO K = 1 , NZ
  !      DO J = 1, NY
  !      DO I = 1, NX
  !       READ(222,'(8E15.6)') X(I,J,K), Y(I,J,K), Z(I,J,K) , U(I,J,K) , V(I,J,K) , W(I,J,K) &
  !                       & ,P(I,J,K) , PHI(I,J,K)
  !      END DO
  !      END DO
  !      END DO
  !    CLOSE(222) 
  !    ENDIF
        
        
       T_Iter = T_Iter + 1
       
      
      
       IF(T_Iter == 1) THEN
          DDt = Dt
        ELSE
          DDt = Dt / 1.5_DP
       END IF
       
       
   
       
       	  
      ! CALL RK4_DRPCCD7TH_AD_TRIPE_3D(Nx , Ny , NZ , Dx , Dy , DZ , Dt , U , V  , W , PHI , PHI_TEMP,ANGC  &
      !                        &, AU_X , BU_X  , CU_X , AAU_X , BBU_X , CCU_X , AAAU_X , BBBU_X  , CCCU_X &
      !                        &, AD_X , BD_X  , CD_X , AAD_X , BBD_X , CCD_X , AAAD_X , BBBD_X  , CCCD_X &
      !                        &, AU_Y , BU_Y  , CU_Y , AAU_Y , BBU_Y , CCU_Y , AAAU_Y , BBBU_Y  , CCCU_Y &
      !                        &, AD_Y , BD_Y  , CD_Y , AAD_Y , BBD_Y , CCD_Y , AAAD_Y , BBBD_Y  , CCCD_Y &
      !                        &, AU_Z , BU_Z  , CU_Z , AAU_Z , BBU_Z , CCU_Z , AAAU_Z , BBBU_Z  , CCCU_Z &
      !                        &, AD_Z , BD_Z  , CD_Z , AAD_Z , BBD_Z , CCD_Z , AAAD_Z , BBBD_Z  , CCCD_Z  )  
  
      ! PHI = PHI_TEMP
      
     
     
    

                             
     !  CALL WENO_RK_AD(NX , NY , NZ ,  Phi , u , v , W,  Dx , Dy ,  DZ ,  Dt )
     
       
       DO K=1,NZ
       DO J=1,NY
	     DO I=1,NX  
          W_MIX_1(i,j,K) =  W(i,j,K) - W_1S   
         
       ENDDO
	     ENDDO
	     ENDDO  
	     
	     DO J=1,NY  
	     DO I=1,NX  
         C_1(i,J,1) =    (  W_1S*( C_1(i,J,2) - C_1(i,J,1)  )  / ( 0.5_DP*DX)  )*DT +  C_1(i,J,1)         
       ENDDO
       ENDDO
	     
	    !  CALL RK3_DRPCCD5TH_AD_TWIN(Nx , Ny , NZ , Dx , Dy , DZ , Dt , U , V , W_MIX_1 , C_1 , C_1_TEMP  &
      !                       &, AU_X1 , BU_X1 , AAU_X1 , BBU_X1 &
      !                       &, AD_X1 , BD_X1 , AAD_X1 , BBD_X1 &
      !                       &, AU_Y1 , BU_Y1 , AAU_Y1 , BBU_Y1 &
      !                       &, AD_Y1 , BD_Y1 , AAD_Y1 , BBD_Y1 & 
      !                       &, AU_Z1 , BU_Z1 , AAU_Z1 , BBU_Z1 &
      !                       &, AD_Z1 , BD_Z1 , AAD_Z1 , BBD_Z1 )   
      !  C_1 = C_1_TEMP                     
       
       
        CALL RK3_DRPCCD5TH_AD_TWIN_1(Nx , Ny , NZ , Dx , Dy , DZ , Dt , U , V , W_MIX_1 , C_1 , C_1_TEMP  , K_X , K_Y , K_Z &
                             &, AU_X1 , BU_X1 , AAU_X1 , BBU_X1 &
                             &, AD_X1 , BD_X1 , AAD_X1 , BBD_X1 &
                             &, AU_Y1 , BU_Y1 , AAU_Y1 , BBU_Y1 &
                             &, AD_Y1 , BD_Y1 , AAD_Y1 , BBD_Y1 & 
                             &, AU_Z1 , BU_Z1 , AAU_Z1 , BBU_Z1 &
                             &, AD_Z1 , BD_Z1 , AAD_Z1 , BBD_Z1 )   
        C_1 = C_1_TEMP        
     
           DO K=1,NZ
           DO J=1,NY
	         DO I=1,NX 
            
            IF(   C_1(i,j,K) > 0.999999999_DP ) THEN 
            	
            	  C_1(i,j,K) = 1.0_DP  
            	  
            ELSEIF( C_1(i,j,K) < 0.00000001_DP  ) THEN
            	 	  
            	  C_1(i,j,K) = 0.0_DP 
            	  
            ELSE
            	 	C_1(i,j,K) = C_1(i,j,K)   
            	  
            ENDIF
          
           
          
           
        ENDDO
	      ENDDO
	      ENDDO      
          
          
       C_T = C_1! + C_2    
       
       
        ! ɳ    
   m_s1 = dv*sum(c_1(2:nx-1,2:ny-1,2:nz-1))      !????֣cֵ͵ķΧ   
 !  m_s2 = dv*sum(c_2(2:nx-1,2:ny-1,2:nz-1))   
   m_st = m_s1   !+m_s2
  
if (mod(t_iter,10)==0)	then 
  write(902,'(E15.6,2x,E15.6)') real(t_iter)*dt,m_st
end if
       
       
  !ͷλ



DO I=1,NX
 	c_f(i)=(sum(c_t(i,:,:))*da_zy)/a_x   ! xϵķŨֵ   2016/5/8 9:17:21
 	if (c_f(i)>0.2_dp) then
 		start1=i       !ֹһʱǰ˵ŨֵΪ0.1ʱʹжͷλóִ
  end if
end do             !趨һŨֵΪ0.2ڵλΪʼжϵ㣬ųǰεӰ졣
DO I=start1+1,NX                                                      
 if ( (c_f(i)>=0.009998_dp) .and.(c_f(i)<=0.010002_dp) )	then 		   !2016/5/10 14:46:28
write(903,'(f8.4,2x,E15.6)') real(t_iter)*dt ,x(i,1,1)   !ֹͬһʱ䲽ϣϿռλãֻȥֵ
 end if                                                  !ֹͬλûǱȽСλµ
end do                          
       
       
       
       
    !   DO K=1,NZ 
    !   DO J=1,NY
	  !   DO I=1,NX 
    !    
    !    IF(   C_t(i,j,K) > 0.99999999_DP ) THEN 
    !    	
    !    	  C_t(i,j,K) = 1.0_DP  
    !    	  
    !    ELSEIF( C_1(i,j,K) < 0.0000001_DP  ) THEN
    !    	 	  
    !    	  C_t(i,j,K) = 0.0_DP 
    !    	  
    !    ELSE
    !    	 	C_t(i,j,K) = C_t(i,j,K)   
    !    	  
    !    ENDIF
    !    
    !
    ! 
    !      
    !   ENDDO
	  !   ENDDO
	  !   ENDDO      


      

       


       !   heavy_node = 0
       !   DO K=2,NZ-1
       !   DO J=2,NY-1
	     !   DO I=2,NX-1
	     !   	
	     !   	 
	     !   	 
	     !   	 	if(  heavy(PHI(i,j,K),dx,hp(I,J,K))   > 0.0_dp.AND. heavy(PHI(i,j,K),dx,hp(I,J,K))  < 1.0_dp )  THEN
	     !   	    heavy_node =  heavy_node  + 1
	     !   	  endif  
       !      
	     !   ENDDO
	     !   ENDDO
	     !   ENDDO 
       !
       !
       !
       !   
       ! MASS = 0.0_DP
       ! DO K=2,NZ-1
       ! DO J=2,NY-1
 	     ! DO I=2,NX-1
       !       MASS = MASS + heavy(PHI(i,j,K),dx,hp(I,J,K))
 	     ! ENDDO
 	     ! ENDDO
 	     ! ENDDO
 	     ! 
 	     ! DO K=2,NZ-1
 	     ! DO J=2,NY-1
       ! DO I=2,NX-1
	     !      heavy_mat(I,J,K) = heavy(PHI(i,j,K),dx,hp(I,J,K))
	     ! ENDDO
       ! ENDDO
       ! ENDDO
       !  
       !  
       !   DO K=  2,NZ-1
       !   DO J = 2,NY-1
	     !   DO I = 2,NX-1
	     !       	
	     !       		
       !            IF( (MASS-MASS_OLD) >= 0.0_DP ) THEN
       !                heavy_mat(I,J,K) = heavy_mat(I,J,K) - (  ABS( MASS-MASS_OLD ) / (  heavy_node ) )
       !            
       !            ELSEIF( (MASS-MASS_OLD) < 0.0_DP ) THEN    
       !                heavy_mat(I,J,K) = heavy_mat(I,J,K) +  (  ABS( MASS-MASS_OLD ) / (  heavy_node  ) )
       !            
       !            else 
       !            	
       !                heavy_mat(I,J,K) = heavy_mat(I,J,K) 
       !                
       !            ENDIF   
       !         
       !      
       !             
       !   ENDDO
	     !   ENDDO   
	     !   ENDDO  
	     !   
	     ! 
	     ! !!! ATTENTION FOR  *3.0_DP*DX
	     !  DO K = 2,NZ-1  
	     !  DO J = 2,NY-1
	     !  DO I = 2,NX-1
	     !  	 if(  heavy(PHI(i,j,K),dx,hp(I,J,K))   <=0.5_dp.AND. heavy(PHI(i,j,K),dx,hp(I,J,K))  > 0.0_dp )  THEN  
       !       PHI(I,J,K) = -1.0_DP / 3.0_DP* LOG(  ( -heavy_mat(I,J,K) +1.0_DP  )/  heavy_mat(I,J,K) )*3.0_DP*DX
       !    ELSEif(  heavy(PHI(i,j,K),dx,hp(I,J,K))  >  0.5_dp.AND. heavy(PHI(i,j,K),dx,hp(I,J,K))  < 1.0_dp )  THEN  
       !     	PHI(I,J,K) = -1.0_DP / 3.0_DP* LOG(  ( -heavy_mat(I,J,K) +1.0_DP  )/  heavy_mat(I,J,K) )*3.0_DP*DX
       !    ELSE
       !    	  PHI(I,J,K) = PHI(I,J,K) 
       !    ENDIF	   	
       !    
       !   ENDDO
	     !   ENDDO 
	     !   ENDDO        
	          
       
     
    !!!!!!!!!!!!!!!!!!!!!!!!! redistance 
    !!!!!!!!!!!!!!!!!!!!!!!!! redistance 
    !!!!!!!!!!!!!!!!!!!!!!!!! redistance 
    
   !   IF(MOD(T_Iter,1)==0) THEN  
   !     IMASS = 1 
   !     CALL WENO_RK(NX , NY , NZ ,  Phi , Dx , Dy ,  DZ , Dt , imass ) 
   !   ENDIF 
   !    
   !    
   !   DO K = 2 ,NZ-1
   !   DO J = 2 ,NY-1
	 !   DO I = 2 ,NX-1
	 !      	
	 !   	  TEST1(I,J,K) =  heavy1(PHI(i,j,K),dx,hp2(I,J,K))  
   !        
   !   ENDDO
	 !   ENDDO
	 !   ENDDO  
    
    
     
   
              
   !    WRITE(13,*) T_ITER , MASS / MASS_OLD ,  ( MASS - MASS_OLD ) / MASS_OLD
   !                                    
   !
   ! 
   !   CALL RHO_Mu_compute(NX , NY , NZ , Dx , PHI , RHO , MU , RHO_GL , MU_GL , He , Hp)
   !   
   !  
   !  
   !   IF(MOD(T_ITER,5)==0) THEN 
   !     WRITE(*,*) "====================================================================="
   !     WRITE(*,*) 'T_Iter', T_Iter    
   !     WRITE(*,'(1X,A,4E15.5)') "   MASS RATIO.............." ,  MASS / MASS_OLD   
   !     WRITE(*,'(1X,A,4E15.5)') "======================================================="   
   !   ENDIF
     
     
   
    
    !!!!!!!!!!!!!!!!!iO
    !  CALL BC_3D_LS1(Nx , Ny, Nz, DZ, PHI, ANGC, PHI_x, PHI_y)
    !  CALL LS_SURFACE_FORCE_3D(Nx , Ny  , NZ , DX , DY , DZ ,  PHI , Kappa)   
    !  CALL FIND_FxFy_001_fv_3D(NX , NY  , NZ, PHI_X , PHI_Y , PHI_Z, PHI, Dx, Dy , DZ)   
    


                               
       
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP SHARED(U_TEMP,V_TEMP,W_TEMP,P_TEMP,U,V,W,P,NX,NY,NZ) PRIVATE(I,J,K) 
  !$OMP DO
    
        DO K = 1 , NZ  
        DO J = 1 , NY 
       	DO I = 1 , NX
            U_temp(I,J,K) = U(I,J,K)
            V_temp(I,J,K) = V(I,J,K)
            W_temp(I,J,K) = W(I,J,K)
            P_temp(I,J,K) = P(I,J,K)
        ENDDO
        ENDDO
        ENDDO
  !$OMP END DO
  !$OMP END PARALLEL
    
         
      
       DO Iter = 1 , I_Iter
         
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !Solving X-momentum
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
        Us = U
        DO
    
    
          C_X = U
          C_Y = V
          C_Z = W
          K_X = 1.0_DP / Re
          K_Y = 1.0_DP / Re
          K_Z = 1.0_DP / Re
    
       !   S = 0.0_DP  -  Kappa * 1.0_DP / RHO * ( pHI_X ) / We *HP
       
         S = 0.0_DP  !-  Kappa * 1.0_DP / RHO * ( pHI_X ) / We *HP2
         
         
        !  CALL RHS_COMPUTE_QUICK3ST_3D(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z   &
        !                        &, K_X , K_Y , K_Z , RHO , Mu , S , U , RHS  )
                                
         
          CALL RHS_COMPUTE_QUICK3ST_3D_1(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z   &
                                &, K_X , K_Y , K_Z , RHO , Mu , S , U , RHS  )
                                
               
        !  CALL RHS_COMPUTE_UP1ST(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z   &
        !                        &, K_X , K_Y , K_Z , RHO , Mu , S , U , RHS  )
              
                                  
                           
              IF(T_Iter >= 1) THEN
          
                DO K = 2 , NZ-1
                DO J = 2 , Ny-1
                DO I = 2 , Nx-1
                  U(I,J,K) = U_old(I,J,K) + Dt * RHS(I,J,K)
                END DO
                END DO
                END DO
                
              ELSE
          
        !$OMP PARALLEL DEFAULT(NONE) &
        !$OMP SHARED(U,U_OLD,U_OLD2,RHS,NX,NY,NZ) PRIVATE(I,J,K)  &
        !$OMP FIRSTPRIVATE(DT) 
        !$OMP DO
                DO K = 2 , NZ-1
                DO J = 2 , Ny-1
                DO I = 2 , Nx-1
                  U(I,J,K) = (2.0_DP * U_old(I,J,K) - 0.5_DP * U_old2(I,J,K) + Dt * RHS(I,J,K) ) / 1.5_DP
                END DO
                END DO
                END DO
        !$OMP END DO
        !$OMP END PARALLEL      
          
               END IF
         
         
         
         
    
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !Check convergence
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
    
        L2NORM_U = MAXVAL( ABS( (U(2:Nx-1,2:Ny-1,2:NZ-1) - Us(2:Nx-1,2:Ny-1,2:NZ-1)) ) )
    
    
        !IF( L2NORM_U <= 1.0E-10_DP) EXIT
    
        EXIT
    
        Us = U
    
        END DO
        
        
        
    
     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     !Solving Y-momentum
     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
        Vs = V
     DO
    
    
       !  S = 0.0_DP  -  Kappa * 1.0_DP / RHO * ( pHI_y ) / We  * HP 
       
        S = 0.0_DP  !-  Kappa * 1.0_DP / RHO * ( pHI_y ) / We  * HP2
        
         
    
     !   CALL RHS_COMPUTE_QUICK3ST_3D(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z   &
     !                        &, K_X , K_Y , K_Z , RHO , Mu , S , V , RHS  )     
      
       CALL RHS_COMPUTE_QUICK3ST_3D_1(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z   &
                             &, K_X , K_Y , K_Z , RHO , Mu , S , V , RHS  )                                                     
      
     !  CALL RHS_COMPUTE_UP1ST(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z   &
     !                           &, K_X , K_Y , K_Z , RHO , Mu , S , V , RHS  )                                               
                                                                                                                   
           IF(T_Iter >= 1) THEN
          
             DO K = 2 , NZ-1
             DO J = 2 , Ny-1
             DO I = 2 , Nx-1
               V(I,J,K) = V_old(I,J,K) + Dt * RHS(I,J,K)
             END DO
             END DO
             END DO
             
           ELSE
     !$OMP PARALLEL DEFAULT(NONE) &
     !$OMP SHARED(V,V_OLD,V_OLD2,RHS,NX,NY,NZ) PRIVATE(I,J,K)  &
     !$OMP FIRSTPRIVATE(DT) 
     !$OMP DO      	
             DO K = 2 , NZ-1
             DO J = 2 , Ny-1
             DO I = 2 , Nx-1
               V(I,J,K) = (2.0_DP * V_old(I,J,K) - 0.5_DP * V_old2(I,J,K) + Dt * RHS(I,J,K) ) / 1.5_DP
             END DO
             END DO
             END DO
     !$OMP END DO
     !$OMP END PARALLEL             
         
           END IF
    
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !Check convergence
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
    
        L2NORM_V = MAXVAL( ABS( (V(2:Nx-1,2:Ny-1,2:NZ-1) - Vs(2:Nx-1,2:Ny-1,2:NZ-1)) ) )
    
    
        !IF( L2NORM_V <= 1.0E-10_DP) EXIT
    
        EXIT
    
        Vs = V
    
        END DO
        
       
     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     !Solving Z-momentum
     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
    
    
        Ws = W
        DO
    
    
        !  S = - 1.0_DP / (Fr**2)  ! -  Kappa * 1.0_DP / RHO * ( pHI_Z ) / We  * HP2
        
        S = -C_T
        
        
        !   S =  0.0_DP / (Fr**2)   -  Kappa * 1.0_DP / RHO * ( pHI_Z ) / We  * HP 
        
        ! S =  0.0_DP / (Fr**2)   -  Kappa * 1.0_DP / RHO * ( pHI_Z ) / We  * HP2
        
         
    
     !   CALL RHS_COMPUTE_QUICK3ST_3D(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z   &
     !                        &, K_X , K_Y , K_Z , RHO , Mu , S , W , RHS  )   
      
      
        CALL RHS_COMPUTE_QUICK3ST_3D_1(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z   &
                             &, K_X , K_Y , K_Z , RHO , Mu , S , W , RHS  )                                                     
       
      ! CALL RHS_COMPUTE_UP1ST(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z   &
      !                          &, K_X , K_Y , K_Z , RHO , Mu , S , W , RHS  ) 
                                                     
                                                                                                                   
           IF(T_Iter >= 1) THEN
          
             DO K = 2 , NZ-1
             DO J = 2 , Ny-1
             DO I = 2 , Nx-1
               W(I,J,K) = W_old(I,J,K) + Dt * RHS(I,J,K)
             END DO
             END DO
             END DO
             
           ELSE
           	
     !$OMP PARALLEL DEFAULT(NONE) &
     !$OMP SHARED(W,W_OLD,W_OLD2,RHS,NX,NY,NZ) PRIVATE(I,J,K)  &
     !$OMP FIRSTPRIVATE(DT) 
     !$OMP DO          	
             DO K = 2 , NZ-1
             DO J = 2 , Ny-1
             DO I = 2 , Nx-1
               W(I,J,K) = (2.0_DP * W_old(I,J,K) - 0.5_DP * W_old2(I,J,K) + Dt * RHS(I,J,K) ) / 1.5_DP
             END DO
             END DO
             END DO
     !$OMP END DO
     !$OMP END PARALLEL               
         
           END IF
    
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !Check convergence
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
    
        L2NORM_W = MAXVAL( ABS( (W(2:Nx-1,2:Ny-1,2:NZ-1) - Ws(2:Nx-1,2:Ny-1,2:NZ-1)) ) )
    
    
        !IF( L2NORM_W <= 1.0E-10_DP) EXIT
    
        EXIT
    
        Ws = W
    
        END DO 
        
        
  
        
   
       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       !Solving P
       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       

   
      !$OMP PARALLEL DEFAULT(NONE) &
      !$OMP SHARED(US,U,VS,V,WS,W,PP_C,PP,Nx,NY,NZ) PRIVATE(I,J,K) 
      !$OMP DO
          DO K = 1 , NZ
          DO J = 1 , NY
          DO I = 1 , NX      
             Us(I,J,K) = U(I,J,K)
             Vs(I,J,K) = V(I,J,K)
             Ws(I,J,K) = W(I,J,K)
             PP_C(I,J,K) = PP(I,J,K)
         ENDDO
         ENDDO 
         ENDDO
      !$OMP END DO
      !$OMP END PARALLEL      
        
 
        
    CALL Cell_face_velocity_FV_3D(Nx , Ny  , NZ , 1.0_DP / RHO , 1.0_DP / RHO , 1.0_DP / RHO  , RHO_cx , RHO_cy , RHO_cZ)
    CALL Cell_face_velocity_FV_3D(Nx , Ny  , NZ , Us , Vs , Ws , Uc , Vc , Wc)
 
      
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP SHARED(UC,P,RHO_CX,Nx,NY,NZ) PRIVATE(I,J,K) FIRSTPRIVATE(DDT,DX)
    !$OMP DO
    
        DO K = 2 , NZ-1
        DO J = 2 , Ny-1
        DO I = 2 , Nx-2
           Uc(I,J,K) =  Uc(I,J,K) - DDt * (P(I+1,J,K) - P(I,J,K)) / Dx * RHO_Cx(I,J,K) 
        END DO
        END DO
        END DO
        
    !$OMP END DO
    !$OMP END PARALLEL    
     
    
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP SHARED(VC,P,RHO_CY,Nx,NY,NZ) PRIVATE(I,J,K) FIRSTPRIVATE(DDT,DY)
    !$OMP DO 
        DO K = 2 , NZ-1
        DO J = 2 , Ny-2
        DO I = 2 , Nx-1
          Vc(I,J,K) =  Vc(I,J,K) - DDt * (P(I,J+1,K) - P(I,J,K)) / Dy * RHO_cy(I,J,K) 
        END DO
        END DO
        END DO
    !$OMP END DO
    !$OMP END PARALLEL  
    
    
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP SHARED(WC,P,RHO_CZ,Nx,NY,NZ) PRIVATE(I,J,K) FIRSTPRIVATE(DDT,DZ)
    !$OMP DO 
        DO K = 2 , NZ-2
        DO J = 2 , Ny-1
        DO I = 2 , Nx-1
          Wc(I,J,K) =  Wc(I,J,K) - DDt * (P(I,J,K+1) - P(I,J,K)) / DZ * RHO_cZ(I,J,K) 
        END DO
        END DO
        END DO    
   !$OMP END DO
   !$OMP END PARALLEL 
    
        PP_C = 0.0_DP

    
    
     CALL cell_face_POISSON_SOLVER_GS(Nx , Ny , NZ , Dx , Dy , DZ , DDt , Uc , Vc , Wc , RHO_Cx &
                                   &, RHO_Cy  , RHO_CZ , PP_C , S , Iter , Tol , PHI )    
                                  

    
   !$OMP PARALLEL DEFAULT(NONE) &
   !$OMP SHARED(P,PP_C,Nx,NY,NZ) PRIVATE(I,J,K) 
   !$OMP DO 
        DO K = 2 , NZ-1
        DO J = 2 , Ny-1
        DO I = 2 , Nx-1
          P(I,J,K) =  P(I,J,K) + PP_C(I,J,K)
        END DO
        END DO
        END DO
   !$OMP END DO
   !$OMP END PARALLEL   
    
    
       
    
         CALL BC_2D_P_3D(Nx , Ny , NZ , P)
     !    CALL BC_3D_P1(Nx, Ny, Nz, P, RHO)
        
          
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP SHARED(UC,PP_C,RHO_CX,Nx,NY,NZ) PRIVATE(I,J,K) FIRSTPRIVATE(DDT,DX)
    !$OMP DO
        DO K = 2 , NZ-1
        DO J = 2 , Ny-1
        DO I = 2 , Nx-2
          Uc(I,J,K) = Uc(I,J,K) - DDt * (PP_C(I+1,J,K) - PP_C(I,J,K)) / Dx * RHO_Cx(I,J,K)
        END DO
        END DO
        END DO
    !$OMP END DO
    !$OMP END PARALLEL   
        
    
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP SHARED(VC,PP_C,RHO_CY,Nx,NY,NZ) PRIVATE(I,J,K) FIRSTPRIVATE(DDT,DY)
    !$OMP DO
    
        DO K = 2 , NZ-1 
        DO J = 2 , Ny-2
        DO I = 2 , Nx-1
          Vc(I,J,K) = Vc(I,J,K) - DDt * (PP_C(I,J+1,K) - PP_C(I,J,K)) / Dy * RHO_cy(I,J,K)
        END DO
        END DO
        END DO
        
    !$OMP END DO
    !$OMP END PARALLEL   
    
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP SHARED(WC,PP_C,RHO_CZ,Nx,NY,NZ) PRIVATE(I,J,K) FIRSTPRIVATE(DDT,DZ)
    !$OMP DO 
    
       DO K = 2 , NZ-2 
       DO J = 2 , Ny-1
       DO I = 2 , Nx-1
          Wc(I,J,K) = Wc(I,J,K) - DDt * (PP_C(I,J,K+1) - PP_C(I,J,K)) / DZ * RHO_cZ(I,J,K)
       END DO
       END DO
       END DO
    !$OMP END DO
    !$OMP END PARALLEL    
      
        !!!For node
       CALL FIND_FxFy_001_FV_3D(Nx , Ny , NZ , P_X , P_Y  , P_Z , P, Dx , Dy , DZ)
        
        
     
     
     !$OMP PARALLEL DEFAULT(NONE) &
     !$OMP SHARED(U,V,W,P_X,P_Y,P_Z,RHO,Nx,NY,NZ) PRIVATE(I,J,K) FIRSTPRIVATE(DDT)
     !$OMP DO
         DO K = 2 , NZ-1
         DO J = 2 , Ny-1
         DO I = 2 , Nx-1
           U(I,J,K) = U(I,J,K) - DDt * P_X(I,J,K) / RHO(I,J,K)
           V(I,J,K) = V(I,J,K) - DDt * P_Y(I,J,K) / RHO(I,J,K)
           W(I,J,K) = W(I,J,K) - DDt * P_Z(I,J,K) / RHO(I,J,K)
         END DO
         END DO
         END DO
     !$OMP END DO
     !$OMP END PARALLEL
 
     
   ! BOUNDARY CONDITION  
   
   
   
      !!!!!!3D	B . C . 
      
   !! FOR TOP   
      DO J = 2 , NY-1 
      DO I = 2 , Nx-1
  !     U(I,J,1)  = ( 9.0_DP * U(I,J,2)    - U(I,J,3)    ) / 8.0_DP
        U(I,J,NZ) = ( 9.0_DP * U(I,J,NZ-1) - U(I,J,NZ-2) ) / 8.0_DP
        V(I,J,NZ) = ( 9.0_DP * V(I,J,NZ-1) - V(I,J,NZ-2) ) / 8.0_DP
         
      END DO
      END DO
      
      
     
  !    DO K = 2 , NZ-1 
  !    DO I = 2 , Nx-1
  !      U(I,1,K)  = ( 9.0_DP * U(I,2,K)    - U(I,3,K)    ) / 8.0_DP
  !      W(I,1,K)  = ( 9.0_DP * W(I,2,K)    - W(I,3,K)    ) / 8.0_DP 
  !     
  !       
  !    END DO
  !    END DO
  !    	
  !    	
  !    DO K = 2 , NZ-1 
  !    DO I = 2 , Nx-1
  !      U(I,NY,K)  = ( 9.0_DP * U(I,NY-1,K)    - U(I,NY-2,K)    ) / 8.0_DP
  !      W(I,NY,K)  = ( 9.0_DP * W(I,NY-1,K)    - W(I,NY-2,K)    ) / 8.0_DP 
  !     
  !       
  !    END DO
  !    END DO
   
   
   
   
   
   
    
     !!!!!!!	B . C .  
    
     
   !  DO K = 2 , NZ-1
   !  DO J = 2 , Ny-1
   !   U(1,J,K)  = U(2,J,K)
   !   U(Nx,J,K) = U(NX-1,J,K)
   !   V(1,J,K)  = V(2,J,K)
   !   V(Nx,J,K) = V(NX-1,J,K)
   !   W(1,J,K)  = W(2,J,K)
   !   W(Nx,J,K) = W(NX-1,J,K)
   !  END DO
   !  END DO
   ! 
   ! 
   !  DO K = 2 , NZ-1
   !  DO I = 2 , Nx-1
   !   U(I,1,K)  = U(I,2,K)
   !   U(I,Ny,K) = U(I,NY-1,K)
   !   V(I,1,K)  = V(I,2,K)
   !   V(I,Ny,K) = V(I,NY-1,K)
   !   W(I,1,K)  = W(I,2,K)
   !   W(I,Ny,K) = W(I,NY-1,K)
   !  END DO
   !  END DO
   !  
   !  DO J = 2 , NY-1
   !  DO I = 2 , Nx-1
   !   U(I,J,1)  = U(I,J,2)
   !   U(I,J,NZ) = U(I,J,NZ-1)
   !   V(I,J,1)  = V(I,J,2)
   !   V(I,J,NZ) = V(I,J,NZ-1)
   !   W(I,J,1)  = W(I,J,2)
   !   W(I,J,NZ) = W(I,J,NZ-1)
   !  END DO
   !  END DO
  
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      !Check convergence
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
      
!⶯				

Ek_con=DV/2.0_dp *sum( U(2:nx-1,2:ny-1,2:nz-1)**2+v(2:nx-1,2:ny-1,2:nz-1)**2+w(2:nx-1,2:ny-1,2:nz-1)**2)


!

EP_CON=DV*SUM(z(2:nx-1,2:ny-1,2:nz-1)*c_t(2:nx-1,2:ny-1,2:nz-1))


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!ɵܺɢ
ES_CON=DV*SUM(c_1(2:nx-1,2:ny-1,2:nz-1))*w_1s     !+SUM(c_2(2:nx-1,2:ny-1,2:nz-1)*w_2s))
EST_CON=EST_CON+ES_CON
ESTT_CON=EST_CON*DT


!ճʧֵ
!ED_U=0.0_dp 
!ED_V=0.0_dp 
!ED_W=0.0_dp


!!ճʧ
 ED_UVW=0.0_DP
 do k=2,nz-1 
 do j=2,ny-1 
 do i=2,nx-1 
   ED_UVW = ED_UVW+((u(i+1,j,k)-u(i-1,j,k))/(2.0_dp*dx) + (u(i,j+1,k)-u(i,j-1,k))/(2.0_dp*dy) +(u(i,j,k+1)-u(i,j,k-1))/(2.0_dp*dz)&
         &+(v(i+1,j,k)-v(i-1,j,k))/(2.0_dp*dx) + (v(i,j+1,k)-v(i,j-1,k))/(2.0_dp*dy) +(v(i,j,k+1)-v(i,j,k-1))/(2.0_dp*dz)  &
         &+ (w(i+1,j,k)-w(i-1,j,k))/(2.0_dp*dx) + (w(i,j+1,k)-w(i,j-1,k))/(2.0_dp*dy) +(w(i,j,k+1)-w(i,j,k-1))/(2.0_dp*dz))**2
 end do
 end do
 end do
   ED_UVW1 =  (2.0_dp/real(re))*DV*ED_UVW
   EDT_UVW = EDT_UVW + ED_UVW1
   EDTT_UVW=EDT_UVW*DT


ET_0=Ek_con+EP_CON+EDTT_UVW+ESTT_CON!+esumTT_cwt     !ÿϵ


!ÿ10һ

if (mod(t_iter,10)==0) then
write(907,'(f8.4,2x,E15.6,2x,E15.6,2x,E15.6,2x,E15.6,2x,E15.6)') REAL(T_ITER)*DT ,EK_CON ,EP_CON , ESTT_CON, EDTT_UVW ,  E0
write(906,'(f8.4,2x,E15.6,2x,E15.6,2x,E15.6,2x,E15.6,2x,E15.6)') REAL(T_ITER)*DT ,EK_CON/E0 ,EP_CON/E0 ,  EDTT_UVW/E0 ,ESTT_CON/E0,  ET_0/E0  
end if   
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
  
      L2NORM_U = MAXVAL( ABS( (U(2:Nx-1,2:Ny-1,2:NZ-1) - U_temp(2:Nx-1,2:Ny-1,2:NZ-1)) ) )
  
      L2NORM_V = MAXVAL( ABS( (V(2:Nx-1,2:Ny-1,2:NZ-1) - V_temp(2:Nx-1,2:Ny-1,2:NZ-1)) ) )
      
      L2NORM_W = MAXVAL( ABS( (W(2:Nx-1,2:Ny-1,2:NZ-1) - W_temp(2:Nx-1,2:Ny-1,2:NZ-1)) ) )
  
      L2NORM_P = MAXVAL( ABS( (P(2:Nx-1,2:Ny-1,2:NZ-1) - P_temp(2:Nx-1,2:Ny-1,2:NZ-1)) ) )
  
  
  
      IF( MOD(Iter , 1) == 0 ) THEN
  
        DIV  = 0.0_DP
  
        !for node
        CALL Cell_face_velocity_FV_3D(Nx , Ny , NZ , U , V , W , PP_X , PP_Y , PP_Z)
  
        DO K = 2 , NZ-1
        DO J = 2 , NY-1
        DO I = 2 , Nx-1       
          DIV(I,J,K) = (PP_X(I,J,K) - PP_X(I-1,J,K) ) / Dx + (PP_Y(I,J,K) - PP_Y(I,J-1,K)) / Dy   &
                  &  + (PP_Z(I,J,K) - PP_Z(I,J,K-1)) / Dz 
        END DO
        END DO
        END DO
  
        DIV_node = MAXVAL(ABS(DIV*Dx*Dy*DZ))
        
             
     !!!  !for cell
        DO K = 2 , NZ-1
        DO J = 2 , Ny-1
        DO I = 2 , Nx-1    
          DIV(I,J,K) = (Uc(I,J,K) - Uc(I-1,J,K)) / Dx + (Vc(I,J,K) - Vc(I,J-1,K)) / Dy    &
                      & + (Wc(I,J,K) - Wc(I,J,K-1)) / DZ
        END DO
        END DO
        END DO
  
        DIV_cell = MAXVAL(ABS(DIV*Dx*Dy*DZ))
  
       ! WRITE(*,'(I8,5(2X,E10.4))') Iter , L2NORM_U , L2NORM_V , L2NORM_P &
       !                          &, DIV_cell , DIV_node
  
      END IF
  
      IF( Iter > 1 .AND. MAX(L2NORM_U,L2NORM_V,L2NORM_W,L2NORM_P) <= Tol) THEN
       ! WRITE(*,*) T_Iter , "Step, inner CONVERGENCE!!!"
        EXIT
      END IF
  
  
      U_temp = U
      V_temp = V
      W_temp = W
      P_temp = P
  
  
  
    END DO
  
  
      L2_U = MAXVAL( ABS(U(1:NX,1:NY,1:NZ) - U_old(1:NX,1:NY,1:NZ)) )
      
      L2_V = MAXVAL( ABS(V(1:NX,1:NY,1:NZ) - V_old(1:NX,1:NY,1:NZ)) )
      
      L2_W = MAXVAL( ABS(W(1:NX,1:NY,1:NZ) - W_old(1:NX,1:NY,1:NZ)) )
  
      L2_P = MAXVAL( ABS(P(1:NX,1:NY,1:NZ) - P_old(1:NX,1:NY,1:NZ)) )
    
      
    
        DIV  = 0.0_DP
    
        !for node
        CALL Cell_face_velocity_FV_3D(Nx , Ny , NZ , U , V , W , PP_X , PP_Y , PP_Z)
    
        DO K = 2 , NZ-1
        DO J = 2 , Ny-1
        DO I = 2 , Nx-1
          DIV(I,J,K) = (PP_X(I,J,K) - PP_X(I-1,J,K) ) / Dx + (PP_Y(I,J,K) - PP_Y(I,J-1,K)) / Dy    &
                 &   + (PP_Z(I,J,K) - PP_Z(I,J,K-1)) / DZ
        END DO
        END DO
        END DO
    
        DIV_node = MAXVAL(ABS(DIV*Dx*Dy*DZ))
    
        !for cell
    
        DO K = 2 , NZ-1
        DO J = 2 , Ny-1
        DO I = 2 , Nx-1    
           DIV(I,J,K) = (Uc(I,J,K) - Uc(I-1,J,K)) / Dx + (Vc(I,J,K) - Vc(I,J-1,K)) / Dy   &
                   &  + (Wc(I,J,K) - Wc(I,J,K-1)) / DZ
        END DO
        END DO
        END DO
    
        DIV_cell = MAXVAL(ABS(DIV*Dx*Dy*DZ))
        
     
       IF( MOD(T_Iter , 1) == 0 ) THEN  
          WRITE(*,*) "     ================================================"
          WRITE(*,*) "     AT" , T_Iter , "NONLINEAR-ITERATION" 
          WRITE(*,*) "     L2_U is :" , L2_U
          WRITE(*,*) "     L2_V is :" , L2_V
          WRITE(*,*) "     L2_V is :" , L2_W
          WRITE(*,*) "     L2_P is :" , L2_P
          WRITE(*,*) "     DIV_cell:" , DIV_cell
          WRITE(*,*) "     DIV_node:" , DIV_node
          WRITE(*,*) "     ================================================"
          WRITE(*,*) 
          WRITE(*,*) 
          WRITE(*,*) 
    
       END IF 
       
     ! CALL VISC( NX, NY, NZ, U, V, W, MU_L, PHI, DX, DY, DZ, DT, TIMESTEP, T_Iter)
     ! CALL VISC_1( NX, NY, NZ, U, V, W, MU_L, PHI, DX, DY, DZ, DT, TIMESTEP, T_Iter, DE_VSOLD)  
     ! call ANAYLSIS( Nx, Ny, Nz, T_Iter, P, PHI, PHI_X, PHI_Y, PHI_Z, DX, DY, DZ, timestep)
     ! CALL TOTAL_ENERGY(Nx, Ny, Nz, T_Iter,PHI, PHI_X, PHI_Y, PHI_Z, P, DX, DY, DZ, DT, U, V, W, ANGC, RRR, RHO, MU_l, timestep)
        
       
     !  IF(MOD(T_ITER,timestep)==0) THEN
     
       IF(MOD(T_ITER,1000)==0) THEN
       	
       	CALL TEC_ITER_NESQ_Vec_3D(T_Iter  , Nx , NY , NZ , X , Y , Z , U , V , W , C_T)      	
     	 ! CALL TEC_NS_CLS_2D(T_Iter , Nx , Ny , X , Y , u , v , p , rho , PHI)
       ENDIF                          
     
       ! PAUSE
   !    IF(MOD(T_ITER,500)==0) THEN
   !      OPEN( UNIT = 222, FILE = "RT.dat", STATUS = "REPLACE" )
   !  !    WRITE(222,*) N
   !     DO K = 1 , NZ
   !     DO J = 1, NY
   !     DO I = 1, NX
   !      WRITE(222,'(8E15.6)') X(I,J,K), Y(I,J,K), Z(I,J,K) , U(I,J,K) , V(I,J,K) , W(I,J,K) &
   !                      & ,P(I,J,K) , PHI(I,J,K)
   !     END DO
   !     END DO
   !     END DO
   !     CLOSE(222)  
   !   ENDIF  
   
      Uc_old2 = Uc_old
      Vc_old2 = Vc_old
      Wc_old2 = Wc_old
      Uc_old = Uc
      Vc_old = Vc
      Wc_old = Wc
      U_old2 = U_old
      V_old2 = V_old
      W_old2 = W_old
      U_old = U
      V_old = V
      W_old = W
      P_old = P
  
      !!!PHI_old = M_PHI  !use modified level set
      PHI_old = PHI
      
      IF(T_Iter== TIMESTOP) EXIT
      
   END DO
     
     
  close(900) 
! close(901)    
 close(902)
 close(903)
! close(904)
! close(9041)
! close(9042)
! close(905)
 close(906) 
 close(907)
! close(908) 
! close(909)  
   
   
   
   
        CALL CPU_TIME(Te)
        
         OPEN(1,FILE='cputime.PLT')
         WRITE(1,*) Te - Ts
         CLOSE(1) 
        
        CLOSE(UNIT=13)
     !   CLOSE(UNIT=14)
        
   
  
  
  


CONTAINS


   INCLUDE 'level_set_redistance_3D.inc'
   INCLUDE 'Level_set_initialize_3D.INC'
   INCLUDE 'level_set_AD_3D.inc'
  
  ! INCLUDE 'TIME_INT_3D.INC'
 !  INCLUDE 'Level_set_initialize_3D_bubble.INC'
 !  INCLUDE 'level_set_redistance_3D_BUBBLE.inc'
 !  INCLUDE 'level_set_AD_3D_BUBBLE.inc'
 !  INCLUDE 'TRIPE_CCD_BACKUP_3D.INC'
 !  INCLUDE 'DATA_ANALYSIS.INC'
   INCLUDE 'weno_scheme.inc'
   INCLUDE 'BC_LS_DC.INC'
   
   INCLUDE 'SCHEME_3D.INC'
   
   INCLUDE 'Twin_CCD_BACKUP_3D.INC' 
   
   
   
!
!  
! SUBROUTINE RHO_Mu_compute(N , M , Dx , FHI , RHO , MU , RHO_GL , MU_GL , He , Hp)
!  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  !Routine to smooth the material coeff. RHO and MU using Heavyside function.
!  !Where RHO_GL and MU_GL means the ratio of gas and fluid.
!  !
!  !If rho for gas = 1/80 , rho for fluid is 1
!  !then RHO_GL = (rho_gas / rho_fluid) = (1/80) / 1 = 1/80.
!  !
!  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
!    
!    INTEGER,INTENT(IN) :: N , M
!    
!    REAL(KIND=DP),INTENT(IN)  :: FHI(:,:) , RHO_GL , MU_GL , Dx
!    REAL(KIND=DP),INTENT(OUT) :: RHO(:,:) , MU(:,:), He(:,:) , HP(:,:)
!    
!    REAL(KIND=DP) :: Temp
!    
!    INTEGER :: I , J
!    
!    DO J = 1 , M
!    DO I = 1 , N
!    	
!       RHO(I,J) = RHO_GL +  (1.0_DP - RHO_GL) * Heavy(FHI(I,J), Dx,Temp)
!      
!      
!    !!!!! A Projection FEM for Variable Density Incompressible Flows 6.2    RT problem
!     ! RHO(I,J) = 1.0_DP +  ( RHO_GL - 1.0_DP) * Heavy(FHI(I,J), Dx,Temp)
!    END DO
!    END DO 
!  
!    DO J = 1 , M
!    DO I = 1 , N
!      MU(I,J) = MU_GL +  (1.0_DP - MU_GL) * Heavy(FHI(I,J), Dx,Temp)
!     
!    !!!!! A Projection FEM for Variable Density Incompressible Flows 6.2    RT problem
!     ! MU(I,J) = 1.0_DP +  (  MU_GL - 1.0_DP) * Heavy(FHI(I,J), Dx,Temp)
!    END DO
!    END DO  
!    
!    DO J = 1 , M
!    DO I = 1 , N
!      He(I,J) = Heavy(FHI(I,J), Dx ,HP(I,J))
!    END DO
!    END DO
!  END SUBROUTINE RHO_Mu_compute  


    SUBROUTINE RHO_Mu_compute(N , M , L , Dx , FHI , RHO , MU , RHO_GL , MU_GL , He , Hp)
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   !Routine to smooth the material coeff. RHO and MU using Heavyside function.
   !Where RHO_GL and MU_GL means the ratio of gas and fluid.
   !
   !If rho for gas = 1/80 , rho for fluid is 1
   !then RHO_GL = (rho_gas / rho_fluid) = (1/80) / 1 = 1/80.
   !
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
     
     INTEGER,INTENT(IN) :: N , M , L
     
     REAL(KIND=DP),INTENT(IN)  :: FHI(:,:,:) , RHO_GL , MU_GL , Dx
     REAL(KIND=DP),INTENT(OUT) :: RHO(:,:,:) , MU(:,:,:), He(:,:,:) , HP(:,:,:)
     
     REAL(KIND=DP) :: Temp
     
     INTEGER :: I , J , K
     
     DO K = 1 , L
     DO J = 1 , M
     DO I = 1 , N
     	
        RHO(I,J,K) = RHO_GL +  (1.0_DP - RHO_GL) * Heavy(FHI(I,J,K), Dx,Temp)
       
     END DO
     END DO 
     END DO
   
     DO K = 1 , L
     DO J = 1 , M
     DO I = 1 , N
       MU(I,J,K) = MU_GL +  (1.0_DP - MU_GL) * Heavy(FHI(I,J,K), Dx,Temp)
      
     END DO
     END DO
     END DO  
     
     DO K = 1 , L
     DO J = 1 , M
     DO I = 1 , N
       He(I,J,K) = Heavy(FHI(I,J,K), Dx ,HP(I,J,K))
     END DO
     END DO
     END DO
     
   END SUBROUTINE RHO_Mu_compute 
  
 
   SUBROUTINE TEC_ITER_NESQ_Vec_3D(Iter , XNode , YNode , ZNode , X , Y , Z , U , V , W , P)
  !-------------------------------------------
  ! TECPLOT 2D
  !-------------------------------------------
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
    
    INTEGER      ,INTENT(IN) :: Iter , XNode , YNode , ZNode
    REAL(KIND=DP),INTENT(IN) :: X(:,:,:) , Y(:,:,:) , Z(:,:,:)
    REAL(KIND=DP),INTENT(IN) :: U(:,:,:) , V(:,:,:) , W(:,:,:) , P(:,:,:) 

    INTEGER                  :: I , J , K
    CHARACTER(6)             :: Name
    

    WRITE(Name,'(I6.6)') Iter
    OPEN( UNIT= 11, FILE='Nesq_3D_'//Name//'_.plt', STATUS= 'UNKNOWN' )
    
    WRITE(11,*) 'TITLE = "Numerical and Exact Solution"'
    WRITE(11,*) 'VARIABLES = "X" "Y" "Z" "U" "V" "W" "P"'
    !-------------------------------------------  
    ! Write out the Numerical solution
    !-------------------------------------------  	
    WRITE(11,*) 'ZONE T= Numerical, I=', XNode, ', J=', YNode, ', K=' , ZNode, ', F= POINT'
    DO K = 1 , ZNode
    DO J = 1, YNode
    DO I = 1, XNode
      WRITE(11,'(7E15.6)') X(I,J,K), Y(I,J,K), Z(I,J,K) , U(I,J,K) , V(I,J,K) , W(I,J,K) &
                         & ,P(I,J,K)
    END DO
    END DO
    END DO
    
    CLOSE(UNIT=11)
    
  END SUBROUTINE TEC_ITER_NESQ_Vec_3D
  
  SUBROUTINE BC_3D_P1(Nx,Ny,Nz,P, RHO)
  
  INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
  INTEGER :: I,J,K
  REAL(KIND=DP),INTENT(INOUT) :: P(:,:,:)
  REAL(KIND=DP),INTENT(IN) :: RHO(:,:,:)
  INTEGER,INTENT(IN) :: Nx , Ny , NZ
 
  
  DO J=1,Ny-1
  DO I=1,Nx-1
  	
  	P(I,J,1) = P(I,J,2) ! - MO_P * ( RHO(I,J,2)-RHO(I,J,1) )
  	P(I,J,Nz) = P(I,J,Nz-1) !- ( RHO(I,J,Ny)-RHO(I,J,Ny-1) )
  	
  	END DO
  	END DO
  			
  
  DO K=1,Nz-1
  DO J=1,Ny-1
  		
  	P(1,J,K)  =P(2,J,K)!- ( RHO(2,J,K)-RHO(1,J,K) )
  	P(Nx,J,K) =P(Nx-1,J,K)!- ( RHO(Nx,J,K)-RHO(Nx-1,J,K) )
  	
  	END DO
  	END DO
  		
  DO K=1,Nz-1
  DO I=1,Nx-1
  	 
    P(I,1,K)  = P(I,2,K)!- ( RHO(I,2,K)-RHO(I,1,K) )
    P(I,Ny,K) = P(I,Ny-1,K) !- ( RHO(I,Ny,K)-RHO(I,Ny-1,K) )
  
  END DO
  END DO
  			
END SUBROUTINE



END PROGRAM FV_CD_2D