SUBROUTINE ANAYLSIS( Nx, Ny, Nz, T_Iter, P, PHI, PHI_X, PHI_Y, PHI_Z, DX, DY, DZ, timestep)
INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
INTEGER,INTENT(IN) :: Nx, Ny, Nz, T_Iter, timestep
REAL(KIND=DP),INTENT(IN) :: PHI(:,:,:), PHI_X(:,:,:), PHI_Y(:,:,:), PHI_Z(:,:,:), P(:,:,:), DY, DZ, DX
INTEGER :: T, I, J, K, NUM(Nx,Ny,Nz), D
REAL(KIND=DP) :: A(Nx,Ny,Nz), NF_ZZ(Nx,Ny,Nz), NF_Z, SA, FP, FU, FD



IF( T_Iter == 1) THEN
OPEN(200,FILE='NetForce.csv')
END IF

!! reset

DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
	
	A(I,J,K) = 0.0_DP
	NF_ZZ(I,J,K) = 0.0_DP
	
END DO
END DO
END DO

!! compute area

DO K = 1, Nz-1
DO J = 1, Ny-1
DO I = 1, Nx-1
	
IF( ABS( PHI_Z(I,J,K)/( 1.0E-15_DP + SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) ) ) >= 1.0_DP ) THEN 

	IF( PHI(I,J,K) * PHI(I,J,K+1) < 0.0_DP ) THEN
	IF( PHI(I,J,K) > 0.0_DP ) THEN
		
	IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Z(I,J,K) ) )THEN
	IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
		A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) &
		         * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))
		         
	ELSEIF( ABS(PHI_X(I,J,K)) < ABS(PHI_Y(I,J,K)) )THEN
		A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) &
		         * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))
		 	        END IF
  ELSEIF( ABS(PHI_X(I,J,K)) < ABS(PHI_Z(I,J,K)) )THEN
 	IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
		A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) &
		         * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))
		         
	ELSEIF( ABS(PHI_X(I,J,K)) < ABS(PHI_Y(I,J,K)) )THEN
		A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) &
		         * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))
		          END IF
		          END IF
		         
  ELSEIF( PHI(I,J,K) < 0.0_DP ) THEN
  	
	IF( ABS( PHI_X(I,J,K+1) ) >= ABS( PHI_Z(I,J,K+1) ) )THEN
	IF( ABS( PHI_X(I,J,K+1) ) >= ABS( PHI_Y(I,J,K+1) ) )THEN
		A(I,J,K+1) = DY * SQRT(PHI_X(I,J,K+1)**2+PHI_Y(I,J,K+1)**2) / ABS(PHI_X(I,J,K+1)) &
		         * DZ * SQRT(PHI_X(I,J,K+1)**2+PHI_Z(I,J,K+1)**2) / ABS(PHI_X(I,J,K+1))
		         
	ELSEIF( ABS(PHI_X(I,J,K+1)) < ABS(PHI_Y(I,J,K+1)) )THEN
		A(I,J,K+1) = DY * SQRT(PHI_X(I,J,K+1)**2+PHI_Y(I,J,K+1)**2) / ABS(PHI_Y(I,J,K+1)) &
		         * DZ * SQRT(PHI_X(I,J,K+1)**2+PHI_Z(I,J,K+1)**2) / ABS(PHI_X(I,J,K+1))
		 	        END IF
  ELSEIF( ABS(PHI_X(I,J,K+1)) < ABS(PHI_Z(I,J,K+1)) )THEN
 	IF( ABS( PHI_X(I,J,K+1) ) >= ABS( PHI_Y(I,J,K+1) ) )THEN
		A(I,J,K+1) = DY * SQRT(PHI_X(I,J,K+1)**2+PHI_Y(I,J,K+1)**2) / ABS(PHI_X(I,J,K+1)) &
		         * DZ * SQRT(PHI_X(I,J,K+1)**2+PHI_Z(I,J,K+1)**2) / ABS(PHI_Z(I,J,K+1))
		         
	ELSEIF( ABS(PHI_X(I,J,K+1)) < ABS(PHI_Y(I,J,K+1)) )THEN
		A(I,J,K+1) = DY * SQRT(PHI_X(I,J,K+1)**2+PHI_Y(I,J,K+1)**2) / ABS(PHI_Y(I,J,K+1)) &
		         * DZ * SQRT(PHI_X(I,J,K+1)**2+PHI_Z(I,J,K+1)**2) / ABS(PHI_Z(I,J,K+1))
		          END IF
		          END IF
	END IF
	END IF
	
ELSEIF( ABS( PHI_Z(I,J,K)/( 1.0E-15_DP + SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) ) ) < 1.0_DP ) THEN
	
	 IF( ABS(PHI_X(I,J,K)) > ABS(PHI_Y(I,J,K)) ) THEN
		
		  IF( PHI(I,J,K) * PHI(I+1,J,K) < 0.0_DP ) THEN
			   IF( PHI(I,J,K)> 0.0_DP )THEN
			   	
	       IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Z(I,J,K) ) )THEN
	       IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
			      A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))             
			   ELSEIF( ABS( PHI_X(I,J,K) ) < ABS( PHI_Y(I,J,K) ) )THEN 
			   	  A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))    
			   	                END IF
			   ELSEIF( ABS( PHI_X(I,J,K)) < ABS(PHI_Z(I,J,K)) )THEN
			   IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
			      A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))             
			   ELSEIF( ABS( PHI_X(I,J,K) ) < ABS( PHI_Y(I,J,K) ) )THEN 
			   	  A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))    
			   	              END IF
			   	              END IF
			   
			   
			   	                       
			   ELSEIF( PHI(I,J,K) < 0.0_DP ) THEN
			   	
	       IF( ABS( PHI_X(I+1,J,K) ) >= ABS( PHI_Z(I+1,J,K) ) )THEN
	       IF( ABS( PHI_X(I+1,J,K) ) >= ABS( PHI_Y(I+1,J,K) ) )THEN
			      A(I+1,J,K) = DY * SQRT(PHI_X(I+1,J,K)**2+PHI_Y(I+1,J,K)**2) / ABS(PHI_X(I+1,J,K)) & 
			               * DZ * SQRT(PHI_X(I+1,J,K)**2+PHI_Z(I+1,J,K)**2) / ABS(PHI_X(I+1,J,K))             
			   ELSEIF( ABS( PHI_X(I+1,J,K) ) < ABS( PHI_Y(I+1,J,K) ) )THEN               
			   	  A(I+1,J,K) = DY * SQRT(PHI_X(I+1,J,K)**2+PHI_Y(I+1,J,K)**2) / ABS(PHI_Y(I+1,J,K)) & 
			               * DZ * SQRT(PHI_X(I+1,J,K)**2+PHI_Z(I+1,J,K)**2) / ABS(PHI_X(I+1,J,K))    
			   	                END IF                                               
			   ELSEIF( ABS( PHI_X(I+1,J,K)) < ABS(PHI_Z(I+1,J,K)) )THEN                  
			   IF( ABS( PHI_X(I+1,J,K) ) >= ABS( PHI_Y(I+1,J,K) ) )THEN                  
			      A(I+1,J,K) = DY * SQRT(PHI_X(I+1,J,K)**2+PHI_Y(I+1,J,K)**2) / ABS(PHI_X(I+1,J,K)) & 
			               * DZ * SQRT(PHI_X(I+1,J,K)**2+PHI_Z(I+1,J,K)**2) / ABS(PHI_Z(I+1,J,K))             
			   ELSEIF( ABS( PHI_X(I,J,K) ) < ABS( PHI_Y(I,J,K) ) )THEN 
			   	  A(I+1,J,K) = DY * SQRT(PHI_X(I+1,J,K)**2+PHI_Y(I+1,J,K)**2) / ABS(PHI_Y(I+1,J,K)) & 
			               * DZ * SQRT(PHI_X(I+1,J,K)**2+PHI_Z(I+1,J,K)**2) / ABS(PHI_Z(I+1,J,K))  
			                    END IF
			                    END IF
			END IF
			END IF		
			                      
	 ELSEIF( ABS( PHI_X(I,J,K) / PHI_Y(I,J,K) ) < 1.0_DP )THEN
	 	
		  IF( PHI(I,J,K) * PHI(I,J+1,K) < 0.0_DP ) THEN
			  IF( PHI(I,J,K) > 0.0_DP ) THEN
			  	
	       IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Z(I,J,K) ) )THEN
	       IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
			      A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))             
			   ELSEIF( ABS( PHI_X(I,J,K) ) < ABS( PHI_Y(I,J,K) ) )THEN 
			   	  A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))    
			   	                END IF
			   ELSEIF( ABS( PHI_X(I,J,K)) < ABS(PHI_Z(I,J,K)) )THEN
			   IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
			      A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))             
			   ELSEIF( ABS( PHI_X(I,J,K) ) < ABS( PHI_Y(I,J,K) ) )THEN 
			   	  A(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))    
			   	              END IF
			   	              END IF
                    
        ELSEIF( PHI(I,J,K) < 0.0_DP )THEN    
        	      
	       IF( ABS( PHI_X(I,J+1,K) ) >= ABS( PHI_Z(I,J+1,K) ) )THEN
	       IF( ABS( PHI_X(I,J+1,K) ) >= ABS( PHI_Y(I,J+1,K) ) )THEN
			      A(I,J+1,K) = DY * SQRT(PHI_X(I,J+1,K)**2+PHI_Y(I,J+1,K)**2) / ABS(PHI_X(I,J+1,K)) & 
			               * DZ * SQRT(PHI_X(I,J+1,K)**2+PHI_Z(I,J+1,K)**2) / ABS(PHI_X(I,J+1,K))             
			   ELSEIF( ABS( PHI_X(I,J+1,K) ) < ABS( PHI_Y(I,J+1,K) ) )THEN 
			   	  A(I,J+1,K) = DY * SQRT(PHI_X(I,J+1,K)**2+PHI_Y(I,J+1,K)**2) / ABS(PHI_Y(I,J+1,K)) & 
			               * DZ * SQRT(PHI_X(I,J+1,K)**2+PHI_Z(I,J+1,K)**2) / ABS(PHI_X(I,J+1,K))    
			   	                END IF
			   ELSEIF( ABS( PHI_X(I,J+1,K)) < ABS(PHI_Z(I,J+1,K)) )THEN
			   IF( ABS( PHI_X(I,J+1,K) ) >= ABS( PHI_Y(I,J+1,K) ) )THEN
			      A(I,J+1,K) = DY * SQRT(PHI_X(I,J+1,K)**2+PHI_Y(I,J+1,K)**2) / ABS(PHI_X(I,J+1,K)) & 
			               * DZ * SQRT(PHI_X(I,J+1,K)**2+PHI_Z(I,J+1,K)**2) / ABS(PHI_Z(I,J+1,K))             
			   ELSEIF( ABS( PHI_X(I,J+1,K) ) < ABS( PHI_Y(I,J+1,K) ) )THEN 
			   	  A(I,J+1,K) = DY * SQRT(PHI_X(I,J+1,K)**2+PHI_Y(I,J+1,K)**2) / ABS(PHI_Y(I,J+1,K)) & 
			               * DZ * SQRT(PHI_X(I,J+1,K)**2+PHI_Z(I,J+1,K)**2) / ABS(PHI_Z(I,J+1,K))    
			   	              END IF
			   	              END IF
           
        END IF
        END IF
        END IF
        END IF
              
        END DO
        END DO
        END DO

!! compute net force


DO K = 2, Nz-1
DO J = 1, Ny-1
DO I = 1, Nx-1
	
IF( ABS(PHI_Z(I,J,K)) >= SQRT( PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) ) THEN 

	IF( PHI(I,J,K) * PHI(I,J,K+1) < 0.0_DP ) THEN
	IF( PHI(I,J,K) > 0.0_DP ) THEN
		
		NF_ZZ(I,J,K) = - PHI_Z(I,J,K)/ABS(PHI_Z(I,J,K)) & 
		               * ( P(I,J,K) - P(I,J,K+1) ) * A(I,J,K) &
		                * ABS(PHI_Z(I,J,K)) / SQRT( PHI_X(I,J,K)**2 + PHI_Y(I,J,K)**2 + PHI_Z(I,J,K)**2 )
		             
  ELSEIF( PHI(I,J,K) < 0.0_DP ) THEN
  	NF_ZZ(I,J,K+1) = - PHI_Z(I,J,K+1)/ABS(PHI_Z(I,J,K+1)) & 
		                * ( P(I,J,K+1) - P(I,J,K) ) * A(I,J,K+1) &
		                * ABS(PHI_Z(I,J,K+1)) / SQRT( PHI_X(I,J,K+1)**2 + PHI_Y(I,J,K+1)**2 + PHI_Z(I,J,K+1)**2 )
		          
	END IF
	END IF
	
ELSEIF( ABS( PHI_Z(I,J,K)) < SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) ) THEN
	
	 IF( ABS( PHI_X(I,J,K)) >= ABS(PHI_Y(I,J,K)) ) THEN
		
		  IF( PHI(I,J,K) * PHI(I+1,J,K) < 0.0_DP ) THEN
			   IF( PHI(I,J,K)> 0.0_DP )THEN
			      NF_ZZ(I,J,K) = - PHI_Z(I,J,K)/ABS(PHI_Z(I,J,K)) & 
		               * ( P(I,J,K) - P(I+1,J,K) ) * A(I,J,K) &
		                * ABS(PHI_Z(I,J,K)) / SQRT( PHI_X(I,J,K)**2 + PHI_Y(I,J,K)**2 + PHI_Z(I,J,K)**2 )
			               
			   ELSEIF( PHI(I,J,K) < 0.0_DP ) THEN
			      NF_ZZ(I+1,J,K) = - PHI_Z(I+1,J,K)/ABS(PHI_Z(I+1,J,K)) & 
		                *( P(I+1,J,K) - P(I,J,K) ) * A(I+1,J,K) &
		                * ABS(PHI_Z(I+1,J,K)) / SQRT( PHI_X(I+1,J,K)**2 + PHI_Y(I+1,J,K)**2 + PHI_Z(I+1,J,K)**2 )
			
			END IF
			END IF		
			                      
	 ELSEIF( ABS(PHI_X(I,J,K) < ABS(PHI_Y(I,J,K)) ) )THEN
	 	
		  IF( PHI(I,J,K) * PHI(I,J+1,K) < 0.0_DP ) THEN
			  IF( PHI(I,J,K) > 0.0_DP ) THEN
			     NF_ZZ(I,J,K) = - PHI_Z(I,J,K)/ABS(PHI_Z(I,J,K)) & 
		               * ( P(I,J,K) - P(I,J+1,K) ) * A(I,J,K) &
		                * ABS(PHI_Z(I,J,K)) / SQRT( PHI_X(I,J,K)**2 + PHI_Y(I,J,K)**2 + PHI_Z(I,J,K)**2 )
                    
        ELSEIF( PHI(I,J,K) < 0.0_DP )THEN          
	         NF_ZZ(I,J+1,K) = - PHI_Z(I,J+1,K)/ABS(PHI_Z(I,J+1,K)) & 
		               * ( P(I,J+1,K) - P(I,J,K) ) * A(I,J+1,K) &
		                * ABS(PHI_Z(I,J+1,K)) / SQRT( PHI_X(I,J+1,K)**2 + PHI_Y(I,J+1,K)**2 + PHI_Z(I,J+1,K)**2 )
           
        END IF
        END IF
        END IF
        END IF
              
        END DO
        END DO
        END DO


DO J = 1, Ny
DO I = 1, Nx
	
	IF( PHI(I,J,1) > 0.0_DP ) THEN
		
	NF_ZZ(I,J,1) = P(I,J,K) * DY * DX

   END IF

END DO
END DO

!! integral

DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
	
	NF_Z = NF_Z + NF_ZZ(I,J,K)
	
END DO
END DO
END DO

!! write data

IF( MOD(T_Iter,timestep)==1) THEN

  WRITE(200,*) NF_Z

END IF

END SUBROUTINE 
	
SUBROUTINE TOTAL_ENERGY(Nx, Ny, Nz, T_Iter,PHI, PHI_X, PHI_Y, PHI_Z, P, DX, DY, DZ, DT, U, V, W, ANGC, RRR, RHO, MU_l, timestep)
IMPLICIT NONE
INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
REAL(KIND=DP),PARAMETER :: PI = 3.141592653589793_DP
INTEGER,INTENT(IN) :: Nx, Ny, Nz, T_Iter, timestep
INTEGER :: I, J, K
REAL(KIND=DP),INTENT(IN) :: PHI(:,:,:), PHI_X(:,:,:), PHI_Y(:,:,:), PHI_Z(:,:,:), P(:,:,:), DY, DZ, DX, DT
REAL(KIND=DP),INTENT(IN) :: U(:,:,:), V(:,:,:), W(:,:,:), ANGC, RRR, RHO(:,:,:), MU_l
REAL(KIND=DP) :: SA_VL, SA_SL, ST_VL, ST_SLSV, SA_IVL, SA_ISL
REAL(KIND=DP) :: SSA_VL(Nx,Ny,Nz), SSA_SL(Nx,Ny,Nz), DE_SA
REAL(KIND=DP) :: KKE(Nx,Ny,Nz), DE_KE, KE, PPE(Nx,Ny,Nz), PE, DE_PE, IPE, M
REAL(KIND=DP) :: U_X(Nx,Ny,Nz),U_Y(Nx,Ny,Nz),U_Z(Nx,Ny,Nz)
REAL(KIND=DP) :: V_X(Nx,Ny,Nz),V_Y(Nx,Ny,Nz),V_Z(Nx,Ny,Nz)
REAL(KIND=DP) :: W_X(Nx,Ny,Nz),W_Y(Nx,Ny,Nz),W_Z(Nx,Ny,Nz)
REAL(KIND=DP) :: PHI_VS(Nx,Ny,Nz), VS_TO, DE_VS, DE_VSOLD

SA_IVL = 2.0_DP * ( 4.0_DP*RRR**2*PI*( (1.0_DP - COS(ANGC) ) / 2.0_DP))
SA_ISL = 2.0_DP * ( RRR**2*COS( ANGC- 0.5_DP*PI)**2*PI )

ST_VL = 0.07423_DP
ST_SLSV = - ST_VL * COS(ANGC)


!!!! reset 

DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
	
	SSA_VL(I,J,K) = 0.0_DP
	SSA_SL(I,J,K) = 0.0_DP
	KKE(I,J,K) = 0.0_DP
	PPE(I,J,K) = 0.0_DP
	
END DO
END DO
END DO

!!! compute surface energy S L V

DO K = 2, Nz-1
DO J = 1, Ny-1
DO I = 1, Nx-1
	
IF( ABS( PHI_Z(I,J,K)/( 1.0E-15_DP + SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) ) ) >= 1.0_DP ) THEN 

	IF( PHI(I,J,K) * PHI(I,J,K+1) < 0.0_DP ) THEN
	IF( PHI(I,J,K) > 0.0_DP ) THEN
		
	IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Z(I,J,K) ) )THEN
	IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
		SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) &
		         * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))
		         
	ELSEIF( ABS(PHI_X(I,J,K)) < ABS(PHI_Y(I,J,K)) )THEN
		SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) &
		         * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))
		 	        END IF
  ELSEIF( ABS(PHI_X(I,J,K)) < ABS(PHI_Z(I,J,K)) )THEN
 	IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
		SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) &
		         * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))
		         
	ELSEIF( ABS(PHI_X(I,J,K)) < ABS(PHI_Y(I,J,K)) )THEN
		SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) &
		         * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))
		          END IF
		          END IF
		         
  ELSEIF( PHI(I,J,K) < 0.0_DP ) THEN
  	
	IF( ABS( PHI_X(I,J,K+1) ) >= ABS( PHI_Z(I,J,K+1) ) )THEN
	IF( ABS( PHI_X(I,J,K+1) ) >= ABS( PHI_Y(I,J,K+1) ) )THEN
		SSA_VL(I,J,K+1) = DY * SQRT(PHI_X(I,J,K+1)**2+PHI_Y(I,J,K+1)**2) / ABS(PHI_X(I,J,K+1)) &
		         * DZ * SQRT(PHI_X(I,J,K+1)**2+PHI_Z(I,J,K+1)**2) / ABS(PHI_X(I,J,K+1))
		         
	ELSEIF( ABS(PHI_X(I,J,K+1)) < ABS(PHI_Y(I,J,K+1)) )THEN
		SSA_VL(I,J,K+1) = DY * SQRT(PHI_X(I,J,K+1)**2+PHI_Y(I,J,K+1)**2) / ABS(PHI_Y(I,J,K+1)) &
		         * DZ * SQRT(PHI_X(I,J,K+1)**2+PHI_Z(I,J,K+1)**2) / ABS(PHI_X(I,J,K+1))
		 	        END IF
  ELSEIF( ABS(PHI_X(I,J,K+1)) < ABS(PHI_Z(I,J,K+1)) )THEN
 	IF( ABS( PHI_X(I,J,K+1) ) >= ABS( PHI_Y(I,J,K+1) ) )THEN
		SSA_VL(I,J,K+1) = DY * SQRT(PHI_X(I,J,K+1)**2+PHI_Y(I,J,K+1)**2) / ABS(PHI_X(I,J,K+1)) &
		         * DZ * SQRT(PHI_X(I,J,K+1)**2+PHI_Z(I,J,K+1)**2) / ABS(PHI_Z(I,J,K+1))
		         
	ELSEIF( ABS(PHI_X(I,J,K+1)) < ABS(PHI_Y(I,J,K+1)) )THEN
		SSA_VL(I,J,K+1) = DY * SQRT(PHI_X(I,J,K+1)**2+PHI_Y(I,J,K+1)**2) / ABS(PHI_Y(I,J,K+1)) &
		         * DZ * SQRT(PHI_X(I,J,K+1)**2+PHI_Z(I,J,K+1)**2) / ABS(PHI_Z(I,J,K+1))
		          END IF
		          END IF
	END IF
	END IF
	
ELSEIF( ABS( PHI_Z(I,J,K)/( 1.0E-15_DP + SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) ) ) < 1.0_DP ) THEN
	
	 IF( ABS(PHI_X(I,J,K)) > ABS(PHI_Y(I,J,K)) ) THEN
		
		  IF( PHI(I,J,K) * PHI(I+1,J,K) < 0.0_DP ) THEN
			   IF( PHI(I,J,K)> 0.0_DP )THEN
			   	
	       IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Z(I,J,K) ) )THEN
	       IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
			      SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))             
			   ELSEIF( ABS( PHI_X(I,J,K) ) < ABS( PHI_Y(I,J,K) ) )THEN 
			   	  SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))    
			   	                END IF
			   ELSEIF( ABS( PHI_X(I,J,K)) < ABS(PHI_Z(I,J,K)) )THEN
			   IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
			      SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))             
			   ELSEIF( ABS( PHI_X(I,J,K) ) < ABS( PHI_Y(I,J,K) ) )THEN 
			   	  SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))    
			   	              END IF
			   	              END IF
			   
			   
			   	                       
			   ELSEIF( PHI(I,J,K) < 0.0_DP ) THEN
			   	
	       IF( ABS( PHI_X(I+1,J,K) ) >= ABS( PHI_Z(I+1,J,K) ) )THEN
	       IF( ABS( PHI_X(I+1,J,K) ) >= ABS( PHI_Y(I+1,J,K) ) )THEN
			     SSA_VL(I+1,J,K) = DY * SQRT(PHI_X(I+1,J,K)**2+PHI_Y(I+1,J,K)**2) / ABS(PHI_X(I+1,J,K)) & 
			               * DZ * SQRT(PHI_X(I+1,J,K)**2+PHI_Z(I+1,J,K)**2) / ABS(PHI_X(I+1,J,K))             
			   ELSEIF( ABS( PHI_X(I+1,J,K) ) < ABS( PHI_Y(I+1,J,K) ) )THEN               
			   	  SSA_VL(I+1,J,K) = DY * SQRT(PHI_X(I+1,J,K)**2+PHI_Y(I+1,J,K)**2) / ABS(PHI_Y(I+1,J,K)) & 
			               * DZ * SQRT(PHI_X(I+1,J,K)**2+PHI_Z(I+1,J,K)**2) / ABS(PHI_X(I+1,J,K))    
			   	                END IF                                               
			   ELSEIF( ABS( PHI_X(I+1,J,K)) < ABS(PHI_Z(I+1,J,K)) )THEN                  
			   IF( ABS( PHI_X(I+1,J,K) ) >= ABS( PHI_Y(I+1,J,K) ) )THEN                  
			      SSA_VL(I+1,J,K) = DY * SQRT(PHI_X(I+1,J,K)**2+PHI_Y(I+1,J,K)**2) / ABS(PHI_X(I+1,J,K)) & 
			               * DZ * SQRT(PHI_X(I+1,J,K)**2+PHI_Z(I+1,J,K)**2) / ABS(PHI_Z(I+1,J,K))             
			   ELSEIF( ABS( PHI_X(I,J,K) ) < ABS( PHI_Y(I,J,K) ) )THEN 
			   	  SSA_VL(I+1,J,K) = DY * SQRT(PHI_X(I+1,J,K)**2+PHI_Y(I+1,J,K)**2) / ABS(PHI_Y(I+1,J,K)) & 
			               * DZ * SQRT(PHI_X(I+1,J,K)**2+PHI_Z(I+1,J,K)**2) / ABS(PHI_Z(I+1,J,K))  
			                    END IF
			                    END IF
			END IF
			END IF		
			                      
	 ELSEIF( ABS( PHI_X(I,J,K) / PHI_Y(I,J,K) ) < 1.0_DP )THEN
	 	
		  IF( PHI(I,J,K) * PHI(I,J+1,K) < 0.0_DP ) THEN
			  IF( PHI(I,J,K) > 0.0_DP ) THEN
			  	
	       IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Z(I,J,K) ) )THEN
	       IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
			     SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))             
			   ELSEIF( ABS( PHI_X(I,J,K) ) < ABS( PHI_Y(I,J,K) ) )THEN 
			   	  SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_X(I,J,K))    
			   	                END IF
			   ELSEIF( ABS( PHI_X(I,J,K)) < ABS(PHI_Z(I,J,K)) )THEN
			   IF( ABS( PHI_X(I,J,K) ) >= ABS( PHI_Y(I,J,K) ) )THEN
			      SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_X(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))             
			   ELSEIF( ABS( PHI_X(I,J,K) ) < ABS( PHI_Y(I,J,K) ) )THEN 
			   	  SSA_VL(I,J,K) = DY * SQRT(PHI_X(I,J,K)**2+PHI_Y(I,J,K)**2) / ABS(PHI_Y(I,J,K)) & 
			               * DZ * SQRT(PHI_X(I,J,K)**2+PHI_Z(I,J,K)**2) / ABS(PHI_Z(I,J,K))    
			   	              END IF
			   	              END IF
                    
        ELSEIF( PHI(I,J,K) < 0.0_DP )THEN    
        	      
	       IF( ABS( PHI_X(I,J+1,K) ) >= ABS( PHI_Z(I,J+1,K) ) )THEN
	       IF( ABS( PHI_X(I,J+1,K) ) >= ABS( PHI_Y(I,J+1,K) ) )THEN
			      SSA_VL(I,J+1,K) = DY * SQRT(PHI_X(I,J+1,K)**2+PHI_Y(I,J+1,K)**2) / ABS(PHI_X(I,J+1,K)) & 
			               * DZ * SQRT(PHI_X(I,J+1,K)**2+PHI_Z(I,J+1,K)**2) / ABS(PHI_X(I,J+1,K))             
			   ELSEIF( ABS( PHI_X(I,J+1,K) ) < ABS( PHI_Y(I,J+1,K) ) )THEN 
			   	  SSA_VL(I,J+1,K) = DY * SQRT(PHI_X(I,J+1,K)**2+PHI_Y(I,J+1,K)**2) / ABS(PHI_Y(I,J+1,K)) & 
			               * DZ * SQRT(PHI_X(I,J+1,K)**2+PHI_Z(I,J+1,K)**2) / ABS(PHI_X(I,J+1,K))    
			   	                END IF
			   ELSEIF( ABS( PHI_X(I,J+1,K)) < ABS(PHI_Z(I,J+1,K)) )THEN
			   IF( ABS( PHI_X(I,J+1,K) ) >= ABS( PHI_Y(I,J+1,K) ) )THEN
			      SSA_VL(I,J+1,K) = DY * SQRT(PHI_X(I,J+1,K)**2+PHI_Y(I,J+1,K)**2) / ABS(PHI_X(I,J+1,K)) & 
			               * DZ * SQRT(PHI_X(I,J+1,K)**2+PHI_Z(I,J+1,K)**2) / ABS(PHI_Z(I,J+1,K))             
			   ELSEIF( ABS( PHI_X(I,J+1,K) ) < ABS( PHI_Y(I,J+1,K) ) )THEN 
			   	  SSA_VL(I,J+1,K) = DY * SQRT(PHI_X(I,J+1,K)**2+PHI_Y(I,J+1,K)**2) / ABS(PHI_Y(I,J+1,K)) & 
			               * DZ * SQRT(PHI_X(I,J+1,K)**2+PHI_Z(I,J+1,K)**2) / ABS(PHI_Z(I,J+1,K))    
			   	              END IF
			   	              END IF
           
        END IF
        END IF
        END IF
        END IF
              
        END DO
        END DO
        END DO



DO J = 1, Ny-1
DO I = 1, Nx-1
	
	IF( ABS( PHI_X(I,J,1)/PHI_Y(I,J,1) ) >= 1.0_DP )THEN
		IF( PHI(I,J,1)*PHI(I+1,J,1) < 0.0_DP )THEN
			IF( PHI(I,J,1) > 0.0_DP )THEN
				SSA_SL(I,J,1) = 0.5_DP * DY**2 * ABS( PHI_Y(I,J,1) / SQRT(PHI_X(I,J,1)**2+PHI_Y(I,J,1)**2))
		  ELSEIF( PHI(I,J,1) < 0.0_DP )THEN
		  	SSA_SL(I+1,J,1) = 0.5_DP * DY**2 * ABS( PHI_Y(I+1,J,1) / SQRT(PHI_X(I+1,J,1)**2+PHI_Y(I+1,J,1)**2))
		  END IF
		 END IF
		  	
	ELSEIF( ABS( PHI_X(I,J,1)/PHI_Y(I,J,1) ) < 1.0_DP ) THEN
    IF( PHI(I,J,1)*PHI(I,J+1,1) < 0.0_DP )THEN
    	IF( PHI(I,J,1) > 0.0_DP )THEN
    		SSA_SL(I,J,1) = 0.5_DP * DY**2 * ABS( PHI_Y(I,J,1) / SQRT(PHI_X(I,J,1)**2+PHI_Y(I,J,1)**2))
    	ELSEIF( PHI(I,J,1) < 0.0_DP )THEN
    		SSA_SL(I,J+1,1) = 0.5_DP * DY**2 * ABS( PHI_Y(I,J+1,1) / SQRT(PHI_X(I,J+1,1)**2+PHI_Y(I,J+1,1)**2))	
	    END IF
	  END IF
	END IF
	
END DO
END DO
		
DO J = 1, Ny
DO I = 1, Nx
	
	IF( PHI(I,J,1)*PHI(I+1,J,1) > 0.0_DP ) THEN
		IF( PHI(I,J,1) > 0.0_DP )THEN
			
			SSA_SL(I,J,1) = DX * DY
			SSA_SL(I+1,J,1) = DX * DY
		 	
			 	END IF
			 	END IF
			 	
END DO
END DO
			 			
		
	
SA_VL = 0.0_DP
SA_SL = 0.0_DP
		
DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
	
	SA_VL = SA_VL + SSA_VL(I,J,K) 
	SA_SL = SA_SL + SSA_SL(I,J,K)
	
END DO
END DO
END DO 	 

!! uOn(L]

 DE_SA =  ST_VL * ( SA_VL - SA_IVL ) + ST_SLSV * ( SA_SL - SA_ISL ) 
 
 !!!!!!!!!!!!!!!!!! compute kinetic energy
 
 
DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
	
	IF( PHI(I,J,K) > 0.0_DP ) THEN
		KKE(I,J,K) = 0.5_DP*DX*DY*DZ*(U(I,J,K)**2+V(I,J,K)**2+W(I,J,K)**2)*RHO(I,J,K)
	END IF
	 	
END DO
END DO
END DO

KE = 0.0_DP

DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
	
	KE = KE + KKE(I,J,K)
	
END DO
END DO
END DO


DE_KE = KE


!!!!!!!!!!!! compute	potential energy


IPE = 2.0_DP * 1000.0_DP * 4.0_DP / 3.0_DP * 0.5_DP**3 * PI * 0.5_DP * 9.8_DP
M = 2.0_DP * 1000.0_DP * 4.0_DP / 3.0_DP * 0.5_DP**3 * PI

DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
	
 IF( PHI(I,J,K) > 0.0_DP ) THEN
 	PPE(I,J,K) = 1000.0_DP*DX*DY*DZ*RHO(I,J,K)*REAL(K,DP)*9.8_DP 
 END IF
 
END DO
END DO
END DO

PE = 0.0_DP

DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
	
	PE = PE + PPE(I,J,K)
	
END DO
END DO
END DO

DE_PE = PE - IPE

!!!!!!!!!!!! viscous dissipations
!
! CALL GRAD(NX, NY, NZ, DX, DY, DZ, U, U_X, U_Y, U_Z)
! CALL GRAD(NX, NY, NZ, DX, DY, DZ, V, V_X, V_Y, V_Z)
! CALL GRAD(NX, NY, NZ, DX, DY, DZ, W, W_X, W_Y, W_Z)
! 
!	
!DO K = 1, Nz
!DO J = 1, Ny
!DO I = 1, Nx
!
!IF( PHI(I,J,K) > 0.0_DP ) THEN
!		
!	PHI_VS(I,J,K)  = 2.0_DP* MU_L * ( U_X(I,J,K)**2+V_Y(I,J,K)**2+W_Z(I,J,K)**2 &
!	                     +  0.5_DP* (V_X(I,J,K)+U_Y(I,J,K))**2&
!	                     +  0.5_DP* (W_Y(I,J,K)+V_Z(I,J,K))**2&
!	                     +  0.5_DP* (U_Z(I,J,K)+W_X(I,J,K))**2 ) *DX*DY*DZ
!	                     
!ELSEIF( PHI(I,J,K)<0.0_DP) THEN
!	
!	PHI_VS(I,J,K) = 0.0_DP
!
!END IF
!
!END DO
!END DO
!END DO
!
!
!VS_TO = 0.0_DP
!
!DO K = 1, Nz
!DO J = 1, Ny
!DO I = 1, Nx
!	
!	VS_TO = VS_TO + PHI_VS(I,J,K)
!	
!END DO
!END DO
!END DO
!
!IF( VS_TO < 0.0_DP )THEN
!	STOP
!END IF
!
!
!DE_VS = DE_VS + VS_TO * DT
!		
!!write(*,*) 'de_vs =',de_vs

!!!!!!!!! OUTPUT DATA

IF( T_Iter == 1 ) THEN
	OPEN(71,FILE='SurfaceEvoSL.csv')
	OPEN(72,FILE='SurfaceEvoVL.csv')
	OPEN(73,file='SurfaceEneEvo.csv')
	OPEN(74,file='KineEvo.csv')
	OPEN(75,file='PotentEvo.csv')
	OPEN(76,file='ViscEvo.csv')
END IF

IF( MOD(T_Iter,timestep)==1 ) THEN
	WRITE(71,*)SA_SL
	WRITE(72,*)SA_VL
	WRITE(73,*)DE_SA
	WRITE(74,*)DE_KE
	WRITE(75,*)DE_PE


END IF
	


END SUBROUTINE

SUBROUTINE GRAD(NX, NY, NZ, DX, DY, DZ, U, U_X, U_Y, U_Z)
IMPLICIT NONE
INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
REAL(KIND=DP),PARAMETER :: PI = 3.141592653589793_DP
REAL(KIND=DP), INTENT(IN) ::  U(:,:,:), DX, DY, DZ
REAL(KIND=DP), INTENT(INOUT) :: U_X(:,:,:), U_Y(:,:,:), U_Z(:,:,:)
INTEGER, INTENT(IN) :: NX, NY, NZ
INTEGER :: I, J, K

DO K = 2, NZ-1
DO J = 2, NY-1
DO I = 2, NX-1
	
	U_X(I,J,K) = 0.5_DP * ( U(I+1,J,K)-U(I-1,J,K) )/DX
	U_Y(I,J,K) = 0.5_DP * ( U(I,J+1,K)-U(I,J-1,K) )/DY
  U_Z(I,J,K) = 0.5_DP * ( U(I,J,K+1)-U(I,J,K-1) )/DZ
  
END DO
END DO
END DO

 CALL BC_GD( U_X, U_Y, U_Z, NX, NY, NZ)

END SUBROUTINE

SUBROUTINE BC_GD( UX, UY, UZ, NX, NY, NZ )
IMPLICIT NONE
INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
REAL(KIND=DP),PARAMETER :: PI = 3.141592653589793_DP
REAL(KIND=DP), INTENT(INOUT) :: UX(:,:,:), UY(:,:,:), UZ(:,:,:)
INTEGER, INTENT(IN) :: NX, NY, NZ
INTEGER :: I,J,K

DO K = 1, NZ
DO J = 1, NY

	
	UX(1,J,K) = UX(2,J,K)
	UX(NX,J,K) = UX(NX-1,J,K)

END DO
END DO 

DO K = 1, NZ
DO I = 1, NX

	UY(I,1,K) = UY(I,2,K)
	UY(I,NY,K) = UY(I,NY-1,K)

END DO
END DO

DO J = 1, NY
DO I = 1, NX
		
	UZ(I,J,1) = UZ(I,J,2)
	UZ(I,J,NZ) = UZ(I,J,NZ-1)
	
END DO
END DO 

END SUBROUTINE 

SUBROUTINE VISC( NX, NY, NZ, U, V, W, MU_L, PHI, DX, DY, DZ, DT, TIMESTEP, T_Iter)
IMPLICIT NONE
INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
REAL(KIND=DP), INTENT(IN) :: DX, DY, DZ, DT, U(:,:,:), V(:,:,:), W(:,:,:), PHI(:,:,:), MU_L
INTEGER, INTENT(IN) :: NX, NY, NZ, TIMESTEP, T_Iter
REAL(KIND=DP) :: U_X(NX,NY,NZ), U_Y(NX,NY,NZ), U_Z(NX,NY,NZ)
REAL(KIND=DP) :: V_X(NX,NY,NZ), V_Y(NX,NY,NZ), V_Z(NX,NY,NZ)
REAL(KIND=DP) :: W_X(NX,NY,NZ), W_Y(NX,NY,NZ), W_Z(NX,NY,NZ)
REAL(KIND=DP) :: VS(NX,NY,NZ), DE_VS, DE_VSOLD, A, DE_VSOLD2
INTEGER :: I, J, K

 CALL GRAD(NX, NY, NZ, DX, DY, DZ, U, U_X, U_Y, U_Z)
 CALL GRAD(NX, NY, NZ, DX, DY, DZ, V, V_X, V_Y, V_Z)
 CALL GRAD(NX, NY, NZ, DX, DY, DZ, W, W_X, W_Y, W_Z)
 
 
DO K = 1, NZ
DO J = 1, NY
DO I = 1, NX
	
	IF( PHI(I,J,K) > 0.0_DP )THEN
				
      VS(I,J,K)  = 2.0_DP* MU_L * ( U_X(I,J,K)**2+V_Y(I,J,K)**2+W_Z(I,J,K)**2 &
	                     +  0.5_DP* (V_X(I,J,K)+U_Y(I,J,K))**2&
	                     +  0.5_DP* (W_Y(I,J,K)+V_Z(I,J,K))**2&
	                     +  0.5_DP* (U_Z(I,J,K)+W_X(I,J,K))**2 ) *DX*DY*DZ
	                     
	ELSEIF( PHI(I,J,K)>0.0_DP )THEN
		
		  VS(I,J,K) = 0.0_DP
		  
END IF

ENDDO
ENDDO
ENDDO

 A = 0.0_DP
 
DO K = 1, NZ
DO J = 1, NY
DO I = 1, NX
	
	 A = A + VS(I,J,K)
	 
END DO
END DO
END DO

WRITE(*,*) "A" ,  A
PAUSE

DE_VS = DE_VSOLD + A* DT

WRITE(*,*)'============================================='
WRITE(*,*) 'NEW=',DE_VS
WRITE(*,*) 'OLD=',DE_VSOLD
WRITE(*,*) 'OLD2=',DE_VSOLD2
WRITE(*,*) DE_VS - DE_VSOLD
WRITE(*,*)'============================================='


DE_VSOLD2 = DE_VSOLD
DE_VSOLD = DE_VS


IF( MOD(T_Iter,TIMESTEP)==1 )THEN
	WRITE(76,*) DE_VS
END IF


END SUBROUTINE



SUBROUTINE VISC_1( NX, NY, NZ, U, V, W, MU_L, PHI, DX, DY, DZ, DT, TIMESTEP, T_Iter , DE_VSOLD)
IMPLICIT NONE
INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
REAL(KIND=DP), INTENT(IN) :: DX, DY, DZ, DT, U(:,:,:), V(:,:,:), W(:,:,:), PHI(:,:,:), MU_L
INTEGER, INTENT(IN) :: NX, NY, NZ, TIMESTEP, T_Iter
REAL(KIND=DP) :: U_X(NX,NY,NZ), U_Y(NX,NY,NZ), U_Z(NX,NY,NZ)
REAL(KIND=DP) :: V_X(NX,NY,NZ), V_Y(NX,NY,NZ), V_Z(NX,NY,NZ)
REAL(KIND=DP) :: W_X(NX,NY,NZ), W_Y(NX,NY,NZ), W_Z(NX,NY,NZ)
REAL(KIND=DP) :: VS(NX,NY,NZ), DE_VS, DE_VSOLD, A, DE_VSOLD2
INTEGER :: I, J, K

 CALL GRAD(NX, NY, NZ, DX, DY, DZ, U, U_X, U_Y, U_Z)
 CALL GRAD(NX, NY, NZ, DX, DY, DZ, V, V_X, V_Y, V_Z)
 CALL GRAD(NX, NY, NZ, DX, DY, DZ, W, W_X, W_Y, W_Z)
 
 
DO K = 1, NZ
DO J = 1, NY
DO I = 1, NX
	
	IF( PHI(I,J,K) > 0.0_DP )THEN
				
      VS(I,J,K)  = 2.0_DP* MU_L * ( U_X(I,J,K)**2+V_Y(I,J,K)**2+W_Z(I,J,K)**2 &
	                     +  0.5_DP* (V_X(I,J,K)+U_Y(I,J,K))**2&
	                     +  0.5_DP* (W_Y(I,J,K)+V_Z(I,J,K))**2&
	                     +  0.5_DP* (U_Z(I,J,K)+W_X(I,J,K))**2 ) *DX*DY*DZ
	                     
	ELSEIF( PHI(I,J,K)<0.0_DP )THEN
		
		  VS(I,J,K) = 0.0_DP
		  
END IF

ENDDO
ENDDO
ENDDO

 A = 0.0_DP
 
DO K = 1, NZ
DO J = 1, NY
DO I = 1, NX
	
	 A = A + VS(I,J,K)
	 
END DO
END DO
END DO

WRITE(*,*) "A" ,  A
PAUSE

DE_VS = DE_VSOLD + A* DT


DE_VSOLD2 = DE_VSOLD



WRITE(*,*)'============================================='
WRITE(*,*) 'NEW=',DE_VS
WRITE(*,*) 'OLD=',DE_VSOLD
WRITE(*,*) 'OLD2=',DE_VSOLD2
WRITE(*,*) DE_VS - DE_VSOLD
WRITE(*,*)'============================================='

DE_VSOLD = DE_VS



IF( MOD(T_Iter,TIMESTEP)==1 )THEN
	WRITE(76,*) DE_VS
END IF


END SUBROUTINE




	                     
	                     