SUBROUTINE WENO_RK_AD_BUBBLe(m , n , fhi , u , v , Dx , Dy , Dt  )
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to do level set method 
  !with renormailze tech mass preserving tech.
  !
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
    
    INTEGER,INTENT(IN) :: m , n !, imass
    REAL(KIND=DP),INTENT(INOUT) :: fhi(:,:) 
    REAL(KIND=DP),INTENT(IN)    :: u(:,:) , v(:,:) , dx , dy , Dt

    REAL(KIND=DP) :: fin(-2:m+3,-2:n+3),fi1(-2:m+3,-2:n+3), &
	                   fi2(-2:m+3,-2:n+3),fi0(-2:m+3,-2:n+3), &
	                   finp1(-2:m+3,-2:n+3),Lfin(-2:m+3,-2:n+3), &
		                 Lfi1(-2:m+3,-2:n+3), &
		                 Lfi2(-2:m+3,-2:n+3)
	  REAL(KIND=DP) :: fh(-2:m+3,-2:n+3), uh(-2:m+3,-2:n+3),&
	                   up(-2:m+3,-2:n+3),um(-2:m+3,-2:n+3), &
		                 f(-2:m+3,-2:n+3), &
		                 dfp(-2:m+3,-2:n+3),dfm(-2:m+3,-2:n+3)
	  REAL(KIND=DP) :: gh(-2:m+3,-2:n+3),vh(-2:m+3,-2:n+3), &
	                   vp(-2:m+3,-2:n+3),vm(-2:m+3,-2:n+3)
    REAL(KIND=DP) :: hh(-2:m+3,-2:n+3)
    REAL(KIND=DP) :: tend1 , vol
    
    INTEGER :: I , J
    
    fin(1:M,1:N) = fhi(1:M,1:N)
    uh(1:M,1:N) = u(1:M,1:N)
    vh(1:M,1:N) = v(1:M,1:N)
    
    CALL BC2D_bubble(VH,M,N) 
    CALL BC2D_bubble(UH,M,N)
    CALL BC2D_bubble(FIN,M,N)
  

	  do i=-2,m+3
	  do j=-2,n+3
	    up(i,j)=0.5*(uh(i,j)+abs(uh(i,j)))
	    um(i,j)=0.5*(uh(i,j)-abs(uh(i,j)))
	    vp(i,j)=0.5*(vh(i,j)+abs(vh(i,j)))
	    vm(i,j)=0.5*(vh(i,j)-abs(vh(i,j)))
	  enddo
	  enddo
        
	  call rk3(fin,fi1,fi2,finp1,Lfin,Lfi1,Lfi2, &
	           fh,uh,up,um,f,dfp,dfm,gh,vh,vp,vm, &
             m,n,dx,dy,dt)

!
!     REDISTANCE STEP --- T=0 TO 2*ALPH
!
!111  SET FI0=FIN1 AT T=0
!
      DO I=-2,M+3
      DO J=-2,N+3
        FI0(I,J)=FINP1(I,J)
        FIN(I,J)=FINP1(I,J)
      ENDDO
      ENDDO

   !   tend1= 6.0_DP*DX

!     sgnfi0 -- replaced by f
!     hfi -- replaced by fh
!     hpfi -- replaced by dfp
!     agfi -- replaced by dfm
!     a -- replaced by gh
!     b -- replaced by hh
!     c -- replaced by uh
!



     fhi(1:m,1:n) = fin(1:m,1:n)
                
   
	  
  END SUBROUTINE WENO_RK_AD_BUBBLE