
 
   SUBROUTINE LEVEL_SET_INITIALIZE_3D(M , N , L , FHI , XL , YL ,ZL , DX ,DY ,DZ)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !ROUTINE TO NORMALIZE THE LEVEL-SET FUNCTION.
  !
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
    INTEGER,INTENT(IN) :: M , N ,  L 
    
    REAL(KIND=DP),INTENT(IN)    :: XL , YL  , ZL , DX , DY , DZ
    REAL(KIND=DP),INTENT(INOUT) :: Fhi(:,:,:)

    REAL(KIND=DP),DIMENSION(-2:M+3,-2:N+3,-2:L+3) :: FI,UP,UM,VP,VM,wp,wm, &
                                              fin,fi0,fi1,fi2,finp1,sgnfi0,agfi, &
	                                            Lfin,Lfi1,Lfi2
    REAL(KIND=DP) :: AMX , TEND1
    INTEGER :: I , J , K 
    
    FI(1:M,1:N,1:L) = Fhi(1:M,1:N,1:L)
    
 

!
!     EXTRAPOLATED TO GHOST CELLS
!
!    I - DIR
 !    DO J=1,N
!        FI(0,J)=2.0*Fhi(1,J)-Fhi(2,J)
!        FI(-1,J)=2.0*Fhi(0,J)-Fhi(1,J)
!        FI(-2,J)=2.0*Fhi(-1,J)-Fhi(0,J)
!        FI(M+1,J)=2.0*Fhi(M,J)-Fhi(M-1,J)
!        FI(M+2,J)=2.0*Fhi(M+1,J)-Fhi(M,J)
!        FI(M+3,J)=2.0*Fhi(M+2,J)-Fhi(M+1,J)     
!       FI(0,J)=Fhi(1,J)
!       FI(-1,J)=Fhi(1,J)
!       FI(-2,J)=Fhi(1,J)
!       FI(M+1,J)=Fhi(M,J)
!       FI(M+2,J)=Fhi(M,J)
!       FI(M+3,J)=Fhi(M,J)
!     END DO
!    J - DIR
 !    DO I=-2,M+3
!        FI(I,0)=2.0*Fhi(I,1)-Fhi(I,2)
!        FI(I,-1)=2.0*Fhi(I,0)-Fhi(I,1)
!        FI(I,-2)=2.0*Fhi(I,-1)-Fhi(I,0)
!        FI(I,N+1)=2.0*Fhi(I,N)-Fhi(I,N-1)
!        FI(I,N+2)=2.0*Fhi(I,N+1)-Fhi(I,N)
!        FI(I,N+3)=2.0*Fhi(I,N+2)-Fhi(I,N+1)     
 !       FI(I,0)=Fhi(I,1)
 !       FI(I,-1)=Fhi(I,1)
 !       FI(I,-2)=Fhi(I,1)
 !       FI(I,N+1)=Fhi(I,N)
 !       FI(I,N+2)=Fhi(I,N)
 !       FI(I,N+3)=Fhi(I,N)
  !    END DO

       call bc3d_bubble(fi,m,n,l)
  
!
!     GIVE FIN TO CALCULATE UP,UM,VP,VM,WP,WM                      
!
     ! CALL FIXPM(FI,UP,UM,VP,VM,M,N , DX , DY)
     
      call fixpm_3D(fi,up,um,vp,vm,wp,wm,m,n,l,DX,DY,DZ)
!
!     GIVE FIN, UP,UM,VP,VM,WP,WM TO CALCULATE |GRAD(FI)| --- AGFI(I,J,K)
!
	!  CALL AGRADFI(AGFI,FI,UP,UM,VP,VM,M,N)
	
	  call agradfi_3D(agfi,fi,up,um,vp,vm,wp,wm,m,n,l)  

	  AMX=0.0_DP

   !   DO I=1,M
   !   DO J=1,N
   !     IF(AGFI(I,J)>AMX) AMX=AGFI(I,J)
   !   END DO
   !   END DO
   
   DO I=1,M                                
   DO J=1,N                                
   DO K=1,L                                  
      if(agfi(I,J,K)>amx) AMX=agfi(I,J,K)   
   ENDDO                                   
   ENDDO                                   
   ENDDO                                   

   
!     SET |GRAD(FIN)|=1.0
   
 !     DO I=-2,M+3
 !     DO J=-2,N+3
	!    FIN(I,J)=FI(I,J)/AMX
 !     FI0(I,J)=FI(I,J)
 !     END DO
 !     END DO
 
      DO I=-2,M+3
      DO J=-2,N+3
	    DO K=-2,L+3
	      FIN(I,J,K)=FI(I,J,K)/AMX
        FI0(I,J,K)=FI(I,J,K)
      ENDDO
      ENDDO
      ENDDO


     TEND1=MAX(XL,YL,ZL)
   !  TEND1=0.5_DP*ZL
      
!     SGNFI0 
!     AGFI 
     ! CALL FST3D(FIN,FI0,FI1,FI2,FINP1,SGNFI0,AGFI, &
	           !  LFIN,LFI1,LFI2,UP,UM,VP,VM,TEND1,M,N,dx,dy)
	             
	    CALL FST3D_3d(fin,fi0,fi1,fi2,finp1,sgnfi0,agfi, &
	                   Lfin,Lfi1,Lfi2,up,um,vp,vm,wp,wm,TEND1,m,n,l,DX,DY,DZ) 
	               
	                           
  
      FHI(1:M,1:N,1:L) = FIN(1:M,1:N,1:L)
  
  END SUBROUTINE LEVEL_SET_INITIALIZE_3D

    
    
 
  
  
    subroutine fixpm_3D(fi,up,um,vp,vm,wp,wm,m,n,l,DX,DY,DZ)   
    
     INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15) 
    INTEGER,INTENT(IN) :: M , N  ,L                        
    REAL(KIND=DP),INTENT(IN) :: Dx , Dy     ,DZ             
     INTEGER :: I , J   , K        
     REAL(KIND=DP) :: A , B  ,  C 

    
     
	  REAL(KIND=DP) :: up(-2:m+3,-2:n+3,-2:l+3),um(-2:m+3,-2:n+3,-2:l+3), &
	                   vp(-2:m+3,-2:n+3,-2:l+3),vm(-2:m+3,-2:n+3,-2:l+3), &
	                   wp(-2:m+3,-2:n+3,-2:l+3),wm(-2:m+3,-2:n+3,-2:l+3), &
		                 fi(-2:m+3,-2:n+3,-2:l+3)
      
      
      
    do i=1,m
	  do j=1,n
	  do k=1,l
	    a=1.0/(12.0*dx)*(-(fi(i-1,j,k)-fi(i-2,j,k)) &
		       +7.0*(fi(i,j,k)-fi(i-1,j,k))+7.0*(fi(i+1,j,k)-fi(i,j,k)) &
			   -(fi(i+2,j,k)-fi(i+1,j,k)))
        b=1.0/(12.0*dy)*(-(fi(i,j-1,k)-fi(i,j-2,k)) &
		       +7.0*(fi(i,j,k)-fi(i,j-1,k))+7.0*(fi(i,j+1,k)-fi(i,j,k)) &
			   -(fi(i,j+2,k)-fi(i,j+1,k)))
        c=1.0/(12.0*dz)*(-(fi(i,j,k-1)-fi(i,j,k-2)) &
		       +7.0*(fi(i,j,k)-fi(i,j,k-1))+7.0*(fi(i,j,k+1)-fi(i,j,k)) &
			   -(fi(i,j,k+2)-fi(i,j,k+1)))
	    up(i,j,k)=a &
			   +1.0/dx*phyn((fi(i+3,j,k)-2.0*fi(i+2,j,k)+fi(i+1,j,k)), &
			                (fi(i+2,j,k)-2.0*fi(i+1,j,k)+fi(i  ,j,k)), &
                            (fi(i+1,j,k)-2.0*fi(i  ,j,k)+fi(i-1,j,k)), &
					        (fi(i  ,j,k)-2.0*fi(i-1,j,k)+fi(i-2,j,k)))
	    um(i,j,k)=a &
			   -1.0/dx*phyn((fi(i-3,j,k)-2.0*fi(i-2,j,k)+fi(i-1,j,k)), &
			                (fi(i-2,j,k)-2.0*fi(i-1,j,k)+fi(i  ,j,k)), &
                            (fi(i-1,j,k)-2.0*fi(i  ,j,k)+fi(i+1,j,k)), &
					        (fi(i  ,j,k)-2.0*fi(i+1,j,k)+fi(i+2,j,k)))
	    vp(i,j,k)=b &
			   +1.0/dy*phyn((fi(i,j+3,k)-2.0*fi(i,j+2,k)+fi(i,j+1,k)), &
			                (fi(i,j+2,k)-2.0*fi(i,j+1,k)+fi(i,j  ,k)), &
                            (fi(i,j+1,k)-2.0*fi(i,j  ,k)+fi(i,j-1,k)), &
	                        (fi(i,j  ,k)-2.0*fi(i,j-1,k)+fi(i,j-2,k)))
	    vm(i,j,k)=b &
			   -1.0/dy*phyn((fi(i,j-3,k)-2.0*fi(i,j-2,k)+fi(i,j-1,k)), &
			                (fi(i,j-2,k)-2.0*fi(i,j-1,k)+fi(i,j  ,k)), &
                            (fi(i,j-1,k)-2.0*fi(i,j  ,k)+fi(i,j+1,k)), &
	                        (fi(i,j  ,k)-2.0*fi(i,j+1,k)+fi(i,j+2,k)))
	    wp(i,j,k)=c &
			   +1.0/dz*phyn((fi(i,j,k+3)-2.0*fi(i,j,k+2)+fi(i,j,k+1)), &
			                (fi(i,j,k+2)-2.0*fi(i,j,k+1)+fi(i,j,k  )), &
				  	        (fi(i,j,k+1)-2.0*fi(i,j,k  )+fi(i,j,k-1)), &
					        (fi(i,j,k  )-2.0*fi(i,j,k-1)+fi(i,j,k-2)))
	    wm(i,j,k)=c &
			   -1.0/dz*phyn((fi(i,j,k-3)-2.0*fi(i,j,k-2)+fi(i,j,k-1)), &
			                (fi(i,j,k-2)-2.0*fi(i,j,k-1)+fi(i,j,k  )), &
				  	        (fi(i,j,k-1)-2.0*fi(i,j,k  )+fi(i,j,k+1)), &
					        (fi(i,j,k  )-2.0*fi(i,j,k+1)+fi(i,j,k+2)))
    enddo
	  enddo
	  enddo
     
	  END SUBROUTINE  fixpm_3D
  
    FUNCTION PHYN(A,B,C,D)
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)      
    REAL(KIND=DP) :: PHYN
    REAL(KIND=DP) :: A,B,C,D,EPS,ALP0,ALP1,ALP2,W0,W2,IS0,IS1,IS2
        EPS=1.0E-09_DP
        IS0=13.0_DP*(A-B)**2+3.0_DP*(A-3.0_DP*B)**2
        IS1=13.0_DP*(B-C)**2+3.0_DP*(B+C)**2
        IS2=13.0_DP*(C-D)**2+3.0_DP*(3.0_DP*C-D)**2
		ALP0=1.0_DP/(EPS+IS0)**2
		ALP1=6.0_DP/(EPS+IS1)**2
		ALP2=3.0_DP/(EPS+IS2)**2
		W0=ALP0/(ALP0+ALP1+ALP2)
		W2=ALP2/(ALP0+ALP1+ALP2)
		PHYN=W0/3.0_DP*(A-2.0_DP*B+C)+(W2-0.5_DP)/6.0_DP*(B-2.0_DP*C+D)
 
	  END FUNCTION PHYN




	  
	  
	  subroutine agradfi_3D(agfi,fi0,up,um,vp,vm,wp,wm,m,n,l)
!     agradfi --- to calculate |Grad(fi)| for all (i,j,k) --- 2004/03/29
  
     INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15) 
    INTEGER,INTENT(IN) :: M , N  , L    
    INTEGER :: I , J ,  K 
    
	  real(KIND=DP) :: up(-2:m+3,-2:n+3,-2:l+3),um(-2:m+3,-2:n+3,-2:l+3), &
	       vp(-2:m+3,-2:n+3,-2:l+3),vm(-2:m+3,-2:n+3,-2:l+3), &
	       wp(-2:m+3,-2:n+3,-2:l+3),wm(-2:m+3,-2:n+3,-2:l+3), &
		   fi0(-2:m+3,-2:n+3,-2:l+3),agfi(-2:m+3,-2:n+3,-2:l+3)
		   
		   
    do i=1,m
	  do j=1,n
	  do k=1,l
         agfi(i,j,k)=gradf_3D(up(i,j,k),um(i,j,k),vp(i,j,k),vm(i,j,k), &
		                   wp(i,j,k),wm(i,j,k),fi0(i,j,k))
      enddo
	  enddo
	  enddo
	  
	  end SUBROUTINE agradfi_3D




    
    
   function gradf_3D(up,um,vp,vm,wp,wm,fi0)
!     gradf --- to calculate |Grad(fi)| at point (i,j,k) --- 2004/03/29

    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
    REAL(KIND=DP) :: GRADF_3D
    
	  real(KIND=DP)  :: up,um,vp,vm,wp,wm,upm,upp,umm,ump,vpm,vpp,vmm,vmp
	  real(KIND=DP)  :: wpm,wpp,wmm,wmp,fi0
	    upm=-MIN(up,0.0_DP)
	    upp= MAX(up,0.0_DP)
	    umm=-MIN(um,0.0_DP)
	    ump= MAX(um,0.0_DP)
	    vpm=-MIN(vp,0.0_DP)
	    vpp= MAX(vp,0.0_DP)
	    vmm=-MIN(vm,0.0_DP)
	    vmp= MAX(vm,0.0_DP)
	    wpm=-MIN(wp,0.0_DP)
	    wpp= MAX(wp,0.0_DP)
	    wmm=-MIN(wm,0.0_DP)
	    wmp= MAX(wm,0.0_DP)
	  if (fi0 >=0.0_DP ) then
	    gradf_3D=sqrt(MAX(upm,ump)**2+MAX(vpm,vmp)**2+MAX(wpm,wmp)**2)
	  else
	    gradf_3D=sqrt(MAX(upp,umm)**2+MAX(vpp,vmm)**2+MAX(wpp,wmm)**2)
	  endif
     
	  end  FUNCTION gradf_3D




      
      
      
      
    SUBROUTINE FST3D_3d(fin,fi0,fi1,fi2,finp1,sgnfi0,agfi, &
	                   Lhgn,Lhg1,Lhg2,up,um,vp,vm,wp,wm,tstop,m,n,l,DX,DY,DZ)
	                   
	  INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)	  
    REAL(KIND=DP),INTENT(IN) :: Dx , Dy  , DZ
    INTEGER,INTENT(IN) :: M , N , L                
	                   
	  real(KIND=DP) ::  fin(-2:m+3,-2:n+3,-2:l+3),fi1(-2:m+3,-2:n+3,-2:l+3), &
	       finp1(-2:m+3,-2:n+3,-2:l+3),Lhgn(-2:m+3,-2:n+3,-2:l+3), &
		   Lhg2(-2:m+3,-2:n+3,-2:l+3),fi2(-2:m+3,-2:n+3,-2:l+3), &
	       sgnfi0(-2:m+3,-2:n+3,-2:l+3),agfi(-2:m+3,-2:n+3,-2:l+3)
	  real(KIND=DP) :: up(-2:m+3,-2:n+3,-2:l+3),um(-2:m+3,-2:n+3,-2:l+3), &
	       vp(-2:m+3,-2:n+3,-2:l+3),vm(-2:m+3,-2:n+3,-2:l+3), &
	       wp(-2:m+3,-2:n+3,-2:l+3),wm(-2:m+3,-2:n+3,-2:l+3), &
		   Lhg1(-2:m+3,-2:n+3,-2:l+3),fi0(-2:m+3,-2:n+3,-2:l+3)
		   
		   
	  REAL(KIND=DP) :: Dt , TIMES , TStop 
    INTEGER :: I , J , K 
    INTEGER :: ITER   
     

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!                                                C
!       SOLVE FIt + H^G(U+,U-,V+,V-,W+,W-) =0    C
!       BY 3ND ORDER Runge-Kutta SCHEME          C
!                                                C
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      ITER=0
      TIMES=0.0
      Dt = 0.5_DP * Dx
      
!
!     give fi0 to calculate sign(fi0)  --- calculate once only
!
      call sgnf(sgnfi0,fi0,m,n,l,DX)

DO
      
      ITER=ITER+1
      TIMES=TIMES+DT
      WRITE(*,*) ITER,TIMES,FIN(M/2,N/2,L/2)
      
	  call fstrk3_3D(fin,fi0,fi1,fi2,finp1,sgnfi0,agfi, &
	              Lhgn,Lhg1,Lhg2,up,um,vp,vm,wp,wm,m,n,l,DX,DY,DZ,DT)

      DO I=-2,M+3
      DO J=-2,N+3
	    DO K=-2,L+3
        FIN(I,J,K)=FINP1(I,J,K)
      ENDDO
      ENDDO
      ENDDO

      IF(TIMES>=TSTOP) EXIT
  ENDDO
     
      END SUBROUTINE FST3D_3d


      subroutine sgnf(sgnfi0,fi0,m,n,L,dx)
!     sgnf --- to calculate sign(fi0) for all (i,j) --- 2004/03/30
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)	  
	  INTEGER,INTENT(IN) :: m , n ,  L 
	  real(KIND=DP),INTENT(IN) :: dx 
	  
	  real(KIND=DP) :: fi0(-2:m+3,-2:n+3,-2:L+3),sgnfi0(-2:m+3,-2:n+3,-2:L+3)


    do i=1,m
	  do j=1,n
	  do K=1,L
         sgnfi0(i,j,K)=sgn(fi0(i,j,K),dx)
    Enddo
	  Enddo
	  ENDDO

	  end subroutine sgnf   
	  
	  
!
!     SIGN FUNCTION
!
    FUNCTION SGN(X,DX)
      INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)      
      REAL(KIND=DP) :: Dx      
      REAL(KIND=DP) :: SGN
      REAL(KIND=DP) :: X
      REAL(KIND=DP) :: H , HP
      
      H=HEAVY(X,DX,HP)
      SGN=2.0_DP*(H-0.5_DP)
      RETURN
    END FUNCTION SGN
!
!    Heavy side function H(x) and H'(x)
!    H(x)=heavy(x,dx,hp); H'(x)=HP
!
     FUNCTION HEAVY(X,DDX,HP)      
      INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15) 
      REAL(KIND=DP),PARAMETER :: PI = 3.141592653589793_DP      
      REAL(KIND=DP) :: HEAVY
      REAL(KIND=DP) :: X , DDX , HP,DX
      dx= 2.0_dp*DDX

      IF(X > DX) THEN
        HEAVY=1.0_DP
        HP=0.0_DP
      ELSE IF(X < -DX) THEN
        HEAVY=0.0_DP
        HP=0.0_DP
      ELSE
       ! HEAVY=0.5_DP*(1.0_DP+X/DX+1.0_DP/PI*SIN(PI*X/DX)) 
       ! HP=0.5_DP*(1.0_DP/DX+1.0_DP/DX*COS(PI*X/DX))
       
        HEAVY = 1.0_dp / (1.0_DP +  EXP(-3.0_DP*X / DX) )     
        HP = (  3.0_DP*EXP(-3.0_DP*X / DX)  ) /   (1.0_dp + EXP(-3.0_DP*X / DX)  )**2  /  dx
        
      ENDIF
      
      END FUNCTION HEAVY   
      
      
      FUNCTION HEAVY1(X,DDX, HP2)      
      INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15) 
      REAL(KIND=DP),PARAMETER :: PI = 3.141592653589793_DP      
      REAL(KIND=DP) :: HEAVY1
      REAL(KIND=DP) :: X , DDX , HP2 ,DX
      dx= 2.0_dp*DDX

      IF(X > DX) THEN
        HEAVY1=1.0_DP
        HP2=0.0_DP
      ELSE IF(X < -DX) THEN
        HEAVY1=0.0_DP
        HP2=0.0_DP
      ELSE
       ! HEAVY1=0.5_DP*(1.0_DP+X/DX+1.0_DP/PI*SIN(PI*X/DX)) 
       ! HP2= 2.0_dp*( 0.5_DP*(1.0_DP+X/DX+1.0_DP/PI*SIN(PI*X/DX)) )* (0.5_DP*(1.0_DP/DX+1.0_DP/DX*COS(PI*X/DX)) )
       
        HEAVY1 = 1.0_dp / (1.0_DP +  EXP(-3.0_DP*X / DX) )     
        HP2 = 2.0_dp*(1.0_dp / (1.0_DP +  EXP(-3.0_DP*X / DX) )) * (  3.0_DP*EXP(-3.0_DP*X / DX)  ) /   (1.0_dp + EXP(-3.0_DP*X / DX)  )**2  /  dx
        
      ENDIF
      
      END FUNCTION HEAVY1 



 
	  
	  
	  subroutine fstrk3_3D(fin,fi0,fi1,fi2,finp1,sgnfi0,agfi, &
	                    Lhgn,Lhg1,Lhg2,up,um,vp,vm,wp,wm,m,n,l,DX,DY,DZ,DT)
	                    
	  INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15) 	   
    INTEGER,INTENT(IN) :: m , n ,  L 
    REAL(KIND=DP),INTENT(IN) :: Dx , Dy ,DZ , Dt     
	   
	  real(KIND=DP)  ::  fin(-2:m+3,-2:n+3,-2:l+3),fi1(-2:m+3,-2:n+3,-2:l+3), &
	       finp1(-2:m+3,-2:n+3,-2:l+3),Lhgn(-2:m+3,-2:n+3,-2:l+3), &
		   Lhg2(-2:m+3,-2:n+3,-2:l+3),fi2(-2:m+3,-2:n+3,-2:l+3), &
	       sgnfi0(-2:m+3,-2:n+3,-2:l+3),agfi(-2:m+3,-2:n+3,-2:l+3)
	  real(KIND=DP)  :: up(-2:m+3,-2:n+3,-2:l+3),um(-2:m+3,-2:n+3,-2:l+3), &
	       vp(-2:m+3,-2:n+3,-2:l+3),vm(-2:m+3,-2:n+3,-2:l+3), &
	       wp(-2:m+3,-2:n+3,-2:l+3),wm(-2:m+3,-2:n+3,-2:l+3), &
		   Lhg1(-2:m+3,-2:n+3,-2:l+3),fi0(-2:m+3,-2:n+3,-2:l+3)
		   
	  INTEGER :: I , J ,  K 
    
!
!     give fin to calculate up,um,vp,vm,wp,wm
!
      call fixpm_3D(fin,up,um,vp,vm,wp,wm,m,n,l,DX,DY,DZ)
!
!     give fi0, up,um,vp,vm,wp,wm to calculate |grad(fi)|
!
	  call agradfi_3D(agfi,fi0,up,um,vp,vm,wp,wm,m,n,l)
!
!     give sgnfi0,agfi to calculate Lhgn
!
      call fsthg_3D(Lhgn,sgnfi0,agfi,m,n,l)
!
!     calculate fi1
!
	  do i=1,m
	  do j=1,n
	  do k=1,l
	    fi1(i,j,k)=fin(i,j,k)-dt*Lhgn(i,j,k)
	  enddo
	  enddo
	  enddo
!
!     EXTRAPOLATED TO Ghost cells
!
      call bc3d_bubble(fi1,m,n,l)
!
!     give fin to calculate up,um,vp,vm,wp,wm
!
      call fixpm_3D(fi1,up,um,vp,vm,wp,wm,m,n,l,DX,DY,DZ)
!
!     give fi0, up,um,vp,vm,wp,wm to calculate |grad(fi)|
!
	  call agradfi_3D(agfi,fi0,up,um,vp,vm,wp,wm,m,n,l)
!
!     give sgnfi0,agfi to calculate Lhgn
!
      call fsthg_3D(Lhg1,sgnfi0,agfi,m,n,l)
!
!     calculate fi2
!
	  do i=1,m
	  do j=1,n
	  do k=1,l
	    fi2(i,j,k)=fi1(i,j,k)-dt/4.0_DP*(-3.0_DP*Lhgn(i,j,k)+Lhg1(i,j,k))
	  enddo
	  enddo
	  enddo
!
!     EXTRAPOLATED TO Ghost cells
!
      call bc3d_bubble(fi2,m,n,l)
!
!     give fi2 to calculate up,um,vp,vm,wp,wm
!
      call fixpm_3D(fi2,up,um,vp,vm,wp,wm,m,n,l,DX,DY,DZ)
!
!     give fi0, up,um,vp,vm,wp,wm to calculate |grad(fi)|
!
	  call agradfi_3D(agfi,fi0,up,um,vp,vm,wp,wm,m,n,l)
!
!     give sgnfi0, agfi to calculate Lhgn
!
      call fsthg_3D(Lhg2,sgnfi0,agfi,m,n,l)
!
!     calculate finp1
!
	  do i=1,m
	  do j=1,n
	  do k=1,l
	    finp1(i,j,k)=fi2(i,j,k) &
		-dt/12.0_DP*(-Lhgn(i,j,k)-Lhg1(i,j,k)+8.0_DP*Lhg2(i,j,k))
	  enddo
	  enddo
	  enddo
!
!     EXTRAPOLATED TO Ghost cells
!
      call bc3d_bubble(finp1,m,n,l)
	  	
	  End SUBROUTINE fstrk3_3D


 !  subroutine fsthg(Lhg,sgnfi0,agfi,m,n)
 !  INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
 !
	!  INTEGER,INTENT(IN) :: m , n           
	!  REAL(KIND=DP) :: agfi(-2:m+3,-2:n+3),sgnfi0(-2:m+3,-2:n+3), &
	!	                  Lhg(-2:m+3,-2:n+3)
 !
	!  INTEGER :: I , J
	!	
 !    do i=1,m
	!  do j=1,n
 !      Lhg(i,j)=sgnfi0(i,j)*(agfi(i,j)-1.0_DP)
 !    enddo
	!  enddo
 !
	!  end subroutine fsthg  
	  
	  
	  subroutine fsthg_3D(Lhg,sgnfi0,agfi,m,n,l)
	  
	  INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)

	  INTEGER,INTENT(IN) :: m , n   , L 
	  
	  real(KIND=DP)  :: agfi(-2:m+3,-2:n+3,-2:l+3),sgnfi0(-2:m+3,-2:n+3,-2:l+3), &
		                 Lhg(-2:m+3,-2:n+3,-2:l+3)
		   
      do i=1,m
	  do j=1,n
	  do k=1,l
        Lhg(i,j,k)=sgnfi0(i,j,k)*(agfi(i,j,k)-1.0_DP)
      enddo
	  enddo
	  enddo
	  return
	  end SUBROUTINE fsthg_3D
	  
	  
	  

	  
	  
	  
	  
	