 SUBROUTINE RK4_DRPCCD7TH_AD_TRIPE_3D(Nx , Ny , NZ , Dx , Dy  , DZ , Dt , C_X , C_Y , C_Z , U_old , U, ANGC  &
                          &, AU_X , BU_X , CU_X , AAU_X , BBU_X , CCU_X , AAAU_X , BBBU_X , CCCU_X &
                          &, AD_X , BD_X, CD_X , AAD_X , BBD_X  , CCD_X , AAAD_X , BBBD_X  , CCCD_X&
                          &, AU_Y , BU_Y , CU_Y , AAU_Y , BBU_Y  , CCU_Y  , AAAU_Y , BBBU_Y  , CCCU_Y &
                          &, AD_Y , BD_Y , CD_Y , AAD_Y , BBD_Y  ,CCD_Y  , AAAD_Y , BBBD_Y  ,CCCD_Y    &
                          &, AU_Z , BU_Z , CU_Z , AAU_Z , BBU_Z  , CCU_Z  , AAAU_Z , BBBU_Z  , CCCU_Z &
                          &, AD_Z , BD_Z , CD_Z , AAD_Z , BBD_Z  ,CCD_Z  , AAAD_Z , BBBD_Z  ,CCCD_Z )     
                          
                          
                          
  
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to compute conservative level set method.
  !
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    INTEGER,INTENT(IN) :: Nx , Ny , NZ

    REAL(KIND=DP),INTENT(IN   ) :: C_X(:,:,:) , C_Y(:,:,:), C_Z(:,:,:) , U_old(:,:,:) , Dx , Dy , DZ , Dt,ANGC
  ! REAL(KIND=DP),INTENT(IN   ) :: UC(:,:) , VC(:,:) , U_old(:,:) , Dx , Dy , Dt
    REAL(KIND=DP),INTENT(INOUT) :: U(:,:,:)

    REAL(KIND=DP),DIMENSION(Nx,Ny,NZ) :: K_X , K_Y , K_Z , RHS , S
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AU_X , BU_X , CU_X , AAU_X , BBU_X , CCU_X , AAAU_X , BBBU_X , CCCU_X
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AD_X , BD_X , CD_X , AAD_X , BBD_X ,CCD_X , AAAD_X , BBBD_X  , CCCD_X
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AU_Y , BU_Y , CU_Y , AAU_Y , BBU_Y , CCU_Y , AAAU_Y , BBBU_Y , CCCU_Y
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AD_Y , BD_Y , CD_Y , AAD_Y , BBD_Y , CCD_Y  , AAAD_Y , BBBD_Y , CCCD_Y 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AU_Z , BU_Z , CU_Z , AAU_Z , BBU_Z , CCU_Z , AAAU_Z , BBBU_Z , CCCU_Z
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AD_Z , BD_Z , CD_Z , AAD_Z , BBD_Z , CCD_Z  , AAAD_Z , BBBD_Z , CCCD_Z 

   
    INTEGER   :: FILTER
  


    K_X = 0.0_DP
    K_Y = K_X
    K_Z = K_X
    S   = 0.0_DP

                                    
                                     
    CALL RHS_DRPCCD(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y ,  C_Z &
                             &, K_X , K_Y   , K_Z , S , U_OLD , RHS  &
                            &, AU_X , BU_X , CU_X , AAU_X , BBU_X , CCU_X , AAAU_X , BBBU_X , CCCU_X &
                          &, AD_X , BD_X  , CD_X , AAD_X , BBD_X , CCD_X , AAAD_X , BBBD_X , CCCD_X &
                          &, AU_Y , BU_Y , CU_Y , AAU_Y , BBU_Y  , CCU_Y  , AAAU_Y , BBBU_Y  , CCCU_Y &
                          &, AD_Y , BD_Y , CD_Y , AAD_Y , BBD_Y  ,CCD_Y  , AAAD_Y , BBBD_Y  ,CCCD_Y    &
                          &, AU_Z , BU_Z , CU_Z , AAU_Z , BBU_Z  , CCU_Z  , AAAU_Z , BBBU_Z  , CCCU_Z &
                          &, AD_Z , BD_Z , CD_Z , AAD_Z , BBD_Z  ,CCD_Z  , AAAD_Z , BBBD_Z  ,CCCD_Z )                                   

    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
      U(I,J,K) = U_old(I,J,K) + 0.5_DP*Dt * RHS(I,J,K)
    END DO
    END DO
    END DO

    !CALL BC_3D_LS(Nx , Ny  , Nz , U)
    CALL BC_3D_LS1(Nx , Ny, Nz, DZ, U, ANGC, PHI_X, PHI_Y)
 
                                   

    CALL RHS_DRPCCD(Nx , Ny  , Nz  , Dx , Dy , Dz , C_X , C_Y , C_z &
                             &, K_X , K_Y , K_z  , S , U , RHS  &
                            &, AU_X , BU_X , CU_X , AAU_X , BBU_X , CCU_X , AAAU_X , BBBU_X , CCCU_X &
                          &, AD_X , BD_X  , CD_X , AAD_X , BBD_X , CCD_X , AAAD_X , BBBD_X , CCCD_X &
                          &, AU_Y , BU_Y , CU_Y , AAU_Y , BBU_Y  , CCU_Y  , AAAU_Y , BBBU_Y  , CCCU_Y &
                          &, AD_Y , BD_Y , CD_Y , AAD_Y , BBD_Y  ,CCD_Y  , AAAD_Y , BBBD_Y  ,CCCD_Y    &
                          &, AU_Z , BU_Z , CU_Z , AAU_Z , BBU_Z  , CCU_Z  , AAAU_Z , BBBU_Z  , CCCU_Z &
                          &, AD_Z , BD_Z , CD_Z , AAD_Z , BBD_Z  ,CCD_Z  , AAAD_Z , BBBD_Z  ,CCCD_Z )    
 
    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
      U(I,J,K) = U(I,J,K) + 0.5_DP*Dt * RHS(I,J,K)
    END DO
    END DO
    END DO

    !CALL BC_3D_LS(Nx , Ny  , Nz , U)
    CALL BC_3D_LS1(Nx , Ny, Nz, DZ, U, ANGC, PHI_X, PHI_Y)
   
                          
    CALL RHS_DRPCCD(Nx , Ny  , Nz , Dx , Dy , Dz , C_X , C_Y , C_z &
                             &, K_X , K_Y , K_z  , S , U , RHS  &
                            &, AU_X , BU_X , CU_X , AAU_X , BBU_X , CCU_X , AAAU_X , BBBU_X , CCCU_X &
                          &, AD_X , BD_X  , CD_X , AAD_X , BBD_X , CCD_X , AAAD_X , BBBD_X , CCCD_X &
                         &, AU_Y , BU_Y , CU_Y , AAU_Y , BBU_Y  , CCU_Y  , AAAU_Y , BBBU_Y  , CCCU_Y &
                          &, AD_Y , BD_Y , CD_Y , AAD_Y , BBD_Y  ,CCD_Y  , AAAD_Y , BBBD_Y  ,CCCD_Y    &
                          &, AU_Z , BU_Z , CU_Z , AAU_Z , BBU_Z  , CCU_Z  , AAAU_Z , BBBU_Z  , CCCU_Z &
                          &, AD_Z , BD_Z , CD_Z , AAD_Z , BBD_Z  ,CCD_Z  , AAAD_Z , BBBD_Z  ,CCCD_Z )                          
                           

    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
      U(I,J,K) = (4.0_DP*U_old(I,J,K) + 2.0_DP*U(I,J,K) + Dt*RHS(I,J,K)) / 6.0_DP
    END DO
    END DO
    END DO

    !CALL BC_3D_LS(Nx , Ny , Nz , U)
    CALL BC_3D_LS1(Nx , Ny, Nz, DZ, U, ANGC, PHI_X, PHI_Y)
   
    CALL RHS_DRPCCD(Nx , Ny , Nz , Dx , Dy  , Dz , C_X , C_Y , C_z  &
                          &, K_X , K_Y  , K_z , S , U , RHS  &
                          &, AU_X , BU_X , CU_X , AAU_X , BBU_X , CCU_X , AAAU_X , BBBU_X , CCCU_X &
                          &, AD_X , BD_X  , CD_X , AAD_X , BBD_X , CCD_X , AAAD_X , BBBD_X , CCCD_X &
                          &, AU_Y , BU_Y , CU_Y , AAU_Y , BBU_Y  , CCU_Y  , AAAU_Y , BBBU_Y  , CCCU_Y &
                          &, AD_Y , BD_Y , CD_Y , AAD_Y , BBD_Y  ,CCD_Y  , AAAD_Y , BBBD_Y  ,CCCD_Y    &
                          &, AU_Z , BU_Z , CU_Z , AAU_Z , BBU_Z  , CCU_Z  , AAAU_Z , BBBU_Z  , CCCU_Z &
                          &, AD_Z , BD_Z , CD_Z , AAD_Z , BBD_Z  ,CCD_Z  , AAAD_Z , BBBD_Z  ,CCCD_Z )    


    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
    	
      U(I,J,K) = U(I,J,K) + 0.5_DP*Dt*RHS(I,J,K)
      
    END DO
    END DO
    END DO

    !CALL BC_3D_LS(Nx , Ny , Nz , U)
    CALL BC_3D_LS1(Nx , Ny, Nz, DZ, U, ANGC, PHI_X, PHI_Y)
    
    
  END SUBROUTINE RK4_DRPCCD7TH_AD_TRIPE_3D
  
  
   SUBROUTINE RHS_DRPCCD(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z    &
                          &, K_X , K_Y , K_Z  , S , U , RHS           &
                          &, AU_X , BU_X , CU_X , AAU_X , BBU_X , CCU_X  , AAAU_X , BBBU_X , CCCU_X &
                          &, AD_X , BD_X , CD_X , AAD_X , BBD_X , CCD_X , AAAD_X , BBBD_X , CCCD_X &
                          &, AU_Y , BU_Y , CU_Y , AAU_Y , BBU_Y , CCU_Y  , AAAU_Y , BBBU_Y  , CCCU_Y &
                          &, AD_Y , BD_Y , CD_Y , AAD_Y , BBD_Y , CCD_Y  , AAAD_Y , BBBD_Y  ,CCCD_Y    &
                          &, AU_Z , BU_Z , CU_Z , AAU_Z , BBU_Z , CCU_Z  , AAAU_Z , BBBU_Z  , CCCU_Z &
                          &, AD_Z , BD_Z , CD_Z , AAD_Z , BBD_Z ,CCD_Z  , AAAD_Z , BBBD_Z  ,CCCD_Z )    
                        
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!     
  !Routine to compute RHS for using DRP for convective terms.
  !For the diffusion terms, CD2 is used.
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    IMPLICIT NONE

    INTEGER      ,INTENT(IN) :: Nx , Ny , NZ
    REAL(KIND=DP),INTENT(IN) :: Dx , Dy , DZ

    REAL(KIND=DP),INTENT(IN) :: C_X(:,:,:) , C_Y(:,:,:), C_Z(:,:,:)
    REAL(KIND=DP),INTENT(IN) :: K_X(:,:,:) , K_Y(:,:,:) , K_Z(:,:,:)
    REAL(KIND=DP),INTENT(IN) :: S(:,:,:) 

    REAL(KIND=DP),INTENT(OUT) :: RHS(:,:,:)

    REAL(KIND=DP) :: U_X(Nx,Ny,NZ) , U_Y(Nx,Ny,NZ) , U_Z(Nx,Ny,NZ) , U_old(Nx,Ny,NZ) , U(NX,NY,NZ)
    REAL(KIND=DP) :: U_XX(Nx,Ny,NZ) , U_YY(Nx,Ny,NZ) , U_XXX(Nx,Ny,NZ) , U_YYY(Nx,Ny,NZ) , U_ZZ(Nx,Ny,NZ) , U_ZZZ(Nx,Ny,NZ)
    
    INTEGER :: I , J , K
   
  
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AU_X , BU_X , CU_X , AAU_X , BBU_X  , CCU_X , AAAU_X , BBBU_X  , CCCU_X
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AD_X , BD_X , CD_X, AAD_X , BBD_X , CCD_X , AAAD_X , BBBD_X , CCCD_X
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AU_Y , BU_Y , CU_Y , AAU_Y , BBU_Y  , CCU_Y  , AAAU_Y , BBBU_Y  , CCCU_Y
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AD_Y , BD_Y  , CD_Y, AAD_Y , BBD_Y , CCD_Y  , AAAD_Y , BBBD_Y , CCCD_Y 
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AU_Z , BU_Z , CU_Z , AAU_Z , BBU_Z , CCU_Z , AAAU_Z , BBBU_Z , CCCU_Z
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AD_Z , BD_Z , CD_Z , AAD_Z , BBD_Z , CCD_Z  , AAAD_Z , BBBD_Z , CCCD_Z 
  
    DO K = 1 , NZ
    DO J = 1 , Ny
    DO I = 1 , Nx
      U_old(I,J,K) = U(I,J,K)
    END DO
    END DO
    END DO
    
    
  
    !! U(1,J)bCELL FACE ,  U_OLD(1,J)b CELL CENTER
   
  !  !Extrapolate value to ghost cell.
  !  DO J = 1 , Ny
  !    U_old(1,J)  = ( 8.0_DP * U(1,J)  - 6.0_DP * U(2,J)    + U(3,J)    ) / 3.0_DP
  !    U_old(Nx,J) = ( 8.0_DP * U(Nx,J) - 6.0_DP * U(Nx-1,J) + U(Nx-2,J) ) / 3.0_DP
  !   ! U_old(1,J)  = 2.0_DP * U(1,J)  - U(2,J)
  !   ! U_old(Nx,J) = 2.0_DP * U(Nx,J) - U(Nx-1,J)
  !
  !  END DO
  !
  !  DO I = 1 , Nx
  !    U_old(I,1)  = ( 8.0_DP * U(I,1)  - 6.0_DP * U(I,2)    + U(I,3)    ) / 3.0_DP
  !    U_old(I,Ny) = ( 8.0_DP * U(I,Ny) - 6.0_DP * U(I,Ny-1) + U(I,Ny-2) ) / 3.0_DP
  !   ! U_old(I,1)  = 2.0_DP * U(I,1)  - U(I,2)
  !   ! U_old(I,Ny) = 2.0_DP * U(I,Ny) - U(I,Ny-1)
  !
  !  END DO
    
   
    
    
    DO K = 1 , NZ
    DO J = 1 , Ny
      U_old(1,J,K)  = ( 8.0_DP * U(1,J,K)  - 6.0_DP * U(2,J,K)    + U(3,J,K)    ) / 3.0_DP
      U_old(Nx,J,K) = ( 8.0_DP * U(Nx,J,K) - 6.0_DP * U(Nx-1,J,K) + U(Nx-2,J,K) ) / 3.0_DP
     !  U_old(1,J,K)  = 2.0_DP * U(1,J,K)  - U(2,J,K)
     !  U_old(Nx,J,K) = 2.0_DP * U(Nx,J,K) - U(Nx-1,J,K)

    END DO
    END DO
    
   

    DO K = 1 , NZ
    DO I = 1 , Nx
      U_old(I,1,K)  = ( 8.0_DP * U(I,1,K)  - 6.0_DP * U(I,2,K)    + U(I,3,K)    ) / 3.0_DP
      U_old(I,Ny,K) = ( 8.0_DP * U(I,Ny,K) - 6.0_DP * U(I,Ny-1,K) + U(I,Ny-2,K) ) / 3.0_DP
    !  U_old(I,1,K)  = 2.0_DP * U(I,1,K)  - U(I,2,K)
    !  U_old(I,Ny,K) = 2.0_DP * U(I,Ny,K) - U(I,Ny-1,K)

    END DO
    END DO
    
    
   
    
    DO J = 1 , NY
    DO I = 1 , Nx
      U_old(I,J,1)  = ( 8.0_DP * U(I,J,1)  - 6.0_DP * U(I,J,2)    + U(I,J,3)    ) / 3.0_DP
      U_old(I,J,NZ) = ( 8.0_DP * U(I,J,NZ) - 6.0_DP * U(I,J,NZ-1) + U(I,J,NZ-2) ) / 3.0_DP
     ! U_old(I,1)  = 2.0_DP * U(I,1)  - U(I,2)
     ! U_old(I,Ny) = 2.0_DP * U(I,Ny) - U(I,Ny-1)

    END DO
    END DO
    
    
   
    
    
    U_old(1,1,1)   = (8.0_DP * U(1,1,1)   - 6.0_DP * U(2,2,2)       + U(3,3,3)      ) / 3.0_DP
    U_old(1,Ny,1)  = (8.0_DP * U(1,Ny,1)  - 6.0_DP * U(2,Ny-1,2)    + U(3,Ny-2,3)   ) / 3.0_DP
    U_old(Nx,1,1)  = (8.0_DP * U(Nx,1,1)  - 6.0_DP * U(Nx-1,2,2)    + U(Nx-2,3,3)   ) / 3.0_DP
    U_old(Nx,Ny,1) = (8.0_DP * U(Nx,Ny,1) - 6.0_DP * U(Nx-1,Ny-1,2) + U(Nx-2,Ny-2,3)) / 3.0_DP

    U_old(1,1,NZ)   = (8.0_DP * U(1,1,NZ)   - 6.0_DP * U(2,2,NZ-1)       + U(3,3,NZ-2)      ) / 3.0_DP
    U_old(1,Ny,NZ)  = (8.0_DP * U(1,Ny,NZ)  - 6.0_DP * U(2,Ny-1,NZ-1)    + U(3,Ny-2,NZ-2)   ) / 3.0_DP
    U_old(Nx,1,NZ)  = (8.0_DP * U(Nx,1,NZ)  - 6.0_DP * U(Nx-1,2,NZ-1)    + U(Nx-2,3,NZ-2)   ) / 3.0_DP
    U_old(Nx,Ny,NZ) = (8.0_DP * U(Nx,Ny,NZ) - 6.0_DP * U(Nx-1,Ny-1,NZ-1) + U(Nx-2,Ny-2,NZ-2)) / 3.0_DP

  !  U_old(1,1)   = 2.0_DP * U(1,1)   - U(2,2)
  !  U_old(1,Ny)  = 2.0_DP * U(1,Ny)  - U(2,Ny-1)
  !  U_old(Nx,1)  = 2.0_DP * U(Nx,1)  - U(Nx-1,2)
  !  U_old(Nx,Ny) = 2.0_DP * U(Nx,Ny) - U(Nx-1,Ny-1)



  
 
   CALL CCD_UD_TWIN(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y , C_Z , U_OLD , U_OLD  , U_OLD&
                         &, U_X , U_XX , U_XXX , U_Y , U_YY , U_YYY  , U_Z , U_ZZ , U_ZZZ &
                         &, AU_X , BU_X , CU_X  , AAU_X , BBU_X , CCU_X  , AAAU_X , BBBU_X , CCCU_X&
                         &, AD_X , BD_X , CD_X , AAD_X , BBD_X  , CCD_X  , AAAD_X , BBBD_X  , CCCD_X&
                         &, AU_Y , BU_Y  , CU_Y, AAU_Y , BBU_Y , CCU_Y , AAAU_Y , BBBU_Y , CCCU_Y &
                         &, AD_Y , BD_Y , CD_Y , AAD_Y , BBD_Y , CCD_Y  , AAAD_Y , BBBD_Y , CCCD_Y &
                         &, AU_Z , BU_Z  , CU_Z, AAU_Z , BBU_Z , CCU_Z , AAAU_Z , BBBU_Z , CCCU_Z &
                         &, AD_Z , BD_Z , CD_Z , AAD_Z , BBD_Z , CCD_Z  , AAAD_Z , BBBD_Z , CCCD_Z)
   
         
     
    
  !  !Compute RHS
  !  !convective terms and source term
    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
      RHS(I,J,K) = -C_X(I,J,K)*U_X(I,J,K) - C_Y(I,J,K)*U_Y(I,J,K) - C_Z(I,J,K)*U_Z(I,J,K) + S(I,J,K)
    END DO
    END DO
    END DO


  END SUBROUTINE RHS_DRPCCD