
  SUBROUTINE ASSIGN_CCD_UD_TWIN(N , Dx , A , B , AA , BB &
                                      &, AD , BD , AAD , BBD)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to assign CCD coeff.
  !  AU , BU , CU are for the upwind coeff.
  !  AD , BD , CD are for the downwind coeff.
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    IMPLICIT NONE

    INTEGER,INTENT(IN) :: N
    REAL(KIND=DP)                 ,INTENT(IN ) :: Dx
    REAL(KIND=DP),DIMENSION(:,:),INTENT(OUT) :: A , B , AA , BB
    REAL(KIND=DP),DIMENSION(:,:),INTENT(OUT) :: AD , BD , AAD , BBD

    REAL(KIND=DP) :: A1 , B1 , B2 , B3
    REAL(KIND=DP) :: A3D , B1D , B2D , B3D
    REAL(KIND=DP) :: AA1 , AA3 , BB1 , BB3

    INTEGER:: I


  !  !For ux eq., a>0
  !  A1 =  0.875_DP
  !  B1 =  0.12512823415990895606_DP
  !  B2 = -0.24871765840091043936_DP
  !  B3 =  0.00012823415990895606360_DP

  !  !For ux eq., a<0
  !  A3D =  0.875_DP
  !  B1D = -0.00012823415990895606360_DP
  !  B2D =  0.24871765840091043936_DP
  !  B3D = -0.12512823415990895606_DP

  !  !For ux eq., a>0
  !  A1 =  0.875_DP
  !  B1 =  0.12547425010813624084_DP
  !  B2 = -0.24525749891863759159_DP
  !  B3 =  0.00047425010813624083774_DP
  !
  !  !For ux eq., a<0
  !  A3D =  0.875_DP
  !  B1D = -0.00047425010813624083774_DP
  !  B2D =  0.24525749891863759159_DP
  !  B3D = -0.12547425010813624084_DP
    
  !!!!  M - DRPCCD   
    !For ux eq., a>0
    A1 =  0.875_DP
    B1 =  0.125100442885824_DP
    B2 = -0.248995571141759_DP
    B3 =  0.0001004428858241_DP

    !For ux eq., a<0
    A3D =  0.875_DP
    B1D = -0.0001004428858241_DP
    B2D =  0.248995571141759_DP
    B3D = -0.125100442885824_DP


    !For uxx eq.
    AA1 = -9.0_DP / 8.0_DP
    AA3 =  9.0_DP / 8.0_DP
    BB1 = -1.0_DP / 8.0_DP
    BB3 = -1.0_DP / 8.0_DP

  !For Upwind
    !For I = 1
    !I
     !For U_X
     A(2,1) = 1.0_DP
     B(2,1) = 0.0_DP
     !For U_XX
     AA(2,1) = 0.0_DP
     BB(2,1) = 1.0_DP
    !I+1
     !For U_X
     A(3,1) = 2.0_DP
     B(3,1) = -Dx
     !For U_XX
     AA(3,1) = -2.5_DP / Dx
     BB(3,1) =  8.5_DP

    !For I = 2 , N-1
    DO I = 2 , N-1
    !I-1
     !For U_X
      A(1,I) = A1
      B(1,I) = B1 * Dx
     !For U_XX
      AA(1,I) = AA1 / Dx
      BB(1,I) = BB1
    !I
      !For U_X
      A(2,I) = 1.0_DP
      B(2,I) = B2 * Dx
      !For U_XX
      AA(2,I) = 0.0_DP
      BB(2,I) = 1.0_DP
    !I+1
      !For U_X
      A(3,I) = 0.0_DP
      B(3,I) = B3 * Dx
      !For U_XX
      AA(3,I) = AA3 / Dx
      BB(3,I) = BB3
    END DO

    !For I = N
    !I-1
     !For U_X
     A(1,N) = 2.0_DP
     B(1,N) = Dx
     !For U_XX
     AA(1,N) = 2.5_DP / Dx
     BB(1,N) = 8.5_DP
    !I
     !For U_X
     A(2,N) = 1.0_DP
     B(2,N) = 0.0_DP
     !For U_XX
     AA(2,N) = 0.0_DP
     BB(2,N) = 1.0_DP


  !For Downwind
    !For I = 1
    !I
     !For U_X
     AD(2,1) = 1.0_DP
     BD(2,1) = 0.0_DP
     !For U_XX
     AAD(2,1) = 0.0_DP
     BBD(2,1) = 1.0_DP
    !I+1
     !For U_X
     AD(3,1) = 2.0_DP
     BD(3,1) = -Dx
     !For U_XX
     AAD(3,1) = -2.5_DP / Dx
     BBD(3,1) =  8.5_DP

    !For I = 2 , N-1
    DO I = 2 , N-1
    !I-1
     !For U_X
      AD(1,I) = 0.0_DP
      BD(1,I) = B1D * Dx
     !For U_XX
      AAD(1,I) = AA1 / Dx
      BBD(1,I) = BB1
    !I
      !For U_X
      AD(2,I) = 1.0_DP
      BD(2,I) = B2D * Dx
      !For U_XX
      AAD(2,I) = 0.0_DP
      BBD(2,I) = 1.0_DP
    !I+1
      !For U_X
      AD(3,I) = A3D
      BD(3,I) = B3D * Dx
      !For U_XX
      AAD(3,I) = AA3 / Dx
      BBD(3,I) = BB3
    END DO

    !For I = N
    !I-1
     !For U_X
     AD(1,N) = 2.0_DP
     BD(1,N) = Dx
     !For U_XX
     AAD(1,N) = 2.5_DP / Dx
     BBD(1,N) = 8.5_DP
    !I
     !For U_X
     AD(2,N) = 1.0_DP
     BD(2,N) = 0.0_DP
     !For U_XX
     AAD(2,N) = 0.0_DP
     BBD(2,N) = 1.0_DP

  END SUBROUTINE ASSIGN_CCD_UD_TWIN


   SUBROUTINE TWIN_DEC( A, B, AA, BB )
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to solve the CCD matrix by twin-elimination method.
  !
  !Input is the CCD matrix.
  !Output is the twin-forward elimination matrix.
  !Note that the coefficients for elimination
  ! A(1,:) , B(1,:) , AA(1,:) and BB(1,:)
  !are stored in the same locations.
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    REAL(KIND=DP), INTENT(INOUT), DIMENSION(:,:) :: A,  B
    REAL(KIND=DP), INTENT(INOUT), DIMENSION(:,:) :: AA, BB
   !--------------
    INTEGER       ::  i, n
    REAL(KIND=DP) ::  den , SC1 , SC2

    n = SIZE(A,DIM=2)

    A (1,1) = 0.0_DP
    AA(1,1) = 0.0_DP
    A (3,n) = 0.0_DP
    AA(3,n) = 0.0_DP

    B (1,1) = 0.0_DP
    BB(1,1) = 0.0_DP
    B (3,n) = 0.0_DP
    BB(3,n) = 0.0_DP

    DO i = 2, N
    	Den = A(2,i-1)*BB(2,i-1) - AA(2,i-1)*B(2,i-1)
      SC1 = -( AA(2,i-1)*B(1,i) - A(1,i)*BB(2,i-1) )/Den   !!!fot x
      SC2 =  (  B(1,i)*A(2,i-1) - B(2,i-1)*A(1,i)  )/Den   !!! for y

      A(1,i) = SC1
      A(2,i) = A(2,i) - ( SC1*A(3,i-1) + SC2*AA(3,i-1) )

      B(1,i) = SC2
      B(2,i) = B(2,i) - ( SC1*B(3,i-1) + SC2*BB(3,i-1) )
     !=========================================
      SC1 = -( AA(2,i-1)*BB(1,i) - AA(1,i)*BB(2,i-1) )/Den
      SC2 =  ( BB(1,i)*A(2,i-1)  -  B(2,i-1)*AA(1,i) )/Den

      AA(1,i) = SC1
      AA(2,i) = AA(2,i) - (SC1*A(3,i-1) + SC2*AA(3,i-1))

      BB(1,i) = SC2
      BB(2,i) = BB(2,i) - (SC1*B(3,i-1) + SC2*BB(3,i-1))
    END DO

  END SUBROUTINE TWIN_DEC




 SUBROUTINE TWIN_DEC_1( A, B, AA, BB )
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to solve the CCD matrix by twin-elimination method.
  !
  !Input is the CCD matrix.
  !Output is the twin-forward elimination matrix.
  !Note that the coefficients for elimination
  ! A(1,:) , B(1,:) , AA(1,:) and BB(1,:)
  !are stored in the same locations.
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    REAL(KIND=DP), INTENT(INOUT), DIMENSION(:,:) :: A,  B
    REAL(KIND=DP), INTENT(INOUT), DIMENSION(:,:) :: AA, BB
   !--------------
    INTEGER       ::  i, n
    REAL(KIND=DP) ::  den , SC1 , SC2

    n = SIZE(A,DIM=2)

    A (1,1) = 0.0_DP
    AA(1,1) = 0.0_DP
    A (3,n) = 0.0_DP
    AA(3,n) = 0.0_DP

    B (1,1) = 0.0_DP
    BB(1,1) = 0.0_DP
    B (3,n) = 0.0_DP
    BB(3,n) = 0.0_DP

    DO i = 2, N
    	Den = A(2,i-1)*BB(2,i-1) - AA(2,i-1)*B(2,i-1)
      SC1 = -( AA(2,i-1)*B(1,i) - A(1,i)*BB(2,i-1) )/Den   !!!fot x
      SC2 =  (  B(1,i)*A(2,i-1) - B(2,i-1)*A(1,i)  )/Den   !!! for y

      A(1,i) = SC1
      A(2,i) = A(2,i) - ( SC1*A(3,i-1) + SC2*AA(3,i-1) )

      B(1,i) = SC2
      B(2,i) = B(2,i) - ( SC1*B(3,i-1) + SC2*BB(3,i-1) )
     !=========================================
      SC1 = -( AA(2,i-1)*BB(1,i) - AA(1,i)*BB(2,i-1) )/Den
      SC2 =  ( BB(1,i)*A(2,i-1)  -  B(2,i-1)*AA(1,i) )/Den

      AA(1,i) = SC1
      AA(2,i) = AA(2,i) - (SC1*A(3,i-1) + SC2*AA(3,i-1))

      BB(1,i) = SC2
      BB(2,i) = BB(2,i) - (SC1*B(3,i-1) + SC2*BB(3,i-1))
    END DO

  END SUBROUTINE TWIN_DEC_1
  
   
   
   SUBROUTINE ASSIGN_CCD_UD_TWIN_2(N , Dx , A , B , AA , BB &
                                      &, AD , BD , AAD , BBD)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to assign CCD coeff.
  !  AU , BU , CU are for the upwind coeff.
  !  AD , BD , CD are for the downwind coeff.
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    IMPLICIT NONE

    INTEGER,INTENT(IN) :: N
    REAL(KIND=DP)                 ,INTENT(IN ) :: Dx
    REAL(KIND=DP),DIMENSION(:,:),INTENT(OUT) :: A , B , AA , BB
    REAL(KIND=DP),DIMENSION(:,:),INTENT(OUT) :: AD , BD , AAD , BBD

    REAL(KIND=DP) :: A1 , A3 ,  B1 , B2 , B3
    REAL(KIND=DP) :: A1D , A3D , B1D , B2D , B3D
    REAL(KIND=DP) :: AA1 , AA3 , BB1 , BB3

    INTEGER:: I


  !  !For ux eq., a>0
  !  A1 =  0.875_DP
  !  B1 =  0.12512823415990895606_DP
  !  B2 = -0.24871765840091043936_DP
  !  B3 =  0.00012823415990895606360_DP

  !  !For ux eq., a<0
  !  A3D =  0.875_DP
  !  B1D = -0.00012823415990895606360_DP
  !  B2D =  0.24871765840091043936_DP
  !  B3D = -0.12512823415990895606_DP

  !  !For ux eq., a>0
  !  A1 =  0.875_DP
  !  B1 =  0.12547425010813624084_DP
  !  B2 = -0.24525749891863759159_DP
  !  B3 =  0.00047425010813624083774_DP
  !
  !  !For ux eq., a<0
  !  A3D =  0.875_DP
  !  B1D = -0.00047425010813624083774_DP
  !  B2D =  0.24525749891863759159_DP
  !  B3D = -0.12547425010813624084_DP
    
    A1 =  0.8882517925816830922_DP
    A3 =  0.04922965156425901316_DP
    B1 =  0.1500723989966411623_DP
    B2 = -0.2507127941223461403_DP
    B3 =  -0.01241646749092410088_DP



    !For ux eq., a<0
    A1D =  0.04922965156425901316_DP
    A3D =  0.8882517925816830922_DP
    B1D =  0.01241646749092410088_DP
    B2D =  0.2507127941223461403_DP
    B3D =  -0.1500723989966411623_DP


    !For uxx eq.
    AA1 = -9.0_DP / 8.0_DP
    AA3 =  9.0_DP / 8.0_DP
    BB1 = -1.0_DP / 8.0_DP
    BB3 = -1.0_DP / 8.0_DP

  !For Upwind
    !For I = 1
    !I
     !For U_X
     A(2,1) = 1.0_DP
     B(2,1) = 0.0_DP
     !For U_XX
     AA(2,1) = 0.0_DP
     BB(2,1) = 1.0_DP
    !I+1
     !For U_X
     A(3,1) = 2.0_DP
     B(3,1) = -Dx
     !For U_XX
     AA(3,1) = -2.5_DP / Dx
     BB(3,1) =  8.5_DP

    !For I = 2 , N-1
    DO I = 2 , N-1
    	
      A(1,I) = A1
      B(1,I) = B1 * Dx
     !For U_XX
      AA(1,I) = AA1 / Dx
      BB(1,I) = BB1
    !I
      !For U_X
      A(2,I) = 1.0_DP
      B(2,I) = B2 * Dx
      !For U_XX
      AA(2,I) = 0.0_DP
      BB(2,I) = 1.0_DP
    !I+1
      !For U_X
      A(3,I) = A3
      B(3,I) = B3 * Dx
      !For U_XX
      AA(3,I) = AA3 / Dx
      BB(3,I) = BB3
      
    END DO

    !For I = N
    !I-1
     !For U_X
     A(1,N) = 2.0_DP
     B(1,N) = Dx
     !For U_XX
     AA(1,N) = 2.5_DP / Dx
     BB(1,N) = 8.5_DP
    !I
     !For U_X
     A(2,N) = 1.0_DP
     B(2,N) = 0.0_DP
     !For U_XX
     AA(2,N) = 0.0_DP
     BB(2,N) = 1.0_DP


  !For Downwind
    !For I = 1
    !I
     !For U_X
     AD(2,1) = 1.0_DP
     BD(2,1) = 0.0_DP
     !For U_XX
     AAD(2,1) = 0.0_DP
     BBD(2,1) = 1.0_DP
    !I+1
     !For U_X
     AD(3,1) = 2.0_DP
     BD(3,1) = -Dx
     !For U_XX
     AAD(3,1) = -2.5_DP / Dx
     BBD(3,1) =  8.5_DP

    !For I = 2 , N-1
    DO I = 2 , N-1
    	
      AD(1,I) = A1D
      BD(1,I) = B1D * Dx
     !For U_XX
      AAD(1,I) = AA1 / Dx
      BBD(1,I) = BB1
    !I
      !For U_X
      AD(2,I) = 1.0_DP
      BD(2,I) = B2D * Dx
      !For U_XX
      AAD(2,I) = 0.0_DP
      BBD(2,I) = 1.0_DP
    !I+1
      !For U_X
      AD(3,I) = A3D
      BD(3,I) = B3D * Dx
      !For U_XX
      AAD(3,I) = AA3 / Dx
      BBD(3,I) = BB3
      
    END DO

    !For I = N
    !I-1
     !For U_X
     AD(1,N) = 2.0_DP
     BD(1,N) = Dx
     !For U_XX
     AAD(1,N) = 2.5_DP / Dx
     BBD(1,N) = 8.5_DP
    !I
     !For U_X
     AD(2,N) = 1.0_DP
     BD(2,N) = 0.0_DP
     !For U_XX
     AAD(2,N) = 0.0_DP
     BBD(2,N) = 1.0_DP

  END SUBROUTINE ASSIGN_CCD_UD_TWIN_2
  
  
  
    SUBROUTINE RK3_DRPCCD5TH_AD_TWIN(Nx , Ny , NZ , Dx , Dy  , DZ , Dt , C_X , C_Y , C_Z , U_old , U  &
                          &, AU_X , BU_X  , AAU_X , BBU_X    &
                          &, AD_X , BD_X  , AAD_X , BBD_X    &
                          &, AU_Y , BU_Y  , AAU_Y , BBU_Y    &
                          &, AD_Y , BD_Y  , AAD_Y , BBD_Y    &
                          &, AU_Z , BU_Z  , AAU_Z , BBU_Z     &
                          &, AD_Z , BD_Z  , AAD_Z , BBD_Z    )     
                          
                          
                          
  
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to compute conservative level set method.
  !
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    INTEGER,INTENT(IN) :: Nx , Ny , NZ

    REAL(KIND=DP),INTENT(IN   ) :: C_X(:,:,:) , C_Y(:,:,:), C_Z(:,:,:) , U_old(:,:,:)  , Dx , Dy , DZ , Dt
  
    REAL(KIND=DP),INTENT(INOUT) :: U(:,:,:)

    REAL(KIND=DP),DIMENSION(Nx,Ny,NZ) :: K_X , K_Y , K_Z , RHS  , RHS_1  , RHS_2 , S , U_1 , U_2
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AU_X , BU_X  , AAU_X , BBU_X 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AD_X , BD_X  , AAD_X , BBD_X 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AU_Y , BU_Y  , AAU_Y , BBU_Y
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AD_Y , BD_Y  , AAD_Y , BBD_Y 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AU_Z , BU_Z  , AAU_Z , BBU_Z 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AD_Z , BD_Z  , AAD_Z , BBD_Z 

   
    INTEGER   :: FILTER
  


    K_X = 1.0_DP / 2000.0_DP
    K_Y = K_X
    K_Z = K_X
    S   = 0.0_DP
 
    CALL Cell_face_velocity_FV(Nx , Ny , NZ ,  C_X , C_Y , C_Z ,  Uc , Vc , Wc)                                    
                                     
    CALL RHS_DRPCCD(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y ,  C_Z &
                          &, K_X , K_Y   , K_Z , S , U_OLD , RHS  &
                          &, AU_X , BU_X  , AAU_X , BBU_X  &
                          &, AD_X , BD_X  , AAD_X , BBD_X &
                          &, AU_Y , BU_Y  , AAU_Y , BBU_Y  &
                          &, AD_Y , BD_Y  , AAD_Y , BBD_Y    &
                          &, AU_Z , BU_Z  , AAU_Z , BBU_Z   &
                          &, AD_Z , BD_Z  , AAD_Z , BBD_Z )                                   


   ! CALL LS_cell_face_DRP_FV_RHS_COMPUTE_FV(Nx , Ny , NZ , Dx , Dy , DZ , Uc , Vc , Wc &
   !                                       &, K_X , K_Y , K_Z , S , U_OLD , RHS , Dt )

    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
      U_1(I,J,K) = U_old(I,J,K) + Dt * RHS(I,J,K)
    END DO
    END DO
    END DO
     

    CALL BC_3D_LS(Nx , Ny  , Nz , U_1)

 
                                   

    CALL RHS_DRPCCD(Nx , Ny  , Nz  , Dx , Dy , Dz , C_X , C_Y , C_z &
                          &, K_X , K_Y , K_z  , S , U_1 , RHS_1  &
                          &, AU_X , BU_X  , AAU_X , BBU_X  &
                          &, AD_X , BD_X  , AAD_X , BBD_X  &
                          &, AU_Y , BU_Y  , AAU_Y , BBU_Y &
                          &, AD_Y , BD_Y  , AAD_Y , BBD_Y      &
                          &, AU_Z , BU_Z  , AAU_Z , BBU_Z   &
                          &, AD_Z , BD_Z  , AAD_Z , BBD_Z  )    
 
  !  CALL LS_cell_face_DRP_FV_RHS_COMPUTE_FV(Nx , Ny , NZ , Dx , Dy , DZ , Uc , Vc , Wc &
  !                                           &, K_X , K_Y , K_Z , S , U_1 , RHS_1 , Dt )

    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
      U_2(I,J,K) = 3.0_DP/ 4.0_DP*U_old(I,J,K) +  1.0_DP/ 4.0_DP*U_1(I,J,K) +  1.0_DP/ 4.0_DP*Dt * RHS_1(I,J,K)
    END DO
    END DO
    END DO
       

    CALL BC_3D_LS(Nx , Ny  , Nz , U_2)

   
                          
     CALL RHS_DRPCCD(Nx , Ny  , Nz , Dx , Dy , Dz , C_X , C_Y , C_z &
                             &, K_X , K_Y , K_z  , S , U_2 , RHS_2  &
                          &, AU_X , BU_X  , AAU_X , BBU_X  &
                          &, AD_X , BD_X  , AAD_X , BBD_X  &
                          &, AU_Y , BU_Y  , AAU_Y , BBU_Y   &
                          &, AD_Y , BD_Y  , AAD_Y , BBD_Y     &
                          &, AU_Z , BU_Z  , AAU_Z , BBU_Z   &
                          &, AD_Z , BD_Z  , AAD_Z , BBD_Z  )                          
                           

   ! CALL LS_cell_face_DRP_FV_RHS_COMPUTE_FV(Nx , Ny , NZ , Dx , Dy , DZ , Uc , Vc , Wc &
   !                                       &, K_X , K_Y , K_Z , S , U_2 , RHS_2 , Dt )



    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
      U(I,J,K) = 1.0_DP/ 3.0_DP*U_OLD(I,J,K) + 2.0_DP/ 3.0_DP*U_2(I,J,K) + 2.0_DP/ 3.0_DP*Dt*RHS_2(I,J,K)
    END DO
    END DO
    END DO
 
    

    CALL BC_3D_LS(Nx , Ny , Nz , U)

  END SUBROUTINE RK3_DRPCCD5TH_AD_TWIN
  
  
   SUBROUTINE RK3_DRPCCD5TH_AD_TWIN_1(Nx , Ny , NZ , Dx , Dy  , DZ , Dt , C_X , C_Y , C_Z , U_old , U  , K_X , K_Y , K_Z  &
                          &, AU_X , BU_X  , AAU_X , BBU_X    &
                          &, AD_X , BD_X  , AAD_X , BBD_X    &
                          &, AU_Y , BU_Y  , AAU_Y , BBU_Y    &
                          &, AD_Y , BD_Y  , AAD_Y , BBD_Y    &
                          &, AU_Z , BU_Z  , AAU_Z , BBU_Z     &
                          &, AD_Z , BD_Z  , AAD_Z , BBD_Z    )     
                          
                          
                          
  
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to compute conservative level set method.
  !
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    INTEGER,INTENT(IN) :: Nx , Ny , NZ

    REAL(KIND=DP),INTENT(IN   ) :: C_X(:,:,:) , C_Y(:,:,:), C_Z(:,:,:) , U_old(:,:,:)  , Dx , Dy , DZ , Dt
  
    REAL(KIND=DP),INTENT(INOUT) :: U(:,:,:)

    REAL(KIND=DP),DIMENSION(Nx,Ny,NZ) :: K_X , K_Y , K_Z , RHS  , RHS_1  , RHS_2 , S , U_1 , U_2  , UU
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AU_X , BU_X  , AAU_X , BBU_X 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AD_X , BD_X  , AAD_X , BBD_X 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AU_Y , BU_Y  , AAU_Y , BBU_Y
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AD_Y , BD_Y  , AAD_Y , BBD_Y 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AU_Z , BU_Z  , AAU_Z , BBU_Z 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) ::  AD_Z , BD_Z  , AAD_Z , BBD_Z 

   
    INTEGER   :: FILTER
  

    DO K = 1 , NZ
    DO J = 1 , Ny
    DO I = 1 , Nx
      UU(I,J,K) = U_OLD(I,J,K) 
    END DO
    END DO
    END DO
    
    S   = 0.0_DP
 
   ! CALL Cell_face_velocity_FV(Nx , Ny , NZ ,  C_X , C_Y , C_Z ,  Uc , Vc , Wc)                                    
                                     
    CALL RHS_DRPCCD(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y ,  C_Z &
                          &, K_X , K_Y   , K_Z , S , U_OLD , RHS  &
                          &, AU_X , BU_X  , AAU_X , BBU_X  &
                          &, AD_X , BD_X  , AAD_X , BBD_X &
                          &, AU_Y , BU_Y  , AAU_Y , BBU_Y  &
                          &, AD_Y , BD_Y  , AAD_Y , BBD_Y    &
                          &, AU_Z , BU_Z  , AAU_Z , BBU_Z   &
                          &, AD_Z , BD_Z  , AAD_Z , BBD_Z )                                   


   ! CALL LS_cell_face_DRP_FV_RHS_COMPUTE_FV(Nx , Ny , NZ , Dx , Dy , DZ , Uc , Vc , Wc &
   !                                       &, K_X , K_Y , K_Z , S , U_OLD , RHS , Dt )

    ! DO K = 2 , NZ-1
    ! DO J = 2 , Ny-1
    ! DO I = 2 , Nx-1
    !   U_1(I,J,K) = U_old(I,J,K) + Dt * RHS(I,J,K)
    ! END DO
    ! END DO
    ! END DO
     
    DO K = 2 , NZ-1 
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
      U(I,J,k) = U_old(I,J,k) + 0.5_DP*Dt * RHS(I,J,k)
    END DO
    END DO
    END DO 
     

    CALL BC_3D_LS(Nx , Ny  , Nz , U)

      DO J = 2 , NY-1
      DO I = 2 , Nx-1
        U(I,J,1)  = UU(I,J,1)
      END DO
      END DO                             

    CALL RHS_DRPCCD(Nx , Ny  , Nz  , Dx , Dy , Dz , C_X , C_Y , C_z &
                          &, K_X , K_Y , K_z  , S , U , RHS  &
                          &, AU_X , BU_X  , AAU_X , BBU_X  &
                          &, AD_X , BD_X  , AAD_X , BBD_X  &
                          &, AU_Y , BU_Y  , AAU_Y , BBU_Y &
                          &, AD_Y , BD_Y  , AAD_Y , BBD_Y      &
                          &, AU_Z , BU_Z  , AAU_Z , BBU_Z   &
                          &, AD_Z , BD_Z  , AAD_Z , BBD_Z  )    
 
  !  CALL LS_cell_face_DRP_FV_RHS_COMPUTE_FV(Nx , Ny , NZ , Dx , Dy , DZ , Uc , Vc , Wc &
  !                                           &, K_X , K_Y , K_Z , S , U_1 , RHS_1 , Dt )

    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
    	
    	U(I,J,k) = U(I,J,k) + 0.5_DP*Dt * RHS(I,J,k)
     ! U_2(I,J,K) = 3.0_DP/ 4.0_DP*U_old(I,J,K) +  1.0_DP/ 4.0_DP*U_1(I,J,K) +  1.0_DP/ 4.0_DP*Dt * RHS_1(I,J,K)
    END DO
    END DO
    END DO
       

    CALL BC_3D_LS(Nx , Ny  , Nz , U)

      DO J = 2 , NY-1
      DO I = 2 , Nx-1
        U(I,J,1)  = UU(I,J,1)
      END DO
      END DO    
                          
     CALL RHS_DRPCCD(Nx , Ny  , Nz , Dx , Dy , Dz , C_X , C_Y , C_z &
                             &, K_X , K_Y , K_z  , S , U , RHS  &
                          &, AU_X , BU_X  , AAU_X , BBU_X  &
                          &, AD_X , BD_X  , AAD_X , BBD_X  &
                          &, AU_Y , BU_Y  , AAU_Y , BBU_Y   &
                          &, AD_Y , BD_Y  , AAD_Y , BBD_Y     &
                          &, AU_Z , BU_Z  , AAU_Z , BBU_Z   &
                          &, AD_Z , BD_Z  , AAD_Z , BBD_Z  )                          
                           

   ! CALL LS_cell_face_DRP_FV_RHS_COMPUTE_FV(Nx , Ny , NZ , Dx , Dy , DZ , Uc , Vc , Wc &
   !                                       &, K_X , K_Y , K_Z , S , U_2 , RHS_2 , Dt )



    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
    	
    	 U(I,J,k) = (4.0_DP*U_old(I,J,k) + 2.0_DP*U(I,J,k) + Dt*RHS(I,J,k)) / 6.0_DP
      !U(I,J,K) = 1.0_DP/ 3.0_DP*U_OLD(I,J,K) + 2.0_DP/ 3.0_DP*U_2(I,J,K) + 2.0_DP/ 3.0_DP*Dt*RHS_2(I,J,K)
    END DO
    END DO
    END DO
 
    

     CALL BC_3D_LS(Nx , Ny , Nz , U)
    
      DO J = 2 , NY-1
      DO I = 2 , Nx-1
        U(I,J,1)  = UU(I,J,1)
      END DO
      END DO     
    
    
     CALL RHS_DRPCCD(Nx , Ny  , Nz  , Dx , Dy , Dz , C_X , C_Y , C_z &
                          &, K_X , K_Y , K_z  , S , U , RHS  &
                          &, AU_X , BU_X  , AAU_X , BBU_X  &
                          &, AD_X , BD_X  , AAD_X , BBD_X  &
                          &, AU_Y , BU_Y  , AAU_Y , BBU_Y &
                          &, AD_Y , BD_Y  , AAD_Y , BBD_Y      &
                          &, AU_Z , BU_Z  , AAU_Z , BBU_Z   &
                          &, AD_Z , BD_Z  , AAD_Z , BBD_Z  ) 
    
    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
    	  U(I,J,k) = U(I,J,k) + 0.5_DP*Dt*RHS(I,J,k)
    	! U(I,J,k) = (4.0_DP*U_old(I,J,k) + 2.0_DP*U(I,J,k) + Dt*RHS(I,J,k)) / 6.0_DP
      !U(I,J,K) = 1.0_DP/ 3.0_DP*U_OLD(I,J,K) + 2.0_DP/ 3.0_DP*U_2(I,J,K) + 2.0_DP/ 3.0_DP*Dt*RHS_2(I,J,K)
    END DO
    END DO
    END DO
    
    
      CALL BC_3D_LS(Nx , Ny , Nz , U)
    
      DO J = 2 , NY-1
      DO I = 2 , Nx-1
        U(I,J,1)  = UU(I,J,1)
      END DO
      END DO     
    

  END SUBROUTINE RK3_DRPCCD5TH_AD_TWIN_1
  
  
  
   SUBROUTINE RHS_DRPCCD(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y  , C_Z    &
                          &, K_X , K_Y , K_Z  , S , U , RHS           &
                          &, AU_X , BU_X  , AAU_X , BBU_X  &
                          &, AD_X , BD_X  , AAD_X , BBD_X  &
                          &, AU_Y , BU_Y  , AAU_Y , BBU_Y  &
                          &, AD_Y , BD_Y  , AAD_Y , BBD_Y    &
                          &, AU_Z , BU_Z  , AAU_Z , BBU_Z  &
                          &, AD_Z , BD_Z  , AAD_Z , BBD_Z )    
                        
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!     
  !Routine to compute RHS for using DRP for convective terms.
  !For the diffusion terms, CD2 is used.
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    IMPLICIT NONE

    INTEGER      ,INTENT(IN) :: Nx , Ny , NZ
    REAL(KIND=DP),INTENT(IN) :: Dx , Dy , DZ

    REAL(KIND=DP),INTENT(IN) :: C_X(:,:,:) , C_Y(:,:,:), C_Z(:,:,:)
    REAL(KIND=DP),INTENT(IN) :: K_X(:,:,:) , K_Y(:,:,:) , K_Z(:,:,:)
    REAL(KIND=DP),INTENT(IN) :: S(:,:,:) 

    REAL(KIND=DP),INTENT(OUT) :: RHS(:,:,:)

    REAL(KIND=DP) :: U_X(Nx,Ny,NZ) , U_Y(Nx,Ny,NZ) , U_Z(Nx,Ny,NZ) , U_old(Nx,Ny,NZ) , U(NX,NY,NZ)
    REAL(KIND=DP) :: U_XX(Nx,Ny,NZ) , U_YY(Nx,Ny,NZ) , U_XXX(Nx,Ny,NZ) , U_YYY(Nx,Ny,NZ) , U_ZZ(Nx,Ny,NZ) , U_ZZZ(Nx,Ny,NZ)
    
    INTEGER :: I , J , K
   
  
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AU_X , BU_X  , AAU_X , BBU_X 
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AD_X , BD_X , AAD_X , BBD_X 
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AU_Y , BU_Y , AAU_Y , BBU_Y  
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AD_Y , BD_Y  , AAD_Y , BBD_Y 
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AU_Z , BU_Z  , AAU_Z , BBU_Z 
  REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AD_Z , BD_Z  , AAD_Z , BBD_Z 
  
    DO K = 1 , NZ
    DO J = 1 , Ny
    DO I = 1 , Nx
      U_old(I,J,K) = U(I,J,K)
    END DO
    END DO
    END DO
    
    
  
    !! U(1,J)bCELL FACE ,  U_OLD(1,J)b CELL CENTER
   
  !  !Extrapolate value to ghost cell.
  !  DO J = 1 , Ny
  !    U_old(1,J)  = ( 8.0_DP * U(1,J)  - 6.0_DP * U(2,J)    + U(3,J)    ) / 3.0_DP
  !    U_old(Nx,J) = ( 8.0_DP * U(Nx,J) - 6.0_DP * U(Nx-1,J) + U(Nx-2,J) ) / 3.0_DP
  !   ! U_old(1,J)  = 2.0_DP * U(1,J)  - U(2,J)
  !   ! U_old(Nx,J) = 2.0_DP * U(Nx,J) - U(Nx-1,J)
  !
  !  END DO
  !
  !  DO I = 1 , Nx
  !    U_old(I,1)  = ( 8.0_DP * U(I,1)  - 6.0_DP * U(I,2)    + U(I,3)    ) / 3.0_DP
  !    U_old(I,Ny) = ( 8.0_DP * U(I,Ny) - 6.0_DP * U(I,Ny-1) + U(I,Ny-2) ) / 3.0_DP
  !   ! U_old(I,1)  = 2.0_DP * U(I,1)  - U(I,2)
  !   ! U_old(I,Ny) = 2.0_DP * U(I,Ny) - U(I,Ny-1)
  !
  !  END DO
    
   
    
    
    DO K = 1 , NZ
    DO J = 1 , Ny
      U_old(1,J,K)  = ( 8.0_DP * U(1,J,K)  - 6.0_DP * U(2,J,K)    + U(3,J,K)    ) / 3.0_DP
      U_old(Nx,J,K) = ( 8.0_DP * U(Nx,J,K) - 6.0_DP * U(Nx-1,J,K) + U(Nx-2,J,K) ) / 3.0_DP
     !  U_old(1,J,K)  = 2.0_DP * U(1,J,K)  - U(2,J,K)
     !  U_old(Nx,J,K) = 2.0_DP * U(Nx,J,K) - U(Nx-1,J,K)

    END DO
    END DO
    
   

    DO K = 1 , NZ
    DO I = 1 , Nx
      U_old(I,1,K)  = ( 8.0_DP * U(I,1,K)  - 6.0_DP * U(I,2,K)    + U(I,3,K)    ) / 3.0_DP
      U_old(I,Ny,K) = ( 8.0_DP * U(I,Ny,K) - 6.0_DP * U(I,Ny-1,K) + U(I,Ny-2,K) ) / 3.0_DP
    !  U_old(I,1,K)  = 2.0_DP * U(I,1,K)  - U(I,2,K)
    !  U_old(I,Ny,K) = 2.0_DP * U(I,Ny,K) - U(I,Ny-1,K)

    END DO
    END DO
    
    
   
    
    DO J = 1 , NY
    DO I = 1 , Nx
      U_old(I,J,1)  = ( 8.0_DP * U(I,J,1)  - 6.0_DP * U(I,J,2)    + U(I,J,3)    ) / 3.0_DP
      U_old(I,J,NZ) = ( 8.0_DP * U(I,J,NZ) - 6.0_DP * U(I,J,NZ-1) + U(I,J,NZ-2) ) / 3.0_DP
     ! U_old(I,1)  = 2.0_DP * U(I,1)  - U(I,2)
     ! U_old(I,Ny) = 2.0_DP * U(I,Ny) - U(I,Ny-1)

    END DO
    END DO
    
    
   
    
    
    U_old(1,1,1)   = (8.0_DP * U(1,1,1)   - 6.0_DP * U(2,2,2)       + U(3,3,3)      ) / 3.0_DP
    U_old(1,Ny,1)  = (8.0_DP * U(1,Ny,1)  - 6.0_DP * U(2,Ny-1,2)    + U(3,Ny-2,3)   ) / 3.0_DP
    U_old(Nx,1,1)  = (8.0_DP * U(Nx,1,1)  - 6.0_DP * U(Nx-1,2,2)    + U(Nx-2,3,3)   ) / 3.0_DP
    U_old(Nx,Ny,1) = (8.0_DP * U(Nx,Ny,1) - 6.0_DP * U(Nx-1,Ny-1,2) + U(Nx-2,Ny-2,3)) / 3.0_DP

    U_old(1,1,NZ)   = (8.0_DP * U(1,1,NZ)   - 6.0_DP * U(2,2,NZ-1)       + U(3,3,NZ-2)      ) / 3.0_DP
    U_old(1,Ny,NZ)  = (8.0_DP * U(1,Ny,NZ)  - 6.0_DP * U(2,Ny-1,NZ-1)    + U(3,Ny-2,NZ-2)   ) / 3.0_DP
    U_old(Nx,1,NZ)  = (8.0_DP * U(Nx,1,NZ)  - 6.0_DP * U(Nx-1,2,NZ-1)    + U(Nx-2,3,NZ-2)   ) / 3.0_DP
    U_old(Nx,Ny,NZ) = (8.0_DP * U(Nx,Ny,NZ) - 6.0_DP * U(Nx-1,Ny-1,NZ-1) + U(Nx-2,Ny-2,NZ-2)) / 3.0_DP

  !  U_old(1,1)   = 2.0_DP * U(1,1)   - U(2,2)
  !  U_old(1,Ny)  = 2.0_DP * U(1,Ny)  - U(2,Ny-1)
  !  U_old(Nx,1)  = 2.0_DP * U(Nx,1)  - U(Nx-1,2)
  !  U_old(Nx,Ny) = 2.0_DP * U(Nx,Ny) - U(Nx-1,Ny-1)



  
 
   CALL CCD_UD_TWIN_1(Nx , Ny , NZ , Dx , Dy , DZ , C_X , C_Y , C_Z , U_OLD , U_OLD  , U_OLD&
                         &, U_X , U_XX , U_Y , U_YY   , U_Z , U_ZZ  &
                         &, AU_X , BU_X  , AAU_X , BBU_X &
                         &, AD_X , BD_X  , AAD_X , BBD_X  &
                         &, AU_Y , BU_Y  , AAU_Y , BBU_Y  &
                         &, AD_Y , BD_Y  , AAD_Y , BBD_Y  &
                         &, AU_Z , BU_Z  , AAU_Z , BBU_Z &
                         &, AD_Z , BD_Z  , AAD_Z , BBD_Z )
   
         
     
    
  !  !Compute RHS
  !  !convective terms and source term
  
  
  
 !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP SHARED(RHS,C_x,U_X,C_Y,U_Y,C_Z,U_Z,S,Nx,NY,NZ) PRIVATE(I,J,K) 
  !$OMP DO 
    DO K = 2 , NZ-1
    DO J = 2 , Ny-1
    DO I = 2 , Nx-1
      RHS(I,J,K) = -C_X(I,J,K)*U_X(I,J,K) - C_Y(I,J,K)*U_Y(I,J,K) - C_Z(I,J,K)*U_Z(I,J,K)   &
                   & +  K_X(I,J,K)*U_XX(I,J,K) +  K_Y(I,J,K)*U_YY(I,J,K) +K_Z(I,J,K)*U_ZZ(I,J,K)  &
                   & + S(I,J,K)
    END DO
    END DO
    END DO
 !$OMP END DO
 !$OMP END PARALLEL

 END SUBROUTINE RHS_DRPCCD
 
 
 
  SUBROUTINE CCD_UD_TWIN_1(Nx , Ny , Nz  , Dx , Dy  , Dz , C_X , C_Y , C_Z , U , V , W &
                         &, U_X , U_XX  , V_Y , V_YY  , W_Z , W_ZZ &
                         &, AU_X , BU_X  , AAU_X , BBU_X &
                         &, AD_X , BD_X  , AAD_X , BBD_X &
                         &, AU_Y , BU_Y  , AAU_Y , BBU_Y  &
                         &, AD_Y , BD_Y  , AAD_Y , BBD_Y  &
                         &, AU_Z , BU_Z  , AAU_Z , BBU_Z  &
                         &, AD_Z , BD_Z  , AAD_Z , BBD_Z  )
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to solve U_X , U_XX , V_Y , V_YY by DRP-CCD.
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    IMPLICIT NONE

    INTEGER,INTENT(IN) :: Nx , Ny , Nz
    REAL(KIND=DP),INTENT(IN) :: Dx , Dy , Dz
    REAL(KIND=DP),DIMENSION(:,:,:),INTENT(IN) :: C_X , C_Y , C_Z , U , V , W
    REAL(KIND=DP),DIMENSION(:,:,:),INTENT(OUT) :: U_X , U_XX  , V_Y , V_YY  , W_Z , W_ZZ 

    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AU_X , BU_X  , AAU_X , BBU_X 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AD_X , BD_X  , AAD_X , BBD_X 

    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AU_Y , BU_Y  , AAU_Y , BBU_Y 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AD_Y , BD_Y  , AAD_Y , BBD_Y 
    
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AU_Z , BU_Z  , AAU_Z , BBU_Z 
    REAL(KIND=DP),DIMENSION(:,:),INTENT(IN) :: AD_Z , BD_Z  , AAD_Z , BBD_Z 

    REAL(KIND=DP) :: S(Nx,Ny,NZ) , SS(Nx,Ny,NZ) 
    REAL(KIND=DP) :: SD(Nx,Ny,NZ) , SSD(Nx,Ny,NZ)

    INTEGER :: I , J , K , Ierr


  
 

   ! DO K = 1 , NZ
   ! DO J = 1 , Ny
   ! 
   !   CALL ASSIGN_CCD_UD_TWIN_SRC_1(Nx , Dx , U(:,J,K) &
   !                            &, S(:,J,K) , SS(:,J,K)  , SD(:,J,K) , SSD(:,J,K) )
   !
   !   !solve CCD matrix
   !   CALL TWIN_BKS_1( AU_X, BU_X, AAU_X, BBU_X , S(:,J,K) , SS(:,J,K)  )
   !
   !   CALL TWIN_BKS_1( AD_X, BD_X , AAD_X, BBD_X , SD(:,J,K) , SSD(:,J,K)  )
   ! END DO
   ! END DO
    
    
    DO K = 1 , NZ
    DO J = 1 , Ny
    
      CALL ASSIGN_CCD_UD_TWIN_SRC(Nx , Dx , U(:,J,K) &
                               &, S(:,J,K) , SS(:,J,K)  , SD(:,J,K) , SSD(:,J,K) )

      !solve CCD matrix
      CALL TWIN_BKS( AU_X, BU_X, AAU_X, BBU_X , S(:,J,K) , SS(:,J,K)  )

      CALL TWIN_BKS( AD_X, BD_X , AAD_X, BBD_X , SD(:,J,K) , SSD(:,J,K)  )
    END DO
    END DO



    DO K = 1 , NZ
    DO J = 1 , Ny
    DO I = 1 , Nx
    	
      IF(C_X(I,J,K) >= 0.0_DP) THEN
        U_X(I,J,K)  = S(I,J,K)
      ELSE
        U_X(I,J,K)  = SD(I,J,K)
      END IF
      
        U_XX(I,J,K) = 0.5_DP*(SS(I,J,K) + SSD(I,J,K))
  
    END DO
    END DO
    END DO



   
   
    DO K = 1 , NZ
    DO I = 1 , Nx
    
      CALL ASSIGN_CCD_UD_TWIN_SRC(Ny , Dy , V(I,:,K) &
                               &, S(I,:,K) , SS(I,:,K) , SD(I,:,K) , SSD(I,:,K))

      !solve CCD matrix
      CALL TWIN_BKS( AU_Y, BU_Y, AAU_Y, BBU_Y , S(I,:,K) , SS(I,:,K)  )

      CALL TWIN_BKS( AD_Y, BD_Y, AAD_Y, BBD_Y, SD(I,:,K) , SSD(I,:,K)   )
      
    END DO
    END DO



    DO K = 1 , NZ
    DO J = 1 , Ny
    DO I = 1 , Nx
    	
        IF(C_Y(I,J,K) >= 0.0_DP) THEN
          V_Y(I,J,K)  = S(I,J,K)
        ELSE
          V_Y(I,J,K)  = SD(I,J,K)
        END IF
        
         V_YY(I,J,K) = 0.5_DP*(SS(I,J,K) + SSD(I,J,K))
      
    END DO
    END DO
    END DO
    
    
    
    DO J = 1 , NY
    DO I = 1 , Nx
    
      CALL ASSIGN_CCD_UD_TWIN_SRC(NZ , DZ , W(I,J,:) &
                               &, S(I,J,:) , SS(I,J,:)  , SD(I,J,:) , SSD(I,J,:) )

      !solve CCD matrix
      CALL TWIN_BKS( AU_Z, BU_Z, AAU_Z, BBU_Z , S(I,J,:) , SS(I,J,:)  )

      CALL TWIN_BKS( AD_Z, BD_Z, AAD_Z, BBD_Z, SD(I,J,:) , SSD(I,J,:)  )
    END DO
    END DO



    DO K = 1 , NZ
    DO J = 1 , Ny
    DO I = 1 , Nx
    	
        IF(C_Z(I,J,K) >= 0.0_DP) THEN
          W_Z(I,J,K)  = S(I,J,K)
        ELSE
          W_Z(I,J,K)  = SD(I,J,K)
        END IF
        
          W_ZZ(I,J,K) = 0.5_DP*(SS(I,J,K) + SSD(I,J,K))
     
    END DO
    END DO
    END DO


  END SUBROUTINE CCD_UD_TWIN_1
  
  
  SUBROUTINE Cell_face_velocity_FV(Nx , Ny , NZ ,  C_X , C_Y , C_Z ,  Uc , Vc , Wc)
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   !Routine to compute cell-face velocity on uniform cell-center FV.
   !Compute cell-face velocity using simple average
   !
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     INTEGER,INTENT(IN) :: Nx , Ny  ,NZ
     REAL(KIND=DP),INTENT(IN ) :: C_X(:,:,:) , C_Y(:,:,:) , C_Z(:,:,:) 
     REAL(KIND=DP),INTENT(OUT) ::  Uc(:,:,:) ,  Vc(:,:,:) ,  Wc(:,:,:) 
 
     INTEGER :: I , J ,  K 
 
     Uc = 0.0_DP
     Vc = 0.0_DP
     Wc = 0.0_DP   
 
 
    
      !Compute cell face value Uc , Vc
     !For Uc
     DO K = 2 , NZ-1
     DO J = 2 , Ny-1
       Uc(1,J,K)    = C_X(1,J,K)
       Uc(Nx-1,J,K) = C_X(Nx,J,K)
     ENDDO
     ENDDO
    
      DO K = 2 , NZ-1   
      DO J = 2 , Ny-1   
      DO I = 2 , Nx-2
         Uc(I,J,K) = 0.5_DP * (C_X(I+1,J,K) + C_X(I,J,K))
      ENDDO
      ENDDO
      ENDDO
 
     !For Vc
     DO K = 2 , NZ-1 
     DO I = 2 , Nx-1
       Vc(I,1,K)    = C_Y(I,1,K)
       Vc(I,Ny-1,K) = C_Y(I,Ny,K)
     ENDDO
     ENDDO
  
     DO K = 2 , NZ-1
     DO J = 2 , Ny-2 
     DO I = 2 , Nx-1
         Vc(I,J,K) = 0.5_DP * (C_Y(I,J+1,K) + C_Y(I,J,K))
     ENDDO
     ENDDO
     ENDDO
     
     
      !For Wc
     DO J = 2 , NY-1 
     DO I = 2 , Nx-1
       Wc(I,J,1)    = C_Z(I,J,1)
       Wc(I,J,NZ-1) = C_Z(I,J,NZ)
     ENDDO
     ENDDO
  
     DO K = 2 , NZ-2 
     DO J = 2 , Ny-1
     DO I = 2 , Nx-1
     
         Wc(I,J,K) = 0.5_DP * (C_Z(I,J,K+1) + C_Z(I,J,K))
     ENDDO
     ENDDO
     ENDDO
     
     
 
   END SUBROUTINE Cell_face_velocity_FV
   
   
   
  SUBROUTINE ASSIGN_CCD_UD_TWIN_SRC_1(N , Dx , U , S , SS , SD , SSD)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to assign CCD source term.
  !  DU are for the upwind coeff.
  !  DD are for the downwind coeff.
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    IMPLICIT NONE

    INTEGER,INTENT(IN) :: N
    REAL(KIND=DP)             ,INTENT(IN ) :: Dx
    REAL(KIND=DP),DIMENSION(:),INTENT(IN ) :: U
    REAL(KIND=DP),DIMENSION(:),INTENT(OUT) :: S , SS
    REAL(KIND=DP),DIMENSION(:),INTENT(OUT) :: SD , SSD

    REAL(KIND=DP) :: C1 , C2 , C3
    REAL(KIND=DP) :: C1D , C2D , C3D
    REAL(KIND=DP) :: CC1 , CC2 , CC3

    INTEGER:: I

  
    
     !For ux eq., a>0
    C1 = -1.93629468537011_DP
    C2 =  1.99758937102742_DP
    C3 = -0.061294685370110_DP

    !For ux eq., a<0
    C1D =  0.061294685370110_DP
    C2D = -1.99758937102742_DP
    C3D =  1.93629468537011_DP


    !For uxx eq.
    CC1 =  3.0_DP
    CC2 = -6.0_DP
    CC3 =  3.0_DP

  !For upwind
    !For I = 1
     !U_X
      S(1)  = (-3.5_DP * U(1) + 4.0_DP * U(2) - 0.5_DP * U(3)) / Dx
     !U_XX
      SS(1) = ( 34.0_DP / 3.0_DP * U(1) - 83.0_DP / 4.0_DP * U(2) &
            &  +10.0_DP * U(3) -7.0_DP/12.0_DP * U(4) ) / (Dx**2)

    !For I = 2 , N-1
    DO I = 2 , N-1
    	!U_X
      S(I)  = (C1*U(I-1) + C2*U(I) + C3*U(I+1)) / Dx
      !U_XX
      SS(I) = (CC1*U(I-1) + CC2*U(I) + CC3*U(I+1)) / (Dx**2)
    END DO

    !For I = N
     !U_X
     S(N)  = -(-3.5_DP * U(N) + 4.0_DP * U(N-1) - 0.5_DP * U(N-2)) / Dx
     !U_XX
     SS(N) = ( 34.0_DP / 3.0_DP * U(N) - 83.0_DP / 4.0_DP * U(N-1) &
           &  +10.0_DP * U(N-2) -7.0_DP/12.0_DP * U(N-3) ) / (Dx**2)



  !For Downwind
    !For I = 1
     !U_X
      SD(1)  = (-3.5_DP * U(1) + 4.0_DP * U(2) - 0.5_DP * U(3)) / Dx
     !U_XX
      SSD(1) = ( 34.0_DP / 3.0_DP * U(1) - 83.0_DP / 4.0_DP * U(2) &
            &  +10.0_DP * U(3) -7.0_DP/12.0_DP * U(4) ) / (Dx**2)

    !For I = 2 , N-1
    DO I = 2 , N-1
    	!U_X
      SD(I)  = (C1D*U(I-1) + C2D*U(I) + C3D*U(I+1)) / Dx
      !U_XX
      SSD(I) = (CC1*U(I-1) + CC2*U(I) + CC3*U(I+1)) / (Dx**2)
    END DO

    !For I = N
     !U_X
     SD(N)  = -(-3.5_DP * U(N) + 4.0_DP * U(N-1) - 0.5_DP * U(N-2)) / Dx
     !U_XX
     SSD(N) = ( 34.0_DP / 3.0_DP * U(N) - 83.0_DP / 4.0_DP * U(N-1) &
           &  +10.0_DP * U(N-2) -7.0_DP/12.0_DP * U(N-3) ) / (Dx**2)

  END SUBROUTINE ASSIGN_CCD_UD_TWIN_SRC_1
  
  
  
   SUBROUTINE ASSIGN_CCD_UD_TWIN_SRC(N , Dx , U , S , SS , SD , SSD)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to assign CCD source term.
  !  DU are for the upwind coeff.
  !  DD are for the downwind coeff.
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    IMPLICIT NONE

    INTEGER,INTENT(IN) :: N
    REAL(KIND=DP)             ,INTENT(IN ) :: Dx
    REAL(KIND=DP),DIMENSION(:),INTENT(IN ) :: U
    REAL(KIND=DP),DIMENSION(:),INTENT(OUT) :: S , SS
    REAL(KIND=DP),DIMENSION(:),INTENT(OUT) :: SD , SSD

    REAL(KIND=DP) :: C1 , C2 , C3
    REAL(KIND=DP) :: C1D , C2D , C3D
    REAL(KIND=DP) :: CC1 , CC2 , CC3

    INTEGER:: I

  !  !For ux eq., a>0
  !  C1 = -1.9359611900810925272_DP
  !  C2 =  1.9969223801621850545_DP
  !  C3 = -0.060961190081092527237_DP

  !  !For ux eq., a<0
  !  C1D =  0.060961190081092527237_DP
  !  C2D = -1.9969223801621850545_DP
  !  C3D =  1.9359611900810925272_DP


   ! !For ux eq., a>0
   ! C1 = -1.9318089987023651093_DP
   ! C2 =  1.9886179974047302197_DP
   ! C3 = -0.056808998702365109925_DP
   !
   ! !For ux eq., a<0
   ! C1D =  0.056808998702365109925_DP
   ! C2D = -1.9886179974047302197_DP
   ! C3D =  1.9318089987023651093_DP
    
     !For ux eq., a>0
    C1 = -1.93629468537011_DP
    C2 =  1.99758937102742_DP
    C3 = -0.061294685370110_DP

    !For ux eq., a<0
    C1D =  0.061294685370110_DP
    C2D = -1.99758937102742_DP
    C3D =  1.93629468537011_DP


    !For uxx eq.
    CC1 =  3.0_DP
    CC2 = -6.0_DP
    CC3 =  3.0_DP

  !For upwind
    !For I = 1
     !U_X
      S(1)  = (-3.5_DP * U(1) + 4.0_DP * U(2) - 0.5_DP * U(3)) / Dx
     !U_XX
      SS(1) = ( 34.0_DP / 3.0_DP * U(1) - 83.0_DP / 4.0_DP * U(2) &
            &  +10.0_DP * U(3) -7.0_DP/12.0_DP * U(4) ) / (Dx**2)

    !For I = 2 , N-1
    DO I = 2 , N-1
    	!U_X
      S(I)  = (C1*U(I-1) + C2*U(I) + C3*U(I+1)) / Dx
      !U_XX
      SS(I) = (CC1*U(I-1) + CC2*U(I) + CC3*U(I+1)) / (Dx**2)
    END DO

    !For I = N
     !U_X
     S(N)  = -(-3.5_DP * U(N) + 4.0_DP * U(N-1) - 0.5_DP * U(N-2)) / Dx
     !U_XX
     SS(N) = ( 34.0_DP / 3.0_DP * U(N) - 83.0_DP / 4.0_DP * U(N-1) &
           &  +10.0_DP * U(N-2) -7.0_DP/12.0_DP * U(N-3) ) / (Dx**2)



  !For Downwind
    !For I = 1
     !U_X
      SD(1)  = (-3.5_DP * U(1) + 4.0_DP * U(2) - 0.5_DP * U(3)) / Dx
     !U_XX
      SSD(1) = ( 34.0_DP / 3.0_DP * U(1) - 83.0_DP / 4.0_DP * U(2) &
            &  +10.0_DP * U(3) -7.0_DP/12.0_DP * U(4) ) / (Dx**2)

    !For I = 2 , N-1
    DO I = 2 , N-1
    	!U_X
      SD(I)  = (C1D*U(I-1) + C2D*U(I) + C3D*U(I+1)) / Dx
      !U_XX
      SSD(I) = (CC1*U(I-1) + CC2*U(I) + CC3*U(I+1)) / (Dx**2)
    END DO

    !For I = N
     !U_X
     SD(N)  = -(-3.5_DP * U(N) + 4.0_DP * U(N-1) - 0.5_DP * U(N-2)) / Dx
     !U_XX
     SSD(N) = ( 34.0_DP / 3.0_DP * U(N) - 83.0_DP / 4.0_DP * U(N-1) &
           &  +10.0_DP * U(N-2) -7.0_DP/12.0_DP * U(N-3) ) / (Dx**2)

  END SUBROUTINE ASSIGN_CCD_UD_TWIN_SRC
  
  
   SUBROUTINE TWIN_BKS_1( A, B, AA, BB, S , SS )
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to solve the CCD matrix by twin-elimination method.
  !
  !Input is the twin-forward elimination matrix and CCD source terms.
  !Output is solution.
  !Note that twin-forward elimination matrix is never changed.
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    REAL(KIND=DP), INTENT(IN   ), DIMENSION(:,:) :: A,  B
    REAL(KIND=DP), INTENT(IN   ), DIMENSION(:,:) :: AA, BB
    REAL(KIND=DP), INTENT(INOUT), DIMENSION(:) :: S , SS
   !--------------
    INTEGER       :: i, n
    REAL(KIND=DP) :: Den, SolS, SolSS

    n = SIZE(A,DIM=2)

    DO i = 2, N
      S(i)  = S(i)  -(  A(1,i)*S(i-1) +  B(1,i)*SS(i-1) )
      SS(i) = SS(i) -( AA(1,i)*S(i-1) + BB(1,i)*SS(i-1) )
    END DO

    Den   = A(2,n)*BB(2,n) - AA(2,n)*B(2,n)
    SolS  = -( B(2,n)*SS(n) - BB(2,n)*S(n) )/Den
    SolSS =  ( A(2,n)*SS(n) - AA(2,n)*S(n) )/Den
    S(n)  = SolS
    SS(n) = SolSS

    DO i = N-1, 1,-1

    	S(i)  = S(i)  - (  A(3,i)*SolS +  B(3,i)*SolSS )
    	SS(i) = SS(i) - ( AA(3,i)*SolS + BB(3,i)*SolSS )

      Den   = A(2,i)*BB(2,i) - AA(2,i)*B(2,i)
      SolS  = -( B(2,i)*SS(i) - BB(2,i)*S(i))/Den
      SolSS =  ( A(2,i)*SS(i) - AA(2,i)*S(i))/Den
      S(i)  = SolS
      SS(i) = SolSS

    END DO



  END SUBROUTINE TWIN_BKS_1
  
  
  
   SUBROUTINE TWIN_BKS( A, B, AA, BB, S , SS )
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to solve the CCD matrix by twin-elimination method.
  !
  !Input is the twin-forward elimination matrix and CCD source terms.
  !Output is solution.
  !Note that twin-forward elimination matrix is never changed.
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    REAL(KIND=DP), INTENT(IN   ), DIMENSION(:,:) :: A,  B
    REAL(KIND=DP), INTENT(IN   ), DIMENSION(:,:) :: AA, BB
    REAL(KIND=DP), INTENT(INOUT), DIMENSION(:) :: S , SS
   !--------------
    INTEGER       :: i, n
    REAL(KIND=DP) :: Den, SolS, SolSS

    n = SIZE(A,DIM=2)

    DO i = 2, N
      S(i)  = S(i)  -(  A(1,i)*S(i-1) +  B(1,i)*SS(i-1) )
      SS(i) = SS(i) -( AA(1,i)*S(i-1) + BB(1,i)*SS(i-1) )
    END DO

    Den   = A(2,n)*BB(2,n) - AA(2,n)*B(2,n)
    SolS  = -( B(2,n)*SS(n) - BB(2,n)*S(n) )/Den
    SolSS =  ( A(2,n)*SS(n) - AA(2,n)*S(n) )/Den
    S(n)  = SolS
    SS(n) = SolSS

    DO i = N-1, 1,-1

    	S(i)  = S(i)  - (  A(3,i)*SolS +  B(3,i)*SolSS )
    	SS(i) = SS(i) - ( AA(3,i)*SolS + BB(3,i)*SolSS )

      Den   = A(2,i)*BB(2,i) - AA(2,i)*B(2,i)
      SolS  = -( B(2,i)*SS(i) - BB(2,i)*S(i))/Den
      SolSS =  ( A(2,i)*SS(i) - AA(2,i)*S(i))/Den
      S(i)  = SolS
      SS(i) = SolSS

    END DO



  END SUBROUTINE TWIN_BKS