 SUBROUTINE WENO_RK_AD(m , n , L,  fhi , u , v , W,  Dx , Dy ,  DZ ,  Dt  )
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to do level set method 
  !with renormailze tech mass preserving tech.
  !
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
    
    INTEGER,INTENT(IN) :: m , n  , L 
    REAL(KIND=DP),INTENT(INOUT) :: fhi(:,:,:) 
    REAL(KIND=DP),INTENT(IN)    :: u(:,:,:) , v(:,:,:) , W(:,:,:) , dx , dy , dZ , Dt



    REAL(KIND=DP) :: fin(-2:m+3,-2:n+3,-2:L+3),fi1(-2:m+3,-2:n+3,-2:L+3), &
	                   fi2(-2:m+3,-2:n+3,-2:L+3),fi0(-2:m+3,-2:n+3,-2:L+3), &
	                   finp1(-2:m+3,-2:n+3,-2:L+3),Lfin(-2:m+3,-2:n+3,-2:L+3), &
		                 Lfi1(-2:m+3,-2:n+3,-2:L+3), &
		                 Lfi2(-2:m+3,-2:n+3,-2:L+3)
		                 
		                 
	  REAL(KIND=DP) :: fh(-2:m+3,-2:n+3,-2:L+3), uh(-2:m+3,-2:n+3,-2:L+3),&
	                   up(-2:m+3,-2:n+3,-2:L+3),um(-2:m+3,-2:n+3,-2:L+3)
		                 
	
	
	  REAL(KIND=DP) :: gh(-2:m+3,-2:n+3,-2:L+3),vh(-2:m+3,-2:n+3,-2:L+3), &
	                   vp(-2:m+3,-2:n+3,-2:L+3),vm(-2:m+3,-2:n+3,-2:L+3)
	                   
	                   
	 REAL(KIND=DP) ::  Hh(-2:m+3,-2:n+3,-2:L+3),Wh(-2:m+3,-2:n+3,-2:L+3), &
	                   Wp(-2:m+3,-2:n+3,-2:L+3),Wm(-2:m+3,-2:n+3,-2:L+3)                  
	                   
	   
	  REAL(KIND=DP) :: f(-2:m+3,-2:n+3,-2:L+3),  dfp(-2:m+3,-2:n+3,-2:L+3) , dfm(-2:m+3,-2:n+3,-2:L+3)
	                   
	                   
	                   
   
    REAL(KIND=DP) :: tend1 , vol
    
    INTEGER :: I , J  , K 
    
    fin(1:M,1:N,1:L) = fhi(1:M,1:N,1:L)
    uh(1:M,1:N,1:L) = u(1:M,1:N,1:L)
    vh(1:M,1:N,1:L) = v(1:M,1:N,1:L)
    Wh(1:M,1:N,1:L) = W(1:M,1:N,1:L)
    
    
    CALL BC3D(UH,M,N,L)
    CALL BC3D(VH,M,N,L) 
    CALL BC3D(WH,M,N,L)
    CALL BC3D(FIN,M,N,L)
  

	  DO K=-2,L+3	
    DO J=-2,N+3
    DO I=-2,M+3
	  	
	    up(i,j,K)=0.5_DP*( uh(i,j,K)+abs(uh(i,j,K)) )
	    um(i,j,K)=0.5_DP*( uh(i,j,K)-abs(uh(i,j,K)) )
	    
	    vp(i,j,K)=0.5_DP*( vh(i,j,K)+abs(vh(i,j,K)) )
	    vm(i,j,K)=0.5_DP*( vh(i,j,K)-abs(vh(i,j,K)) )
	    
	    Wp(i,j,K)=0.5_DP*( Wh(i,j,K)+abs(Wh(i,j,K)) )
	    Wm(i,j,K)=0.5_DP*( Wh(i,j,K)-abs(Wh(i,j,K)) )
	    
	  enddo
	  enddo
	  enddo
        
        
	   call rk3(fin,fi1,fi2,finp1,Lfin,Lfi1,Lfi2, &
	            fh,uh,up,um,f,dfp,dfm,gh,vh,vp,vm,Hh,Wh,Wp,Wm, &
              m,n,L,dx,dy,DZ,dt)

      
      
      DO K=-2,L+3	
      DO J=-2,N+3
      DO I=-2,M+3
     
        FI0(I,J,K)=FINP1(I,J,K)
        FIN(I,J,K)=FINP1(I,J,K)
      ENDDO
      ENDDO
      ENDDO

 



     fhi(1:m,1:n,1:L) = fin(1:m,1:n,1:L)
                
   
	  
  END SUBROUTINE WENO_RK_AD
  
  
  
    subroutine rk3(fin,fi1,fi2,finp1,Lfin,Lfi1,Lfi2, &
	                 fh,u,up,um,f,dfp,dfm,gh,v,vp,vm,Hh,W,Wp,Wm, &
                   m,n,L,dx,dy,DZ,dt)
                   
              
                   
!
!     rk3 --- Solve FIt + fx + gy + hz =0 via 3rd order Runge-Kutta method
!     modified on 2004,04,09
!
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)

    REAL(KIND=DP),INTENT(IN) :: Dx , Dy , DZ ,  dt
    INTEGER,INTENT(IN) :: m , n , L

	!  REAL(KIND=DP) :: fin(-2:m+3,-2:n+3),fi1(-2:m+3,-2:n+3), &
	!                   fi2(-2:m+3,-2:n+3), &
	!                   finp1(-2:m+3,-2:n+3),Lfin(-2:m+3,-2:n+3), &
	!	                 Lfi1(-2:m+3,-2:n+3), &
	!	                 Lfi2(-2:m+3,-2:n+3)
	!	                 
	!  REAL(KIND=DP) :: fh(-2:m+3,-2:n+3),u(-2:m+3,-2:n+3), &
	!                   up(-2:m+3,-2:n+3),um(-2:m+3,-2:n+3), &
	!	                 f(-2:m+3,-2:n+3), &
	!	                 dfp(-2:m+3,-2:n+3),dfm(-2:m+3,-2:n+3)
	!	                 
	!  REAL(KIND=DP) :: gh(-2:m+3,-2:n+3),v(-2:m+3,-2:n+3), &
	!                   vp(-2:m+3,-2:n+3),vm(-2:m+3,-2:n+3)
	          
	          
	  REAL(KIND=DP) :: fin(-2:m+3,-2:n+3,-2:L+3),fi1(-2:m+3,-2:n+3,-2:L+3), &
	                   fi2(-2:m+3,-2:n+3,-2:L+3),fi0(-2:m+3,-2:n+3,-2:L+3), &
	                   finp1(-2:m+3,-2:n+3,-2:L+3),Lfin(-2:m+3,-2:n+3,-2:L+3), &
		                 Lfi1(-2:m+3,-2:n+3,-2:L+3), &
		                 Lfi2(-2:m+3,-2:n+3,-2:L+3)
		                 		                 
	  REAL(KIND=DP) :: fh(-2:m+3,-2:n+3,-2:L+3), u(-2:m+3,-2:n+3,-2:L+3),&
	                   up(-2:m+3,-2:n+3,-2:L+3), um(-2:m+3,-2:n+3,-2:L+3)
		                 
	  REAL(KIND=DP) :: gh(-2:m+3,-2:n+3,-2:L+3), v(-2:m+3,-2:n+3,-2:L+3), &
	                   vp(-2:m+3,-2:n+3,-2:L+3), vm(-2:m+3,-2:n+3,-2:L+3)
	                   
	                   
	  REAL(KIND=DP) ::  Hh(-2:m+3,-2:n+3,-2:L+3), W(-2:m+3,-2:n+3,-2:L+3), &
	                    Wp(-2:m+3,-2:n+3,-2:L+3), Wm(-2:m+3,-2:n+3,-2:L+3)                  
	                    
	  REAL(KIND=DP) :: f(-2:m+3,-2:n+3,-2:L+3),  dfp(-2:m+3,-2:n+3,-2:L+3) , dfm(-2:m+3,-2:n+3,-2:L+3)        
	          
	                   

    INTEGER :: I , J , K



     call fflux(fh,fin,u,up,um,f,dfp,dfm,m,n,L)
	   call gflux(gh,fin,v,vp,vm,f,dfp,dfm,m,n,L)
	   call Hflux(Hh,fin,W,Wp,Wm,f,dfp,dfm,m,n,L)
	   call LphyL(Lfin,fh,gh,HH,m,n,L,dx,dy,DZ)

	 
	  do K=2,L-1
	  do j=2,n-1
	  do i=2,m-1
	 
	    fi1(i,j,K)=fin(i,j,K)+dt*Lfin(i,j,K)
	  enddo
	  enddo
	  enddo

    CALL  BC3D(FI1,M,N,L)

       
     call fflux(fh,fi1,u,up,um,f,dfp,dfm,m,n,L)
	   call gflux(gh,fi1,v,vp,vm,f,dfp,dfm,m,n,L)
	   call Hflux(Hh,fi1,W,Wp,Wm,f,dfp,dfm,m,n,L)
	   call LphyL(Lfi1,fh,gh,HH,m,n,L,dx,dy,DZ)

	  do K=2,L-1
	  do j=2,n-1
	  do i=2,m-1
	    fi2(i,j,K)=fi1(i,j,K)+dt/4.0_DP*(-3.0_DP*Lfin(i,j,K)+Lfi1(i,j,K))
	  enddo
	  enddo
    enddo
   
    CALL BC3D(FI2,M,N,L)


      call fflux(fh,fi2,u,up,um,f,dfp,dfm,m,n,L)
  	  call gflux(gh,fi2,v,vp,vm,f,dfp,dfm,m,n,L)
  	  call Hflux(Hh,fi2,W,Wp,Wm,f,dfp,dfm,m,n,L)
  	  call LphyL(Lfi2,fh,gh,HH,m,n,L,dx,dy,DZ)


	   do K=2,L-1
	   do j=2,n-1
	   do i=2,m-1
	     finp1(i,j,K)=fi2(i,j,K)+dt/12.0_DP*(-Lfin(i,j,K)-Lfi1(i,j,K)+8.0_DP*Lfi2(i,j,K))
	   enddo
	   enddo
	   enddo

  
    CALL BC3D(FINP1,M,N,L)
 
    

	  End subroutine rk3
	  
	  
	  
	  
	 subroutine fflux(fh,fi,u,up,um,f,dfp,dfm,m,n,L)
!
!     fflux --- give fi, u, u+, u- to calculate fh at i+1/2
!     f, dfp, dfm are dummy array
!
		                 
    INTEGER,INTENT(IN) :: m , n , L

    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
	  REAL(KIND=DP) :: fh(-2:m+3,-2:n+3,-2:L+3),fi(-2:m+3,-2:n+3,-2:L+3),u(-2:m+3,-2:n+3,-2:L+3), &
	                   up(-2:m+3,-2:n+3,-2:L+3),um(-2:m+3,-2:n+3,-2:L+3),f(-2:m+3,-2:n+3,-2:L+3), &
		                 dfp(-2:m+3,-2:n+3,-2:L+3),dfm(-2:m+3,-2:n+3,-2:L+3)

    
    INTEGER :: I , J , K
    
    		                 
	  DO K=1,L
	  do j=1,n
    do i=0,m+1
	    f(i,j,K)=u(i,j,K)*fi(i,j,K)
	  enddo
	  enddo
	  enddo
	  
	 
	  DO K=1,L
	  do j=1,n
	  do i=-1,m+1
	
		
	    dfp(i,j,K)=up(i+1,j,K)*fi(i+1,j,K)-up(i,j,K)*fi(i,j,K)
	    dfm(i,j,K)=um(i+1,j,K)*fi(i+1,j,K)-um(i,j,K)*fi(i,j,K)
	    
	  enddo
	  enddo
	  enddo
	  
	
	   DO K=1,L
	   do j=1,n
     do i=1,m-1
     
     	 	
	    fh(i,j,K)=1.0_DP/12.0_DP*(-f(i-1,j,K)+7.0_DP*f(i,j,K)+7.0_DP*f(i+1,j,K)-f(i+2,j,K)) &
		       -phyn(dfp(i-2,j,K),dfp(i-1,j,K),dfp(i,j,K),dfp(i+1,j,K)) &
		       +phyn(dfm(i+2,j,K),dfm(i+1,j,K),dfm(i,j,K),dfm(i-1,j,K))
		       
	   enddo
	   enddo
	   ENDDO

	  end subroutine fflux
	  
	  
	  
	   subroutine gflux(gh,fi,v,vp,vm,g,dgp,dgm,m,n,L)
	   
	   
!
!     gflux --- give fi, v, v+, v- to calculate gh at j+1/2
!     g, dgp, dgm are dummy array
!
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)

    INTEGER,INTENT(IN) :: m , n  , L
	  REAL(KIND=DP) :: gh(-2:m+3,-2:n+3,-2:L+3),fi(-2:m+3,-2:n+3,-2:L+3),v(-2:m+3,-2:n+3,-2:L+3), &
	                   vp(-2:m+3,-2:n+3,-2:L+3),vm(-2:m+3,-2:n+3,-2:L+3),g(-2:m+3,-2:n+3,-2:L+3), &
		                 dgp(-2:m+3,-2:n+3,-2:L+3),dgm(-2:m+3,-2:n+3,-2:L+3)
    

    
    INTEGER :: I , J , K
        		                 
    DO K=1,L 
	  do j=0,n+1
	  do i=1,m	
	    g(i,j,K)=v(i,j,K)*fi(i,j,K)
	  enddo
	  enddo
	  enddo
	  
	  DO K=1,L
	  do j=-1,n+1
	  do i=1,m	
	  	
	    dgp(i,j,K)=vp(i,j+1,K)*fi(i,j+1,K)-vp(i,j,K)*fi(i,j,K)
	    dgm(i,j,K)=vm(i,j+1,K)*fi(i,j+1,K)-vm(i,j,K)*fi(i,j,K)
	  
	  enddo
	  enddo
	  enddo
	  
	  
	  
    DO K=1,L   
	  do j=1,n-1
	  do i=1,m 	
	    gh(i,j,K)=1.0_DP/12.0_DP*(-g(i,j-1,K)+7.0*g(i,j,K)+7.0*g(i,j+1,K)-g(i,j+2,K) ) &
		         -phyn(dgp(i,j-2,K),dgp(i,j-1,K),dgp(i,j,K),dgp(i,j+1,K)) &
		         +phyn(dgm(i,j+2,K),dgm(i,j+1,K),dgm(i,j,K),dgm(i,j-1,K))
	  enddo
	  enddo
	  enddo

   end subroutine gflux
   
   
    subroutine Hflux(gh,fi,v,vp,vm,g,dgp,dgm,m,n,L)
	   
	   
!
!     gflux --- give fi, v, v+, v- to calculate gh at j+1/2
!     g, dgp, dgm are dummy array
!
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)

    INTEGER,INTENT(IN) :: m , n  , L
	  REAL(KIND=DP) :: gh(-2:m+3,-2:n+3,-2:L+3),fi(-2:m+3,-2:n+3,-2:L+3),v(-2:m+3,-2:n+3,-2:L+3), &
	                   vp(-2:m+3,-2:n+3,-2:L+3),vm(-2:m+3,-2:n+3,-2:L+3),g(-2:m+3,-2:n+3,-2:L+3), &
		                 dgp(-2:m+3,-2:n+3,-2:L+3),dgm(-2:m+3,-2:n+3,-2:L+3)
    

    
    INTEGER :: I , J , K
        		                 
    DO K=0,L+1 
	  do j=1,n
	  do i=1,m	
	    g(i,j,K)=v(i,j,K)*fi(i,j,K)
	  enddo
	  enddo
	  enddo
	  
	  DO K=-1,L+1
	  do j=1,n
	  do i=1,m	
	  	
	    dgp(i,j,K)=vp(i,j,K+1)*fi(i,j,K+1)-vp(i,j,K)*fi(i,j,K)
	    dgm(i,j,K)=vm(i,j,K+1)*fi(i,j,K+1)-vm(i,j,K)*fi(i,j,K)
	  
	  enddo
	  enddo
	  enddo
	  
	  
	  
    DO K=1,L-1  
	  do j=1,n
	  do i=1,m 	
	    gh(i,j,K)=1.0_dp/12.0_dp*(-g(i,j,K-1)+7.0*g(i,j,K)+7.0*g(i,j,K+1)-g(i,j,K+2) ) &
		         -phyn(dgp(i,j,K-2),dgp(i,j,K-1),dgp(i,j,K),dgp(i,j,K+1)) &
		         +phyn(dgm(i,j,K+2),dgm(i,j,K+1),dgm(i,j,K),dgm(i,j,K-1))
	  enddo
	  enddo
	  enddo

   end subroutine Hflux
   
   
   subroutine LphyL(Lfi,fh,gh,HH,m,n,L,dx,dy,DZ)
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)  

	  REAL(KIND=DP),INTENT(IN) :: Dx , Dy , DZ
	  INTEGER,INTENT(IN) :: m , n , L       
	  REAL(KIND=DP) :: Lfi(-2:m+3,-2:n+3,-2:L+3),fh(-2:m+3,-2:n+3,-2:L+3),gh(-2:m+3,-2:n+3,-2:L+3),Hh(-2:m+3,-2:n+3,-2:L+3)
	  
	 
	  
	  INTEGER :: I , J
	  
    do K=2,L-1
    do j=2,n-1
    do i=2,m-1
	  
	    Lfi(i,j,K)=-(fh(i,j,K)-fh(i-1,j,K))/dx-(gh(i,j,K)-gh(i,j-1,K))/dy -(Hh(i,j,K)-Hh(i,J,K-1))/dZ 
	    
	  enddo
	  enddo
	  enddo

	  end subroutine LphyL  