SUBROUTINE WENO_RK(m , n , L  , ffhi  , Dx , Dy   , DZ , Dt , imass )
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !Routine to do level set method 
  !with renormailze tech mass preserving tech.
  !
  !
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
    
    INTEGER,INTENT(IN) :: m , n ,  L  , imass
    REAL(KIND=DP),INTENT(INOUT) :: ffhi(:,:,:) 
    REAL(KIND=DP),INTENT(IN)    :: dx , dy  , dZ , Dt

    REAL(KIND=DP) :: fin(-2:m+3,-2:n+3,-2:L+3),fi1(-2:m+3,-2:n+3,-2:L+3),fi(-2:m+3,-2:n+3,-2:L+3), &
	                   fi2(-2:m+3,-2:n+3,-2:L+3),fi0(-2:m+3,-2:n+3,-2:L+3), &
	                   finp1(-2:m+3,-2:n+3,-2:L+3),Lfin(-2:m+3,-2:n+3,-2:L+3), &
		                 Lfi1(-2:m+3,-2:n+3,-2:L+3), &
		                 Lfi2(-2:m+3,-2:n+3,-2:L+3), fhi(-2:m+3,-2:n+3,-2:L+3)
	  REAL(KIND=DP) :: fh(-2:m+3,-2:n+3,-2:L+3), uh(-2:m+3,-2:n+3,-2:L+3),&
	                   up(-2:m+3,-2:n+3,-2:L+3),um(-2:m+3,-2:n+3,-2:L+3), &
		                 f(-2:m+3,-2:n+3,-2:L+3), &
		                 dfp(-2:m+3,-2:n+3,-2:L+3),dfm(-2:m+3,-2:n+3,-2:L+3)
	  REAL(KIND=DP) :: gh(-2:m+3,-2:n+3,-2:L+3),vh(-2:m+3,-2:n+3,-2:L+3), &
	                   vp(-2:m+3,-2:n+3,-2:L+3),vm(-2:m+3,-2:n+3,-2:L+3)
	                   
	 REAL(KIND=DP) :: Wp(-2:m+3,-2:n+3,-2:L+3),Wm(-2:m+3,-2:n+3,-2:L+3)
	                   
    REAL(KIND=DP) :: hh(-2:m+3,-2:n+3,-2:L+3)
    REAL(KIND=DP) :: tend1 
    
    INTEGER :: I , J , K
    

       Fhi(1:M,1:N,1:L) = ffhi(1:M,1:N,1:L)

       FI(1:M,1:N,1:L) = Fhi(1:M,1:N,1:L)

 
       call bc3d_BUBBLE(fi,m,n,l) 
 
        
	  

!
!     REDISTANCE STEP --- T=0 TO 2*ALPH
!
!111  SET FI0=FIN1 AT T=0

      DO K=-2,L+3
      DO J=-2,N+3
      DO I=-2,M+3
        FI0(I,J,K)=FI(I,J,K)
        FIN(I,J,K)=FI(I,J,K)
      ENDDO
      ENDDO
      ENDDO
      
    !  WRITE(*,*) FIN(2:2,1:1) ,   FIN(2:2,2:2) 
    !  PAUSE
      

      tend1= 3.0_DP*DX

!     sgnfi0 -- replaced by f
!     hfi -- replaced by fh
!     hpfi -- replaced by dfp
!     agfi -- replaced by dfm
!     a -- replaced by gh
!     b -- replaced by hh
!     c -- replaced by uh

      !write(*,*) "gogo"
      CALL reingp(fin,fi0,fi1,fi2,finp1,f,fh,dfp,dfm,gh,hh,uh,Lfin,Lfi1,Lfi2, &
	             up,um,vp,vm,Wp,Wm,tend1,m,n,L,dx,dy,DZ,imass)

     
     ffhi(1:m,1:n,1:L) = fin(1:m,1:n,1:L)
                
    
	  
  END SUBROUTINE WENO_RK


   subroutine Lphy(Lfi,fh,gh,HH,m,n,L,dx,dy,DZ)
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)  

	  REAL(KIND=DP),INTENT(IN) :: Dx , Dy , DZ
	  INTEGER,INTENT(IN) :: m , n   , L      
	  REAL(KIND=DP) :: Lfi(-2:m+3,-2:n+3,-2:L+3),fh(-2:m+3,-2:n+3,-2:L+3),gh(-2:m+3,-2:n+3,-2:L+3)
	  REAL(KIND=DP) :: hh(-2:m+3,-2:n+3,-2:L+3)
	  
	 
	  
	  INTEGER :: I , J ,  K
	  
	  do K=1,L
	  do j=1,n
    do i=1,m
	    Lfi(i,j,K)=-(fh(i,j,K)-fh(i-1,j,K))/dx - (gh(i,j,K)-gh(i,j-1,K))/dy  - (hh(i,j,K)-hh(i,j,K-1))/dZ 
	  enddo
	  enddo
	  enddo

	 end subroutine Lphy   




!
!    REINGP.FOR BY LIAO, CHING BIAO
!    LEVEL SET FUNCTION reinitialized and mass preserved --- 2004, 03, 30
!    BY 3rd order Runge-Kutta WENO scheme
!
   SUBROUTINE REINGP(fin,fi0,fi1,fi2,finp1,sgnfi0,hfi,hpfi,agfi,a,b,c, &
	                    Lhgn,Lhg1,Lhg2,up,um,vp,vm,Wp,Wm,tstop,m,n,L,dx,dy,dZ,imass)
	                    
	                    
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15) 	 

    REAL(KIND=DP),INTENT(IN) :: Dx , Dy  , DZ, tstop
    INTEGER,INTENT(IN) :: m , n , L , imass
                       
	  REAL(KIND=DP) :: fin(-2:m+3,-2:n+3,-2:L+3),fi1(-2:m+3,-2:n+3,-2:L+3), &
	                   finp1(-2:m+3,-2:n+3,-2:L+3),Lhgn(-2:m+3,-2:n+3,-2:L+3), &
		                 Lhg2(-2:m+3,-2:n+3,-2:L+3),fi2(-2:m+3,-2:n+3,-2:L+3) ,&
	                   sgnfi0(-2:m+3,-2:n+3,-2:L+3),hfi(-2:m+3,-2:n+3,-2:L+3), &
		                 hpfi(-2:m+3,-2:n+3,-2:L+3)
		                 
	  REAL(KIND=DP) :: up(-2:m+3,-2:n+3,-2:L+3),um(-2:m+3,-2:n+3,-2:L+3), &
	                   vp(-2:m+3,-2:n+3,-2:L+3),vm(-2:m+3,-2:n+3,-2:L+3), &
	                   wp(-2:m+3,-2:n+3,-2:L+3),wm(-2:m+3,-2:n+3,-2:L+3), &
	                   a(-2:m+3,-2:n+3,-2:L+3),b(-2:m+3,-2:n+3,-2:L+3), &
	                   c(-2:m+3,-2:n+3,-2:L+3),agfi(-2:m+3,-2:n+3,-2:L+3), &
		                 Lhg1(-2:m+3,-2:n+3,-2:L+3),fi0(-2:m+3,-2:n+3,-2:L+3)
		                 

     
     REAL(KIND=DP) :: Dt , TIMES

     INTEGER :: I , J , K  , ITER

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!                                                     C
!       SOLVE FIt + H^G(U+,U-,V+,V-,W+,W-) =0         C
!       H^G=S(d0)(|Grad(d)|-1)-C*Delta(d)|Grad(d)|    C
!       BY 3ND ORDER Runge-Kutta SCHEME               C
!                                                     C
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      ITER=0
      TIMES=0.0_DP
      
      Dt = 0.5_DP * Dx
      
!
!     give fi0 to calculate sign(fi0)  --- calculate once only
!
      call sgnf(sgnfi0,fi0,m,n,L,dx)
    
      WRITE(*,*) " Redistancing ... "
    DO
       ITER=ITER+1
       TIMES=TIMES+DT
     
     
	     call reinrk3(fin,fi0,fi1,fi2,finp1,sgnfi0,hfi,hpfi,agfi,a,b,c, &
	                Lhgn,Lhg1,Lhg2,up,um,vp,vm,Wp,Wm,m,n,L,dx,dy,DZ,imass,dt)
     
       DO K=-2,L+3
       DO J=-2,N+3
	     DO I=-2,M+3
         FIN(I,J,K)=FINP1(I,J,K)
       ENDDO
       ENDDO
       ENDDO
     
     
       IF(TIMES >= TSTOP) EXIT
    END DO

   END SUBROUTINE REINGP



   subroutine reinrk3(fin,fi0,fi1,fi2,finp1,sgnfi0,hfi,hpfi,agfi,a,b,c, &
	                     Lhgn,Lhg1,Lhg2,up,um,vp,vm,Wp,Wm,m,n,L,dx,dy,DZ,imass,ddt)



!
!     This subroutine reinrk3 is solve FIt + H^G (fi) = 0
!     H^G=S(d0)(|Grad(d)|-1)-C*Delta(d)|Grad(d)|
!     by 3rd order Runge-Kutta method
!     modified by Liao, 2004, 04, 09
!
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15) 

    REAL(KIND=DP),INTENT(IN) :: Dx , Dy  , DZ , ddt


    INTEGER,INTENT(IN) :: m , n , L, imass
    
	  REAL(KIND=DP) :: fin(-2:m+3,-2:n+3,-2:L+3),fi1(-2:m+3,-2:n+3,-2:L+3), &
	                   finp1(-2:m+3,-2:n+3,-2:L+3),Lhgn(-2:m+3,-2:n+3,-2:L+3), &
      		           Lhg2(-2:m+3,-2:n+3,-2:L+3),fi2(-2:m+3,-2:n+3,-2:L+3), &
		                 Lhg1(-2:m+3,-2:n+3,-2:L+3),fi0(-2:m+3,-2:n+3,-2:L+3), &
	                   sgnfi0(-2:m+3,-2:n+3,-2:L+3),hfi(-2:m+3,-2:n+3,-2:L+3), &
		                 hpfi(-2:m+3,-2:n+3,-2:L+3)
	  REAL(KIND=DP) :: up(-2:m+3,-2:n+3,-2:L+3),um(-2:m+3,-2:n+3,-2:L+3), &
	                   vp(-2:m+3,-2:n+3,-2:L+3),vm(-2:m+3,-2:n+3,-2:L+3), &
	                   wp(-2:m+3,-2:n+3,-2:L+3),wm(-2:m+3,-2:n+3,-2:L+3), &
	                   a(-2:m+3,-2:n+3,-2:L+3),b(-2:m+3,-2:n+3,-2:L+3), &
	                   c(-2:m+3,-2:n+3,-2:L+3),agfi(-2:m+3,-2:n+3,-2:L+3)

    INTEGER :: I , J ,  K

    

      call fixpm_3D(fin,up,um,vp,vm,Wp,Wm,m,n,L,Dx,Dy,DZ)

      call hhpf(hfi,hpfi,fin,m,n,L,dx)   !pXH(FHI)   hfi , H'(FHI)   hpfi

!     give fi0, up,um,vp,vm,wp,wm to calculate |grad(fi)|

	    call agradfi_3D(agfi,fi0,UP,UM,VP,VM,WP,WM,M,N,L)

	              
	  if(imass==1) then
!
!     give sgnfi0,hpfi,agfi to calculate c
!
	  call subc(sgnfi0,hpfi,agfi,a,b,c,m,n,L)
	  else
	    c = 0.0_DP
	  endif
!
!     give sgnfi0,hpfi,agfi,c to calculate Lhgn
!
      call reinhg(Lhgn,sgnfi0,hpfi,agfi,c,m,n,L)
!
!     calculate fi1
!
   
    do K=2,L-1
	  do j=2,n-1
	  do i=2,m-1
	    fi1(i,j,K)=fin(i,j,K)-ddt*Lhgn(i,j,K)
	  enddo
	  enddo
	  enddo
	  
	  
	  call bc3d_BUBBLE(fi1,m,n,l) 

 
      


      call fixpm_3D(fi1,up,um,vp,vm,Wp,Wm,m,n,L,Dx,Dy,DZ)

      call hhpf(hfi,hpfi,fi1,m,n,L,dx)

	    call agradfi_3D(agfi,fi0,UP,UM,VP,VM,WP,WM,M,N,L)
	    if(imass==1) then
!
!     give sgnfi0,hpfi,agfi to calculate c
!
	    call subc(sgnfi0,hpfi,agfi,a,b,c,m,N,L)
	    else
	     c = 0.0_DP
	    endif
!
!     give sgnfi0,hpfi,agfi,c to calculate Lhg1
!
      call reinhg(Lhg1,sgnfi0,hpfi,agfi,c,m,n,L)
!
!     calculate fi2
!

     do K=2,L-1
	   do j=2,n-1
	   do i=2,m-1
	     fi2(i,j,K)=fi1(i,j,K)-ddt/4.0_DP*(-3.0_DP*Lhgn(i,j,K)+Lhg1(i,j,K))
	   enddo
	   enddo
	   enddo

     call bc3d_BUBBLE(fi2,m,n,l) 
 
  
!
!     give fi2 to calculate up,um,vp,vm,wp,wm
!
      call fixpm_3D(fi2,up,um,vp,vm,Wp,Wm,m,n,L,Dx,Dy,DZ)
!
!     give fi2 to calculate H(fi) and HP(fi)
!
      call hhpf(hfi,hpfi,fi2,m,n,L,dx)
!
!     give fi0, up,um,vp,vm,wp,wm to calculate |grad(fi)|
!
	  call agradfi_3D(agfi,fi0,UP,UM,VP,VM,WP,WM,M,N,L)
	  if(imass==1) then
!
!     give sgnfi0,hpfi,agfi to calculate c
!
	  call subc(sgnfi0,hpfi,agfi,a,b,c,m,n,L)
	  else
	    c = 0.0_DP
	  endif
!
!     give sgnfi0,hpfi,agfi,c to calculate Lhgn
!
      call reinhg(Lhg2,sgnfi0,hpfi,agfi,c,m,n,L)
!
!     calculate finp1
!
  
    do K=2,L-1
	  do j=2,n-1
	  do i=2,m-1

	    finp1(i,j,K)=fi2(i,j,K) &
		  & -ddt/12.0_DP*(-Lhgn(i,j,K)-Lhg1(i,j,K) + 8.0_DP*Lhg2(i,j,K))
		
		enddo  
	  enddo
	  enddo

     call bc3d_BUBBLE(finp1,m,n,l) 

      
	  end subroutine reinrk3



   subroutine hhpf(hfi,hpfi,fi,m,n,L,dx)
!     hhpf --- to calculate H(fi), HP(fi) for all (i,j,k) --- 2004/03/30
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)

    REAL(KIND=DP),INTENT(IN) :: Dx
    
    INTEGER,INTENT(IN) :: m , n  ,  L
    
	  REAL(KIND=DP) :: fi(-2:m+3,-2:n+3,-2:L+3),hfi(-2:m+3,-2:n+3,-2:L+3), &
                     hpfi(-2:m+3,-2:n+3,-2:L+3)
                     
    INTEGER :: I , J , K

    do K=1,L    
	  do j=1,n    
    do i=1,m
         hfi(i,j,K)=heavy(fi(i,j,K),dx,hpfi(i,j,K))
    enddo
	  enddo
	  enddo

	 end subroutine hhpf



     Subroutine subc(sgnfi0,hpfi,agfi,a,b,c,m,n,L)
!
!     subc --- to calculate c(i,j,k) --- 2004/03/30
!     a(i,j,k)=int [S(d0)(|Grad(d)|-1)*Delta(d)]
!     b(i,j,k)=int [|Grad(d)|*Delta(d)**2]
!     c=a/b
!
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)

	  INTEGER,INTENT(IN) :: m , n , L
    
	  REAL(KIND=DP) :: a(-2:m+3,-2:n+3,-2:L+3),b(-2:m+3,-2:n+3,-2:L+3), &
	                   c(-2:m+3,-2:n+3,-2:L+3),hpfi(-2:m+3,-2:n+3,-2:L+3), &
		                 sgnfi0(-2:m+3,-2:n+3,-2:L+3),agfi(-2:m+3,-2:n+3,-2:L+3)
		                 

	  
	  INTEGER :: I , J , K  
	  
	  REAL(KIND=DP) :: suma , sumb  
	  
	    do K=1,L
      do J=1,N
	    do I=1,M
        a(i,j,K)=(sgnfi0(i,j,K)*hpfi(i,j,K))*(agfi(i,j,K)-1.0_DP)
		    b(i,j,K)=agfi(i,j,K)*hpfi(i,j,K)**2
	    end do
	    end do
	    end do
	    
	    call bc3d(A,m,n,l)
	    call bc3d(B,m,n,l)
	  
	       
	    suma=0.0_dp
	    sumb=0.0_dp
	    
	    do K=2,L-1
	    do J=2,N-1
	    do I=2,M-1
	      suma=suma+a(i,j,K)*dx*dy*DZ
	      sumb=sumb+b(i,j,K)*dx*dy*DZ
	    end do
	    end do
	    end do
	      
	  do K=2,L-1
    Do J=2,N-1
	  Do I=2,M-1
      if(sumb /=0.0_DP ) then
	       c(i,j,K)=suma/sumb
      else
	       c(i,j,K)=0.0_DP
	    endif
   Enddo
	 Enddo
	 Enddo

	End subroutine subc



   subroutine reinhg(Lhg,sgnfi0,hpfi,agfi,c,m,n,L)
    INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)      
    
    INTEGER,INTENT(IN) :: m , n	, L 
	  REAL(KIND=DP) :: agfi(-2:m+3,-2:n+3,-2:L+3), &
		                 hpfi(-2:m+3,-2:n+3,-2:L+3),Lhg(-2:m+3,-2:n+3,-2:L+3), &
		                 sgnfi0(-2:m+3,-2:n+3,-2:L+3),c(-2:m+3,-2:n+3,-2:L+3)
    

    INTEGER :: I , J  , K                
    
    do K=2,L-1
	  do j=2,n-1		                 
    do i=2,m-1
        Lhg(i,j,K)=(sgnfi0(i,j,K)-c(i,j,K)*hpfi(i,j,K))*agfi(i,j,K)-sgnfi0(i,j,K)
    enddo
	  enddo
	  enddo
	  
	end subroutine reinhg 