SUBROUTINE WENO_DROPLET_leo(Nx,Ny,Nz,DX,DY,DZ,DT,PHI,U,V,W,T_Iter)

IMPLICIT NONE
INTEGER,PARAMETER :: DP = SELECTED_REAL_KIND(p=15)
REAL(KIND=DP),PARAMETER :: PI = 3.141592653589793_DP
INTEGER,INTENT(IN) :: Nx, Ny, Nz, T_Iter
INTEGER :: I, J, K
REAL(KIND=DP),INTENT(INOUT) :: PHI(:,:,:)
REAL(KIND=DP),INTENT(IN) :: V(:,:,:), W(:,:,:), U(:,:,:), DX, DY, DZ, DT
REAL(KIND=DP):: PHI_UX(-2:Nx+3,-2:Ny+3,-2:Nz+3), PHI_UY(-2:Nx+3,-2:Ny+3,-2:Nz+3), PHI_UZ(-2:Nx+3,-2:Ny+3,-2:Nz+3)
REAL(KIND=DP):: FIN(-2:Nx+3,-2:Ny+3,-2:Nz+3)

REAL(KIND=DP):: A, AA, AAA, B, BB, BBB, C, CC, CCC, D, DD, DDD
REAL(KIND=DP):: A1, AA1, AAA1, B1, BB1, BBB1, C1, CC1, CCC1, D1, DD1, DDD1
REAL(KIND=DP):: PHI_DN(Nx,Ny,Nz), PHI_D(Nx,Ny,Nz), PHI_DD(Nx,Ny,Nz), PHI_DDD(Nx,Ny,Nz), PHI_DDDD(Nx,Ny,Nz)

 FIN(1:Nx,1:Ny,1:Nz) = PHI(1:Nx,1:Ny,1:Nz)
 CALL BC3D_leo( FIN, Nx, Ny, Nz )

DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
	
  A = 0.5_DP*( FIN(I+3,J,K) - FIN(I+2,J,K) - ABS(FIN(I+3,J,K)) + ABS(FIN(I+2,J,K)))
  B = 0.5_DP*( FIN(I+2,J,K) - FIN(I+1,J,K) - ABS(FIN(I+2,J,K)) + ABS(FIN(I+1,J,K)))
  C = 0.5_DP*( FIN(I+1,J,K) - FIN(I,J,K)   - ABS(FIN(I+1,J,K)) + ABS(FIN(I,J,K)))
  D = 0.5_DP*( FIN(I,J,K)   - FIN(I-1,J,K) - ABS(FIN(I,J,K))   + ABS(FIN(I-1,J,K)))
   
  AA = 0.5_DP*( FIN(I,J+3,K) - FIN(I,J+2,K)- ABS(FIN(I,J+3,K)) + ABS(FIN(I,J+2,K)))
  BB = 0.5_DP*( FIN(I,J+2,K) - FIN(I,J+1,K)- ABS(FIN(I,J+2,K)) + ABS(FIN(I,J+1,K)))
  CC = 0.5_DP*( FIN(I,J+1,K) - FIN(I,J,K)  - ABS(FIN(I,J+1,K)) + ABS(FIN(I,J,K)))
  DD = 0.5_DP*( FIN(I,J,K)   - FIN(I,J-1,K)- ABS(FIN(I,J,K))   + ABS(FIN(I,J-1,K)))
  
  AAA = 0.5_DP*( FIN(I,J,K+3) - FIN(I,J,K+2) - ABS(FIN(I,J,K+3)) + ABS(FIN(I,J,K+2)))
  BBB = 0.5_DP*( FIN(I,J,K+2) - FIN(I,J,K+1) - ABS(FIN(I,J,K+2)) + ABS(FIN(I,J,K+1)))
  CCC = 0.5_DP*( FIN(I,J,K+1) - FIN(I,J,K)   - ABS(FIN(I,J,K+1)) + ABS(FIN(I,J,K)))
  DDD = 0.5_DP*( FIN(I,J,K)   - FIN(I,J,K-1) - ABS(FIN(I,J,K))   + ABS(FIN(I,J,K-1)))
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  A1 = 0.5_DP*( FIN(I-1,J,K) - FIN(I-2,J,K) + ABS(FIN(I-1,J,K)) - ABS(FIN(I-2,J,K)))
  B1 = 0.5_DP*( FIN(I,J,K)   - FIN(I-1,J,K) + ABS(FIN(I,J,K))   - ABS(FIN(I-1,J,K)))
  C1 = 0.5_DP*( FIN(I+1,J,K) - FIN(I,J,K)   + ABS(FIN(I+1,J,K)) - ABS(FIN(I,J,K)))
  D1 = 0.5_DP*( FIN(I+2,J,K) - FIN(I+1,J,K) + ABS(FIN(I+2,J,K)) - ABS(FIN(I+1,J,K)))
  
  AA1 = 0.5_DP*( FIN(I,J-1,K) - FIN(I,J-2,K) + ABS(FIN(I,J-1,K)) - ABS(FIN(I,J-2,K)))
  BB1 = 0.5_DP*( FIN(I,J,K)   - FIN(I,J-1,K) + ABS(FIN(I,J,K))   - ABS(FIN(I,J-1,K)))
  CC1 = 0.5_DP*( FIN(I,J+1,K) - FIN(I,J,K)   + ABS(FIN(I,J+1,K)) - ABS(FIN(I,J,K)))
  DD1 = 0.5_DP*( FIN(I,J+2,K) - FIN(I,J+1,K) + ABS(FIN(I,J+2,K)) - ABS(FIN(I,J+1,K)))
  
  AAA1 = 0.5_DP*( FIN(I,J,K-1) - FIN(I,J,K-2) + ABS(FIN(I,J,K-1)) - ABS(FIN(I,J,K-2)))
  BBB1 = 0.5_DP*( FIN(I,J,K)   - FIN(I,J,K-1) + ABS(FIN(I,J,K))   - ABS(FIN(I,J,K-1)))
  CCC1 = 0.5_DP*( FIN(I,J,K+1) - FIN(I,J,K)   + ABS(FIN(I,J,K+1)) - ABS(FIN(I,J,K)))
  DDD1 = 0.5_DP*( FIN(I,J,K+2) - FIN(I,J,K+1) + ABS(FIN(I,J,K+2)) - ABS(FIN(I,J,K+1)))
  
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	
	
	PHI_UX(I,J,K) = ( -FIN(I-1,J,K) + 7.0_DP*FIN(I,J,K) + 7.0_DP*FIN(I+1,J,K) - FIN(I+2,J,K))/12.0_DP&
	               - F(A1,B1,C1,D1) + F(A,B,C,D)   
	                                            
	PHI_UY(I,J,K) = ( -FIN(I,J-1,K) + 7.0_DP*FIN(I,J,K) + 7.0_DP*FIN(I,J+1,K) - FIN(J+2,J,K))/12.0_DP&
	               - F(AA1,BB1,CC1,DD1) + F(AA,BB,CC,DD) 
	                                     
	PHI_UZ(I,J,K) = ( -FIN(I,J,K-1) + 7.0_DP*FIN(I,J,K) + 7.0_DP*FIN(I,J,K+1) - FIN(I,J,K+2))/12.0_DP&
	               - F(AAA1,BBB1,CCC1,DDD1) + F(AAA,BBB,CCC,DDD)
	

END DO 
END DO
END DO 
 
 CALL BC3D_leo(PHI_UX,NX,NY,NZ)
 CALL BC3D_leo(PHI_UY,NX,NY,NZ)
 CALL BC3D_leo(PHI_UZ,NX,NY,NZ)
 

IF( T_Iter == 1 ) THEN
	PHI_D(1:Nx,1:Ny,1:Nz) = 0.0_DP
	PHI_DD(1:Nx,1:Ny,1:Nz) = 0.0_DP
	PHI_DDD(1:Nx,1:Ny,1:Nz) = 0.0_DP
	PHI_DDDD(1:Nx,1:Ny,1:Nz) = 0.0_DP
END IF

DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
		
PHI_DN(I,J,K) = - U(I,J,K)*( PHI_UX(I,J,K) - PHI_UX(I-1,J,K) ) / DX &
                - V(I,J,K)*( PHI_UY(I,J,K) - PHI_UY(I-1,J,K) ) / DY &
                - W(I,J,K)*( PHI_UZ(I,J,K) - PHI_UZ(I-1,J,K) ) / DZ 
               
END DO
END DO
END DO


PHI_DDDD(1:Nx,1:Ny,1:Nz) = PHI_DDD(1:Nx,1:Ny,1:Nz)
PHI_DDD(1:Nx,1:Ny,1:Nz) = PHI_DD(1:Nx,1:Ny,1:Nz)
PHI_DD(1:Nx,1:Ny,1:Nz) = PHI_D(1:Nx,1:Ny,1:Nz)
PHI_D(1:Nx,1:Ny,1:Nz) = PHI_DN(1:Nx,1:Ny,1:Nz)




DO K = 1, Nz
DO J = 1, Ny
DO I = 1, Nx
	
	IF( T_Iter == 1) THEN
		PHI(I,J,K) = PHI(I,J,K) + PHI_D(I,J,K)*DT
	ELSEIF( T_Iter == 2) THEN
		PHI(I,J,K) = PHI(I,J,K) + ( -3.0_DP*PHI_DD(I,J,K) + PHI_D(I,J,K) )* DT / 4.0_DP	
	ELSE
		PHI(I,J,K) = PHI(I,J,K) + ( -PHI_DDD(I,J,K) - PHI_DD(I,J,K) + 8.0_DP*PHI_D(I,J,K) )*DT/12.0_DP
		
END IF

END DO
END DO
END DO
		
 CALL HYDROPHOBIC_EFFECT(PHI,Nx,Ny,Nz,DX,DY,DZ)

END SUBROUTINE WENO_DROPLET_leo

 !!!!!!!!!!!!!!! 
 
REAL(KIND=DP) FUNCTION F(A,B,C,D)
REAL(KIND=DP) :: A,B,C,D
REAL(KIND=DP) :: IS0, IS1, IS2
REAL(KIND=DP) :: ALPHA0, ALPHA1, ALPHA2, OMEGA0, OMEGA2
REAL(KIND=DP), PARAMETER :: E = 1.0e-6_DP
           
IS0 = 13.0_DP*( A-B )**2 + 3.0_DP*( A - 3.0_Dp*B )**2
IS1 = 13.0_DP*( B-C )**2 + 3.0_DP*( B+C )**2
IS2 = 13.0_DP*( C-D )**2 + 3.0_DP*( 3.0_DP*C - D )**2

ALPHA0 = 1.0_DP /( E + IS0 )**2
ALPHA1 = 1.0_DP /( E + IS1 )**2
ALPHA2 = 1.0_DP /( E + IS2 )**2

OMEGA0 = ALPHA0 / ( ALPHA0 + ALPHA1 + ALPHA2 )
OMEGA2 = ALPHA2 / ( ALPHA0 + ALPHA1 + ALPHA2 )

F = OMEGA0*( A -2.0_DP*B +C )/3.0_DP + ( OMEGA2-0.5_DP )*( B- 2.0_DP*C+ D)/6.0_DP

END FUNCTION F






SUBROUTINE BC3D_leo( U, M, N, P)
INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
INTEGER,INTENT(IN) :: M, N, P
REAL(KIND=DP) :: U(-2:M+3,-2:N+3,-2:P+3)
INTEGER :: I, J, K

DO K = 1, P
DO J = 1, N
	
	U(1,J,K) = 2.0_DP*U(2,J,K) - U(3,J,K)
	U(0,J,K) = 2.0_DP*U(1,J,K) - U(2,J,K)
	U(-1,J,K) = 2.0_DP*U(0,J,K) - U(1,J,K)
	U(-2,J,K) = 2.0_DP*U(-1,J,K) - U(0,J,K)
	
	U(M,J,K) = 2.0_DP*U(M-1,J,K) - U(M-2,J,K)
	U(M+1,J,K) = 2.0_DP*U(M,J,K) - U(M-1,J,K)
	U(M+2,J,K) = 2.0_DP*U(M+1,J,K) - U(M,J,K)
	U(M+3,J,K) = 2.0_DP*U(M+2,J,K) - U(M+1,J,K)
	
	
END DO
END DO


DO J = 1, N
DO I = 1, M
	
 U(I,J,1) = 2.0_DP*U(I,J,2) - U(I,J,3)
 U(I,J,0) = 2.0_DP*U(I,J,1) - U(I,J,2)
 U(I,J,-1) = 2.0_DP*U(I,J,0) - U(I,J,1)
 U(I,J,-2) = 2.0_DP*U(I,J,-1) - U(I,J,0)
	
 U(I,J,P) = 2.0_DP*U(I,J,P-1) - U(I,J,P-2)
 U(I,J,P+1) = 2.0_DP*U(I,J,P) - U(I,J,P-1)
 U(I,J,P+2) = 2.0_DP*U(I,J,P+1) - U(I,J,P)
 U(I,J,P+3) = 2.0_DP*U(I,J,P+2) - U(I,J,P+1)
 
END DO
END DO

DO K = 1, P
DO I = 1, M
	
	U(I,1,K) = 2.0_DP*U(I,2,K) - U(I,3,K)
	U(I,0,K) = 2.0_DP*U(I,1,K) - U(I,2,K)
	U(I,-1,K) = 2.0_DP*U(I,0,K) - U(I,1,K)
	U(I,-2,K) = 2.0_DP*U(I,-1,K) - U(I,0,K)
	
	U(I,N,K) = 2.0_DP*U(I,N-1,K) - U(I,N-2,K)
	U(I,N+1,K) = 2.0_DP*U(I,N,K) - U(I,N-1,K)
	U(I,N+2,K) = 2.0_DP*U(I,N+1,K) - U(I,N,K)
	U(I,N+3,K) = 2.0_DP*U(I,N+2,K) - U(I,N+1,K)
	
END DO
END DO

	
END SUBROUTINE BC3D_leo


SUBROUTINE HYDROPHOBIC_EFFECT(U,M,N,P,DX,DY,DZ)
INTEGER,PARAMETER  :: DP = SELECTED_REAL_KIND(P=15)
INTEGER,INTENT(IN) :: M,N,P
INTEGER ::  I,J,K
REAL(KIND=DP),INTENT(INOUT):: U(:,:,:)
REAL(KIND=DP),INTENT(IN) :: DX,DY,DZ

DO J = 1, N
DO I = 1, M

 IF( U(I,J,1) * U(I+1,J,1) > 0.0_DP )THEN
 	
 IF( U(I,J,1) > 0.0_DP)THEN
 	U(I,J,1) = U(I,J,2) - DZ
 ELSEIF( U(I,J,1) < 0.0_DP ) THEN
 	U(I+1,J,1) = U(I+1,J,2) - DZ
 

 
ENDIF
ENDIF

END DO
END DO
	
END SUBROUTINE HYDROPHOBIC_EFFECT
